// Talariuksen uusien kysymysten luomiseen ja editointiin liittyvt lomake
// avoimille kysymyksille.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 15.2.2006
//

unit AvoinKysymysForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Kysymysluokat, ExtDlgs;

type
  TFormAvoinKysymys = class(TForm)
    ButtonOK: TButton;
    ButtonPeruuta: TButton;
    SpeedButtonLisaaVideo: TSpeedButton;
    SpeedButtonLisaaAani: TSpeedButton;
    SpeedButtonLisaaKuva: TSpeedButton;
    MemoTietoteksti: TMemo;
    LabelAvoinKysymys: TLabel;
    ImageAvoinKysymyskuvaVasen: TImage;
    ImageAvoinKysymyskuvaOikea: TImage;
    SpeedButtonPoistaKuva: TSpeedButton;
    SpeedButtonPoistaAani: TSpeedButton;
    SpeedButtonPoistaVideo: TSpeedButton;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialogVideo: TOpenDialog;
    OpenDialogAani: TOpenDialog;
    PanelOtsikko: TPanel;
    PanelTietoTeksti: TPanel;
    PanelNappulat: TPanel;
    PanelNapitAlusta: TPanel;
    procedure ButtonOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MemoTietotekstiChange(Sender: TObject);
    procedure MemoTietotekstiEnter(Sender: TObject);
    procedure SpeedButtonLisaaKuvaClick(Sender: TObject);
    procedure SpeedButtonPoistaKuvaClick(Sender: TObject);
    procedure SpeedButtonLisaaAaniClick(Sender: TObject);
    procedure SpeedButtonPoistaAaniClick(Sender: TObject);
    procedure SpeedButtonLisaaVideoClick(Sender: TObject);
    procedure SpeedButtonPoistaVideoClick(Sender: TObject);
  private
    FMuokattuSisalto : Boolean;
    FVideonPolku: string;
    FAanenPolku: string;
    FKuvanPolku: string;

  public
    
  published
    property MuokattuSisalto : Boolean read FMuokattuSisalto write FMuokattuSisalto;
    property KuvanPolku : string read FKuvanPolku write FKuvanPolku;
    property AanenPolku : string read FAanenPolku write FAanenPolku;
    property VideonPolku : string read FVideonPolku write FVideonPolku;
  end;

var
  FormAvoinKysymys: TFormAvoinKysymys;

procedure MuokkaaAvoinKysymys(AvoinKysymysRakenne:TAvoinKysymys; OnkoUusiAvoinKysymys:Boolean; var OnkoMuokattu:Boolean);

implementation

uses KysymystenTekoPaaForm;

{$R *.dfm}

procedure MuokkaaAvoinKysymys(AvoinKysymysRakenne:TAvoinKysymys; OnkoUusiAvoinKysymys:Boolean; var OnkoMuokattu:Boolean);
var f: TFormAvoinKysymys;
begin
  // MUISTA alkuun tutkia, onko uusi ruutu vai editoidaanko!!!
  f := TFormAvoinKysymys.Create(nil);
  f.MuokattuSisalto:=true; // Asetetaan trueksi, jotta uuden saa vain listty OK:lla
  if not OnkoUusiAvoinKysymys then begin
    f.MuokattuSisalto:=false; // Editoitavaa ei ole heti muokattu... 
    // Muokataan lomaketta editointiasuun
    f.MemoTietoteksti.Text := AvoinKysymysRakenne.Kysymys;
    f.Caption:='Avoimen kysymyksen muokkaaminen';
    // Sytytetn oikeat napit sen mukaan, onko editoitavaan avoimeen kysymykseen
    // liitetty kuvia, ni tai videota
    if ( AvoinKysymysRakenne.KuvanPolku <> '' ) then begin
      f.SpeedButtonPoistaKuva.Visible:=true;
      f.SpeedButtonLisaaKuva.Visible:=false;
    end;
    if ( AvoinKysymysRakenne.AanenPolku <> '' ) then begin
      f.SpeedButtonPoistaAani.Visible:=true;
      f.SpeedButtonLisaaAani.Visible:=false;
    end;
    if ( AvoinKysymysRakenne.VideonPolku <> '' ) then begin
      f.SpeedButtonPoistaVideo.Visible:=true;
      f.SpeedButtonLisaaVideo.Visible:=false;
    end;
    // Puretaan vanhat polkutiedot
    f.KuvanPolku:=AvoinKysymysRakenne.KuvanPolku;
    f.AanenPolku:=AvoinKysymysRakenne.AanenPolku;
    f.VideonPolku:=AvoinKysymysRakenne.VideonPolku;
  end;
  // Jos painetaan Ok-nappia, tehdn tarvittavat toimenpiteet
  if ( f.ShowModal = mrOK ) then begin
    // kopiodaan olioon tiedot lomakkeelta (memosta)
    if AvoinKysymysRakenne <> nil then begin
      AvoinKysymysRakenne.Kysymys:=f.MemoTietoteksti.Text;
      AvoinKysymysRakenne.KuvanPolku:=f.KuvanPolku;
      AvoinKysymysRakenne.AanenPolku:=f.AanenPolku;
      AvoinKysymysRakenne.VideonPolku:=f.VideonPolku;
    end;  
    // Asetetaan viesti muokatusta tai muokkaamattomasta
    // sisllst KysymystenTekoPaaFormille.
    OnkoMuokattu:=f.MuokattuSisalto;
  end
  // Jos on painettu Cancel-nappia, ilmoitetaan tieto siten
  // ettei muokkausta ole tapahtunut. Tm siksi, ettei
  // KysymystenTekoPaaFormilla aleta kopioimaan tietoja
  // kopio-oliosta oikeaan olioon.
  else OnkoMuokattu:=false;
  f.Free;
end;

procedure TFormAvoinKysymys.ButtonOKClick(Sender: TObject);
begin
  //FormKysymystenTekeminen.ListBoxKysymyslista.Items.Add(EditAvoinKysymysTeksti.Text);
end;

procedure TFormAvoinKysymys.FormCreate(Sender: TObject);
begin
  MuokattuSisalto:=false;
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);
end;

procedure TFormAvoinKysymys.MemoTietotekstiChange(Sender: TObject);
begin
  // Muokattaessa asetetaan muokkausta kuvaava muuttuja oikeaan arvoonsa
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.MemoTietotekstiEnter(Sender: TObject);
begin
  // Valitaan kaikki olemassaoleva teksti
  MemoTietoteksti.SelectAll;
end;

procedure TFormAvoinKysymys.SpeedButtonLisaaKuvaClick(Sender: TObject);
begin
  if not OpenPictureDialog.Execute then exit;
  KuvanPolku := OpenPictureDialog.FileName;
  SpeedButtonLisaaKuva.Visible:=false;
  SpeedButtonPoistaKuva.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.SpeedButtonPoistaKuvaClick(Sender: TObject);
begin
  KuvanPolku:='';
  SpeedButtonPoistaKuva.Visible:=false;
  SpeedButtonLisaaKuva.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.SpeedButtonLisaaAaniClick(Sender: TObject);
begin
  if not OpenDialogAani.Execute then exit;
  AanenPolku := OpenDialogAani.FileName;
  SpeedButtonLisaaAani.Visible:=false;
  SpeedButtonPoistaAani.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.SpeedButtonPoistaAaniClick(Sender: TObject);
begin
  AanenPolku:='';
  SpeedButtonPoistaAani.Visible:=false;
  SpeedButtonLisaaAani.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.SpeedButtonLisaaVideoClick(Sender: TObject);
begin
  if not OpenDialogVideo.Execute then exit;
  VideonPolku := OpenDialogVideo.FileName;
  SpeedButtonLisaaVideo.Visible:=false;
  SpeedButtonPoistaVideo.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormAvoinKysymys.SpeedButtonPoistaVideoClick(Sender: TObject);
begin
  VideonPolku:='';
  SpeedButtonPoistaVideo.Visible:=false;
  SpeedButtonLisaaVideo.Visible:=true;
  MuokattuSisalto:=true;
end;

end.
