{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

ChatIkkuna - TFormChat: Chatikkuna, sen pivitykseen ja viestien lhetykseen
tarvittavat toiminnot.
}
unit ChatIkkuna;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Paketit, ScktComp;

type
  TFormChat = class(TForm)
    MemoChat: TMemo;
    EditChat: TEdit;
    MemoChatKayttajat: TMemo;
    ButtonChatLaheta: TButton;
    LabelViestit: TLabel;
    LabelChattaajat: TLabel;
    LabelKirjoita: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ButtonChatLahetaClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EditChatKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    Socketti: TClientSocket;
    function EtsiNimi(Nimi: String): Integer;
  public
    procedure Liittyi(Nimi: String);
    procedure Poistui(Nimi: String);
    procedure Alusta(EriSocketti: TClientSocket);
    procedure Vastaanota(Viesti: String);
    procedure VastaanotaKayttajalista(Kayttajat: TStringList);
    procedure Synkronoi(Chat: TFormChat);
  end;

const MaxViesteja: Integer = 50;

var
  FormChat: TFormChat;

implementation

{$R *.dfm}


//Lis annetun viestin listaan
procedure TFormChat.Vastaanota(Viesti: String);

begin

  if (MemoChat.Lines.Count > MaxViesteja) then
    MemoChat.Lines.Delete(0);

  MemoChat.Lines.Add(Viesti);
end;

//tyhjent kyttjlistan ja laittaa uuden sen tilalle
procedure TFormChat.VastaanotaKayttajalista(Kayttajat: TStringList);
var Apu: Integer;
begin
  MemoChatKayttajat.Lines.Clear;
  for Apu := 0 to Kayttajat.Count - 1 do
  begin
    MemoChatKayttajat.Lines.Add(Kayttajat[Apu]);
  end;
  MemoChatKayttajat.Invalidate;
end;

//lis kyttjn listaan
procedure TFormChat.Liittyi(Nimi: String);
begin
  MemoChatKayttajat.Lines.Add(Nimi);
  MemoChatKayttajat.Invalidate;
end;

//poistaa kyttjn listasta
procedure TFormChat.Poistui(Nimi: String);
var I: Integer;
begin
  I := EtsiNimi(Nimi);
  if (I < 0) then exit;
  MemoChatKayttajat.Lines.Delete(I);
  MemoChatKayttajat.Invalidate;
end;

//etsii annetun nimen vastaavan indeksin kyttjlistasta ja palauttaa sen
function TFormChat.EtsiNimi(Nimi: String): Integer;
var I: Integer;
begin
  Result := -1;
  for I := 0 to MemoChatKayttajat.Lines.Count-1 do
  begin
    if (Nimi = MemoChatKayttajat.Lines[I]) then Result := I;
  end;
end;

//sijoitetaan chatikkuna luonnissa oikeaan alanurkkaan
procedure TFormChat.FormCreate(Sender: TObject);
begin
  EditChat.MaxLength := ChatViestiMaksimipituus;
  EditChat.Text := '';
  Left := Screen.Width-Width;
  Top := Screen.Height-Height-30; //30 on Windowsin alapalkin oletuskorkeus
end;

//lhett viestin kulloinkin asetettuun sockettiin, jos sellainen on asetettu
procedure TFormChat.ButtonChatLahetaClick(Sender: TObject);
var Lahetys: TChatViesti; Viesti: String;
begin
  if EditChat.Text = '' then
    Exit;
  Viesti := EditChat.Text;
  //PutsaaViesti(Viesti);
  Lahetys := TChatViesti.Create(Viesti, True);
  if Assigned(Socketti) then
    Socketti.Socket.SendText(Lahetys.PalautaPaketti);
  FreeAndNil(Lahetys);
  EditChat.Text := '';
end;

//ottaa uuden socketin (eli minne lhetetn) talteen
procedure TFormChat.Alusta(EriSocketti: TClientSocket);
begin
  Socketti := EriSocketti;
end;

//alunperin tarkoitettu synkronoimaan annettu chatikkuna omilla viesteill. Ei kytss.
procedure TFormChat.Synkronoi(Chat: TFormChat);
begin
  Chat.MemoChat.Lines.AddStrings(MemoChat.Lines);
end;

//Varmistetaan ettei kukaan vahingossa sulje ikkunaa
procedure TFormChat.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
end;

//Kun painetaan EditChatiss enteri, lhetetn viesti.
procedure TFormChat.EditChatKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
    ButtonChatLaheta.Click;
end;

end.

