{
// Formi tuottamaan ilmoituksia Talariuksesta. Kytetn esimerkiksi
// uuden heittovuoron saamiseen jne.
//
// Tekijt:
//   Heikki Nevala
//
// Luotu: 15.2.2006
// Muokattu: 15.2.2006

ALEA PROJEKTI

Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)

viimeksi muokattu: 23.5.2006

listty suuren ilmoituksen nyttmisen mahdollisuus ja toipuminen kuvien
lataamisessa tulleista virheist. Formi mys sulkee itsens automaattisesti
}
unit IlmoitusForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TFormIlmoitus = class(TForm)
    ButtonOK: TButton;
    LabelViesti: TLabel;
    ImageKuvaEka: TImage;
    ImageKuvaToka: TImage;
    LabelPelaaja: TLabel;
    TimerSulkija: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure TimerSulkijaTimer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const OdotusAika = 3000; //kauan pidetn ilmoituksia nkyviss

var
  FormIlmoitus: TFormIlmoitus;

Function NaytaIlmoitus(nimi:string; ilmoitus:string; kuva:TBitmap): TFormIlmoitus; overload;
Function NaytaIlmoitus(nimi:string; ilmoitus:string; kuva:TBitmap; suuri: boolean): TFormIlmoitus; overload;

implementation

{$R *.dfm}

function NaytaIlmoitus(nimi:string; ilmoitus:string; kuva:TBitmap): TFormIlmoitus;
begin
  Result := NaytaIlmoitus(nimi, ilmoitus, kuva, False);
end;

function NaytaIlmoitus(nimi:string; ilmoitus:string; kuva:TBitmap; suuri:boolean): TFormIlmoitus;
var
  f : TFormIlmoitus;
begin
  f:=TFormIlmoitus.Create(nil);
  //Odotusajan asetus
  f.TimerSulkija.Interval := Odotusaika;
  // Kuvat kohdalleen...
  try
    f.ImageKuvaEka.Picture.Bitmap:=kuva;
    f.ImageKuvaEka.Width:=f.ImageKuvaEka.Picture.Bitmap.Width;
    f.ImageKuvaEka.Height:=f.ImageKuvaEka.Picture.Bitmap.Height;
    f.ImageKuvaEka.Canvas.Draw(0,0,kuva);
    f.ImageKuvaToka.Picture.Bitmap:=kuva;
    f.ImageKuvaToka.Width:=f.ImageKuvaEka.Picture.Bitmap.Width;
    f.ImageKuvaToka.Height:=f.ImageKuvaEka.Picture.Bitmap.Height;
    f.ImageKuvaToka.Canvas.Draw(0,0,kuva);
  except
    //ShowMessage('Ongelma kuvien lataamisessa');
  end;
  // Nimi paikoilleen
  if nimi='' then f.LabelPelaaja.Visible:=false
  else begin
    f.LabelPelaaja.Caption:=nimi;
    f.LabelPelaaja.Left:=(f.ClientWidth div 2)-(f.LabelPelaaja.Width div 2);
  end;
  // Ilmoitus paikoilleen
  if ilmoitus='' then f.LabelViesti.Visible:=false
  else begin
    f.LabelViesti.Caption:=ilmoitus;
    f.LabelViesti.Left:=(f.ClientWidth div 2)-(f.LabelViesti.Width div 2);
  end;
  if suuri then begin
    f.Height := f.Height + 300;
    f.ButtonOK.Top := f.ButtonOK.Top + 300;
  end;
  f.ShowModal; //showmodal
  Result := f;
  f.Free;
end;

procedure TFormIlmoitus.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
  ButtonOK.Left:=(ClientWidth div 2)-(ButtonOK.Width div 2)
end;

procedure TFormIlmoitus.ButtonOKClick(Sender: TObject);
begin
  Close;
end;

procedure TFormIlmoitus.TimerSulkijaTimer(Sender: TObject);
begin
  Close;
end;

end.
