{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

TFormKirjautuminen kytetn kirjautumiseen metapalvelimelle.
Avaa TFormTilinLuonti jos luodaan uusi tili tai TFormMetaOppilaanKayttoliittyma
jos kirjaudutaan sislle. 
}
unit KirjautuminenForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ScktComp, Paketit, md5, IlmoitusForm,
  TilinLuontiForm;

type
  TFormKirjautuminen = class(TForm)
    LabeledEditTunnus: TLabeledEdit;
    LabeledEditSalasana: TLabeledEdit;
    BitBtnKirjaudu: TBitBtn;
    BitBtnUusiTili: TBitBtn;
    BitBtnPeruuta: TBitBtn;
    procedure BitBtnKirjauduClick(Sender: TObject);
    procedure BitBtnUusiTiliClick(Sender: TObject);
    procedure BitBtnPeruutaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    Meta: TClientSocket;
    ImageSuru: TImage;
    ImageHymy: TImage;
    Sulje: Boolean; //Tosi jos saa sulkea
    procedure AnnaPaketti(Socket: TCustomWinSocket);

  public
    Nimi: String;
    function AnnaTunnus: String;
    function AnnaSalasana: String;
    procedure AsetaMetaSocket(Meta: TClientSocket);
    procedure Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
    procedure AsetaSuru(Suru: TImage);
    procedure ClientSocketRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AsetaHymy(Hymy: TImage);
  end;

var
  FormKirjautuminen: TFormKirjautuminen;

implementation

{$R *.dfm}

{ TFormKirjautuminen }

//palauttaa salasanan md5 koodattuna stringin
function TFormKirjautuminen.AnnaSalasana: String;
begin
  Result := MD5Print(MD5String(LabeledEditSalasana.Text));
end;

//palauttaa pelaajan tunnuksen
function TFormKirjautuminen.AnnaTunnus: String;
begin
  Result := LabeledEditTunnus.Text;
end;

//asettaa metapalvelimen socketin kirjautumisen kyttn
procedure TFormKirjautuminen.AsetaMetaSocket(Meta: TClientSocket);
begin
  Self.Meta := Meta;
end;

//lhett kirjautumis tiedot metapalvelimelle (ei sulje formia)
procedure TFormKirjautuminen.BitBtnKirjauduClick(Sender: TObject);
begin
  Laheta(TKirjautuminen.Create(LabeledEditTunnus.Text, MD5String(LabeledEditSalasana.Text)), Meta.Socket);
end;

//lhett paketin sockettiin
procedure TFormKirjautuminen.Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
begin
  try
    Socket.SendText(Paketti.PalautaPaketti);
  finally
    FreeAndNil(Paketti)
  end;
end;

//passaa paketin ksittelijlle
procedure TFormKirjautuminen.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  AnnaPaketti(Socket);
end;

//Lukee socketista paketit talteen ja ksittelee ne.
procedure TFormKirjautuminen.AnnaPaketti(Socket: TCustomWinSocket);
var PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
    Kirjautunut: TKirjautunut;
begin
  XMLPaketti := Socket.ReceiveText;
  if XMLPaketti = '' then begin
    exit;
  end;

  XMLPakettiLista := PilkoXML(XMLPaketti);

  for I := XMLPakettiLista.Count-1 downto 0 do
  begin
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    case PaketinTyyppi of
     KirjautunutTyyppi:
     begin
       Kirjautunut := TKirjautunut.Create(XMLPaketti);
       if not (Kirjautunut.Hyvaksytty)  then
         NaytaIlmoitus('Virhe!','Salasana tai kyttjtunnus on vr!',ImageSuru.Picture.Bitmap)
       else
       begin //kirjautuminen onnistunut, suljetaan formi.
         Nimi := Kirjautunut.PelaajanNimi;
         Sulje := True;
         ModalResult := mrOk;
         //exit;
       end;
     end;
    end;
  end;
end;

//otetaan surukuva talteen
procedure TFormKirjautuminen.AsetaSuru(Suru: TImage);
begin
  ImageSuru := Suru;
end;

//otetaan hymykuva talteen
procedure TFormKirjautuminen.AsetaHymy(Hymy: TImage);
begin
  ImageHymy := Hymy;
end;

//Avataan uuden tilin luonti ja nytetn ilmoitus jos tili luotiin.
procedure TFormKirjautuminen.BitBtnUusiTiliClick(Sender: TObject);
var FormTili: TFormTilinLuonti;
begin
  FormTili := TFormTilinLuonti.Create(self);
  FormTili.AsetaMetaSocket(Meta.Socket);
  FormTili.AsetaSuru(ImageSuru);
  Meta.OnRead := FormTili.ClientSocketRead;
  if (FormTili.ShowModal = mrOk) then   NaytaIlmoitus('Huomio!','Tili luotu!',ImageHymy.Picture.Bitmap);
  FormTili.Free;
  Meta.OnRead := ClientSocketRead;
end;

//Sulkee yhteyden metapalvelimelle ja sulkee formin
procedure TFormKirjautuminen.BitBtnPeruutaClick(Sender: TObject);
begin
  Meta.Close;
  Sulje := True;
end;

procedure TFormKirjautuminen.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  Meta.Close; //katkoo yhteyden vrss paikassa
end;

//Varmistetaan ett formin voi sulkea vain oikein.
procedure TFormKirjautuminen.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := False;
  if Sulje then CanClose := True;
end;

//keskitetn ikkuna luonnissa ja varmistetaan ettei kukaan sulje sit vrin
procedure TFormKirjautuminen.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
  Sulje := False;
end;

end.
