//
// Talariuksen plomake kysymyssarjojen tekemiseen. Kysymyksi on tavallaan
// kolmea tyyppi: monivalintakysymys, avoin kysymys sek tietoruutu. Nist
// kuitenkin tietoruutu on lhinn vain informaatiota varten, ilman
// varsinaista vastausmahdollisuutta. Kysymyksiin on mahdollista liitt
// erilaisia medioita kuten kuvia, nt tai videota (kuitenkin siten, ett
// yhteen kysymykseen on mahdollista liitt vain yksi kutakin lajia).
//
// Toteutuksessa kysymyksist nytettv visuaalinen informaatio on erotettu
// varsinaisesta kovalevylle talletettavasta informaatiosta.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 16.2.2006
//

unit KysymystenTekoPaaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, Menus, StdCtrls, ComCtrls, dbcgrids, Grids,
  Contnrs,JPEG,strUtils;

type
  TFormKysymystenTekeminen = class(TForm)
    SpeedButtonTietoruutu: TSpeedButton;
    SpeedButtonAvoinKysymys: TSpeedButton;
    SpeedButtonMonivalinta: TSpeedButton;
    PanelKysymystenAlusta: TPanel;
    MainMenu: TMainMenu;
    MenuTiedosto: TMenuItem;
    MenuLopeta: TMenuItem;
    MenuAvaaKysymyssarja: TMenuItem;
    MenuTallennanimellaKysymyssarja: TMenuItem;
    MenuTallennaKysymyssarja: TMenuItem;
    MenuUusiKysymyssarja: TMenuItem;
    PanelKaikenAlusta: TPanel;
    PanelKysymyslistaAlusta: TPanel;
    PanelNappulatAlusta: TPanel;
    ListBoxKysymyslista: TListBox;
    SaveDialog: TSaveDialog;
    OpenDialogAvaaKysymyssarja: TOpenDialog;
    PanelTyokaluPalkki: TPanel;
    BitBtnUusi: TBitBtn;
    BitBtnAvaa: TBitBtn;
    BitBtnTallenna: TBitBtn;
    Ohje1: TMenuItem;
    Ohjeettulossa1: TMenuItem;
    PanelInfo: TPanel;
    LabelInfoTehtavatyyppi: TLabel;
    LabelInfoLiitetytMediat: TLabel;
    BitBtnJarjesta: TBitBtn;
    BevelErotin: TBevel;
    BitBtnEsikatselu: TBitBtn;
    BitBtnPoista: TBitBtn;
    Bevel1: TBevel;
    Esikatselevalittuakysymyst1: TMenuItem;
    Poistavalittukysymys1: TMenuItem;
    Jrjesttehtvtyypinmukaan1: TMenuItem;
    procedure SpeedButtonTietoruutuClick(Sender: TObject);
    procedure SpeedButtonPoistaKysymysClick(Sender: TObject);
    procedure SpeedButtonAvoinKysymysClick(Sender: TObject);
    procedure SpeedButtonMonivalintaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBoxKysymyslistaDblClick(Sender: TObject);
    procedure ListBoxKysymyslistaKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure MenuTallennanimellaKysymyssarjaClick(Sender: TObject);
    procedure MenuAvaaKysymyssarjaClick(Sender: TObject);
    procedure MenuLopetaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TietojaohjelmastaValintaClick(Sender: TObject);
    procedure MenuUusiKysymyssarjaClick(Sender: TObject);
    procedure MenuTallennaKysymyssarjaClick(Sender: TObject);
    procedure SpeedButtonEsikatseluClick(Sender: TObject);
    procedure BitBtnJarjestaClick(Sender: TObject);
  private
    KysymystenDataLista : TObjectList; // Tnne varastoidaan varsinaiset kysymysoliot
                                       // ja kysymysten data. Kyttjlle listassa
                                       // nykvt tiedot ovat vain visuaalista dataa.
    OnkoKysymyssarjaaMuutettu: Boolean;
    KysymyssarjanNimi: TFileName;


    procedure PaivitaLista;
    procedure PoistaKysymys;
    procedure ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi, Paate: String);
  public

  end;


var
  FormKysymystenTekeminen: TFormKysymystenTekeminen;

implementation

uses TietoruutuForm, AvoinKysymysForm, MoniValintaKysymysForm, KysymysLuokat,
     IniFiles, PelinPelaaminenTietoruutuForm,
     PelinPelaaminenMonivalintakysymysForm, PelinPelaaminenAvoinKysymysForm;

{$R *.dfm}

procedure TFormKysymystenTekeminen.PaivitaLista;
var
  i, j, pituus, kuvalaskuri: integer;
  lisattava, apu : string;
  MV : TMonivalintaKysymys;
begin
  // Pivitetn kysymykset sisltvt graafinen lista
  ListBoxKysymyslista.Clear; // Tyhjennetn lista
  // Aletaan tutkimaan kysymykset sisltv tietorakennetta ja
  // parsitaan sielt tarvittavat tiedot listaan (kysymys-osio tai
  // tietoruudun teksti).
  for i:=0 to KysymystenDataLista.Count-1 do begin
    // Aloitetaan tietoruuduista
    if KysymystenDataLista[i] is TTietoruutu then begin
      apu:=TTietoruutu(KysymystenDataLista[i]).TietoTeksti;

      // Korvataan rivinvaihto vlilynnill
      apu := StringReplace(apu,#13#10,' ',[rfReplaceAll]);
      apu := Trim(apu);

      // Nytetn listassa kuitenkin vain 40 ensimmist merkki tekstist
      if (length(apu) > 40) then begin
        apu:=Copy(apu,1,40);
        apu:=apu+'...';
      end;
      lisattava:='(T): "' + apu;
    end
    // Tehdn mys monivalintakysymyksille (tm tytyy olla ensin, koska
    // luokka peritn avoimesta kysymyksest, ja jos avoin kysymys olisi ensin,
    // ksitettisiin mys monivalintakysymyskin tss tapauksessa avoimeksi
    // kysymykseksi).
    else if KysymystenDataLista[i] is TMonivalintaKysymys then begin
      apu:=TMonivalintaKysymys(KysymystenDataLista[i]).Kysymys;

      // Korvataan rivinvaihto vlilynnill
      apu := StringReplace(apu,#13#10,' ',[rfReplaceAll]);
      apu := Trim(apu);

      if (length(apu) > 40) then begin
        apu:=Copy(apu,1,40);
        apu:=apu+'...';
      end;
      lisattava:='(M): "' + apu;
    end
    // Tehdn sama avoimille kysymyksille
    else if KysymystenDataLista[i] is TAvoinKysymys then begin
      apu:=TAvoinKysymys(KysymystenDataLista[i]).Kysymys;

      // Korvataan rivinvaihto vlilynnill
      apu := StringReplace(apu,#13#10,' ',[rfReplaceAll]);
      apu := Trim(apu);

      if (length(apu) > 40) then begin
        apu:=Copy(apu,1,40);
        apu:=apu+'...';
      end;
      lisattava:='(A): "' + apu;
    end;

    lisattava:=lisattava+'" ';
    // Listn tarvittava mr tyhj, ett <Kuva>, <ni> ja <Video> tulevat
    // aina samalle kohdalle

    // Luodaan tyhj maski, joka sislt enemmn tyhji merkkej kuin on
    // mahdollista olla nytettvss tekstiss
    apu:='                                                                                ';
    // Kopioidaan tyhj sisltvst jonosta tarpeeksi tyhji merkkej, ett
    // Kuva jne. otsakkeet tulevat oikealle kohdalle
    pituus := 51{=maksimipituus + listyt merkit alusta ja lopusta}-length(lisattava);
    lisattava:=lisattava+Copy(apu,1,pituus);

    // Jos ksiteltv kysymys sattuukin olemaan monivalinta, niin kydn
    // lpi sen vastausvaihtoehdot ja nihin mahdollisesti liitetyt kuvat.
    // Tm tehdn sit varten, ett kyttjlle voidaan ilmoittaa kysymyksen
    // yhteyteen liitetyn kuvia (siis mys muitakin kuin vain kysymyskuva).
    Kuvalaskuri:=0;
    if KysymystenDataLista[i] is TMonivalintaKysymys then begin
      MV:=TMonivalintaKysymys(KysymystenDataLista[i]);
      for j:=0 to MV.VastauksenKuvapolku.Count-1 do begin
        if MV.VastauksenKuvapolku[j]<>'' then begin
          kuvalaskuri:=kuvalaskuri+1;
          break;
        end;
      end;
    end;
    // Konvertoidaan kysymyskannaksi ja selvitetn onko liitetty objekteja
    if ((TKysymyskanta(KysymystenDataLista[i]).KuvanPolku <> '')or(Kuvalaskuri>0)) then
      lisattava:=lisattava + '<Kuva>' else lisattava:=lisattava + '<    >';
    if (TKysymyskanta(KysymystenDataLista[i]).AanenPolku <> '') then
      lisattava:=lisattava + '<ni>' else lisattava:=lisattava + '<    >';
    if (TKysymyskanta(KysymystenDataLista[i]).VideonPolku <> '') then
      lisattava:=lisattava + '<Video>' else lisattava:=lisattava + '<     >';
    // Lopuksi listn listaan
    ListBoxKysymyslista.Items.Add(lisattava);
  end;
end;

procedure TFormKysymystenTekeminen.PoistaKysymys;
var
  Poistoindeksi : integer;
begin
  if ( MessageDlg('Haluatko varmasti poistaa kysymyksen?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
    exit;
  end;
  
  // Jos jokin listan alkio on valittuna, poistetaan se
  if ListBoxKysymyslista.ItemIndex <> -1 then begin
    Poistoindeksi:=ListBoxKysymyslista.ItemIndex; // poistettavan ideksi talteen
    // Poistetaan valittu kysymyslistan alkio graafisesta listasta
    ListBoxKysymyslista.Items.Delete(Poistoindeksi);
    // Poistetaan valittua kysymyslistan alkiota vastaava tieto mys
    // varsinaisesta tietorakenteesta (Helpin mukaan objectListin pitisi
    // tuhota mys listaan talletetulle oliolle varattu muisti...
    KysymystenDataLista.Delete(Poistoindeksi);
    // Kysymys poistettu
    OnkoKysymyssarjaaMuutettu := true;
  end;
end;

procedure TFormKysymystenTekeminen.ErotaPolkuNimiJaPaate(s: String; var Polku,
  Nimi, Paate: String);
var
  IndexNimi: Integer;
  IndexPaate: Integer;
begin
  IndexNimi := LastDelimiter('/\', s);
  IndexPaate := LastDelimiter('.', s);

  // Jos kyttj ei kirjoita nimelleen ptett, listn
  // se itse. Tm siksi, koska halutaan vltt
  if IndexPaate <= 0 then
    IndexPaate:=Length(s) + 1; // +1 johtunee "pisteest tiedoston ptteess"

  // Otetaan talteen polku ilman tiedoston nime
  Polku := Copy(s, 1, IndexNimi);

  // Otetaan talteen tiedoston nimi polusta
  Nimi := Copy(s, IndexNimi+1, ((Length(s)-IndexNimi) - (Length(s)-IndexPaate+1)));

  // Otetaan talteen tiedoston pte polusta
  Paate := Copy(s, IndexPaate, Length(s)-IndexNimi)
end;

procedure TFormKysymystenTekeminen.SpeedButtonTietoruutuClick(
  Sender: TObject);
var
  UusiTietoruutu : TTietoruutu;
  MuokattuTietoruutua : Boolean;
begin
  // Luodaan uusi tietoruutu
  UusiTietoruutu:=TTietoruutu.Create;
  MuokkaaTietoruutu(UusiTietoruutu, true{=on uusi tietoruutu}, MuokattuTietoruutua);
  if not MuokattuTietoruutua then exit; // Kyttj painoi cancelia tai ei muokannut ollenkaan uutta ruutua...
  KysymystenDataLista.Add(UusiTietoruutu);
  PaivitaLista;
  // Kysymys listty
  OnkoKysymyssarjaaMuutettu := true;
end;

procedure TFormKysymystenTekeminen.SpeedButtonPoistaKysymysClick(
  Sender: TObject);
begin
  PoistaKysymys();
end;

procedure TFormKysymystenTekeminen.SpeedButtonAvoinKysymysClick(
  Sender: TObject);
var
  UusiAvoinKysymys : TAvoinKysymys;
  MuokattuAvointaKysymysta : Boolean;
begin
  // Luodaan uusi avoin kysymys
  UusiAvoinKysymys:=TAvoinKysymys.Create;
  MuokkaaAvoinKysymys(UusiAvoinKysymys, true{=on uusi tietoruutu}, MuokattuAvointaKysymysta);
  if not MuokattuAvointaKysymysta then exit; // Kyttj painoi cancelia tai ei muokannut ollenkaan uutta avointa kysymyst...
  KysymystenDataLista.Add(UusiAvoinKysymys);
  PaivitaLista;
  // Kysymys listty
  OnkoKysymyssarjaaMuutettu := true;
end;


procedure TFormKysymystenTekeminen.SpeedButtonMonivalintaClick(
  Sender: TObject);
var
  UusiMonivalintakysymys : TMonivalintaKysymys;
  MuokattuMonivalintaKysymysta : Boolean;

begin
  //PaivitaLista;
  UusiMonivalintakysymys:=TMonivalintaKysymys.Create;
  MuokkaaMonivalintakysymys(UusiMonivalintaKysymys, true{=on uusi tietoruutu}, MuokattuMonivalintakysymysta);
  if not MuokattuMonivalintakysymysta then exit; // Kyttj painoi cancelia tai ei muokannut ollenkaan uutta monivalintakysymyst...
  KysymystenDataLista.Add(UusiMonivalintakysymys);
  PaivitaLista;
  // Kysymys listty
  OnkoKysymyssarjaaMuutettu := true;
end;

procedure TFormKysymystenTekeminen.FormCreate(Sender: TObject);
begin
  KysymystenDataLista := TObjectList.Create;
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);

  OnkoKysymyssarjaaMuutettu := false; // Kysymyssarjaa ei ole viel muutettu
  KysymyssarjanNimi := ''; // Kysymyssarjalle ei ole annettu viel nime
end;


procedure TFormKysymystenTekeminen.FormDestroy(Sender: TObject);

begin
  // Tuhotaan lista. Listan pitisi itse vapauttaa sinne tallennettujen
  // objektien varaama muisti.
  KysymystenDataLista.Free;
end;

procedure TFormKysymystenTekeminen.ListBoxKysymyslistaDblClick(
  Sender: TObject);
var
  KopioTietoruutu: TTietoruutu;
  KopioAvoinKysymys: TAvoinKysymys;
  KopioMonivalintakysymys : TMonivalintaKysymys;
  Index: Integer;
  OnkoMuokattu: Boolean;
begin
  Index := ListBoxKysymyslista.ItemIndex;
  OnkoMuokattu := false;

  // Tutkitaan, mit tyyppi editoitava kysymys on...

  // Tietoruutu
  if ( KysymystenDataLista[Index] is TTietoruutu ) then begin
    KopioTietoruutu := TTietoruutu(KysymystenDataLista[Index]).Copy();
    MuokkaaTietoruutu(KopioTietoruutu, false{=vanha tietoruutu}, OnkoMuokattu);
    if not OnkoMuokattu then exit; // Kyttj ei muokannut kysymyst
    KysymystenDataLista.Delete(Index);
    KysymystenDataLista.Insert(Index, KopioTietoruutu);
  end

  // Monivalintakysymys
  else if ( KysymystenDataLista[Index] is TMonivalintaKysymys ) then begin
    KopioMonivalintaKysymys := TMonivalintaKysymys(KysymystenDataLista[Index]).Copy();
    MuokkaaMonivalintaKysymys(KopioMonivalintaKysymys, false{=vanha tietoruutu}, OnkoMuokattu);
    if not OnkoMuokattu then exit; // Kyttj ei muokannut kysymyst
    KysymystenDataLista.Delete(Index);
    KysymystenDataLista.Insert(Index, KopioMonivalintaKysymys);
  end

  // avoin kysymys
  else if ( KysymystenDataLista[Index] is TAvoinKysymys ) then begin
    KopioAvoinKysymys := TAvoinKysymys(KysymystenDataLista[Index]).Copy();
    MuokkaaAvoinKysymys(KopioAvoinKysymys, false{=vanha tietoruutu}, OnkoMuokattu);
    if not OnkoMuokattu then exit; // Kyttj ei muokannut kysymyst
    KysymystenDataLista.Delete(Index);
    KysymystenDataLista.Insert(Index, KopioAvoinKysymys);
  end;

  // Onko kysymyssarjaa muokattu
  OnkoKysymyssarjaaMuutettu := OnkoMuokattu;

  PaivitaLista;
end;

procedure TFormKysymystenTekeminen.ListBoxKysymyslistaKeyDown(
  Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if ( Key = vk_Delete ) then begin
    PoistaKysymys();
  end;
end;

procedure TFormKysymystenTekeminen.MenuTallennanimellaKysymyssarjaClick(
  Sender: TObject);
begin
  // Avataan oletuksena kansio, josta ohjelma suoritetaan
  SaveDialog.InitialDir := ExtractFilePath(application.ExeName);

  if SaveDialog.Execute then begin
    KysymyssarjanNimi := SaveDialog.FileName;

   // Tutkitaan, lytyyk kysymyssarjan nimest pte .ini.kys, jos ei lydy
   // niin listn se sinne itse. Ilman tt tallentamiseen tulee ongelmia
   // ainakin sellaisissa kansionimiss, joissa on piste.
   if ( AnsiRightStr(KysymyssarjanNimi,4) <> '.kys' ) then begin
      Insert('.kys', KysymyssarjanNimi, Length(KysymyssarjanNimi)+1);
    end;

    // Jos vanha tiedosto on jo olemassa
    if ( FileExists(KysymyssarjanNimi) ) then begin
      if ( MessageDlg('Kysymyssarja "' + KysymyssarjanNimi + '" on jo olemassa. Haluatko korvata tmn kysymyssarjan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
        exit;
      end;
    end;

    // Kysymyssarjalla on nyt nimi, voidaan tallentaa
    MenuTallennaKysymyssarjaClick(Sender);
  end;
end;

procedure TFormKysymystenTekeminen.MenuAvaaKysymyssarjaClick(Sender: TObject);
var
  IniFile: TIniFile;
  i,j: Integer;
  TiedostonNimi: TFileName;
  KysymysObjekti: String;
  KysymystenLkm: Integer;
  VaariaVastauksia, VastauskuvienLkm: Integer;
  VaaraVastaus: String;
  Tyyppi: String;
  Tietoteksti: String;
  Kysymys: String;
  OikeaVastaus: String;
  KuvanPolku: String;
  AanenPolku: String;
  VideonPolku: String;
  VKPolku : string;
  UusiTietoRuutu: TTietoruutu;
  UusiMonivalintaKysymys: TMonivalintaKysymys;
  UusiAvoinKysymys : TAvoinKysymys;
  KysPolku, KysNimi, KysPaate : string;
begin
  // Jos kyttj painaa dialogin cancel-nappulaa, poistutaan
  if not OpenDialogAvaaKysymyssarja.Execute then exit;

  KysymystenDataLista.Clear;

  TiedostonNimi := OpenDialogAvaaKysymyssarja.FileName;
  KysymyssarjanNimi := TiedostonNimi;
  ErotaPolkuNimiJaPaate(KysymyssarjanNimi,KysPolku, KysNimi, KysPaate);

  // Aletaan lukemaan varsinaista tekstitietoa ini-tiedostosta
  IniFile := TInifile.Create(TiedostonNimi);
  try
    KysymystenLkm := IniFile.ReadInteger('Kysymyksia', 'Lkm', 0);

    for i:=0 to KysymystenLkm-1 do begin
      // Pivitetn kysymyksen ilmaisevaa kohtaa ini-tiedostossa
      KysymysObjekti := 'Kysymys ' + intToStr(i+1);
      Tyyppi := IniFile.ReadString(KysymysObjekti,'Tyyppi','');

      if Tyyppi = 'Tietoruutu' then begin
        Tietoteksti := IniFile.ReadString(KysymysObjekti,'Tietoteksti','');

        // Korvataan |-merkit rivinvaihdolla
        Tietoteksti := StringReplace(TietoTeksti,'|',#13#10,[rfReplaceAll]);

        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysPolku+VideonPolku;

        // Luodaan uusi tietoruutu
        UusiTietoruutu := TTietoruutu.Create;
        UusiTietoruutu.TietoTeksti := Tietoteksti;
        UusiTietoruutu.KuvanPolku := KuvanPolku;
        UusiTietoruutu.AanenPolku := AanenPolku;
        UusiTietoruutu.VideonPolku := VideonPolku;
        KysymystenDataLista.Add(UusiTietoruutu);
        PaivitaLista;
      end

      else if Tyyppi = 'Monivalinta' then begin
        // Luodaan uusi tietoruutu
        UusiMonivalintaKysymys := TMonivalintaKysymys.Create;

        Kysymys := IniFile.ReadString(KysymysObjekti,'Kysymys','');
        OikeaVastaus := IniFile.ReadString(KysymysObjekti,'Oikea vastaus','');

        UusiMonivalintaKysymys.Kysymys := Kysymys;
        UusiMonivalintaKysymys.OikeaVastaus := OikeaVastaus;

        VaariaVastauksia := IniFile.ReadInteger(KysymysObjekti,'Vrien vastausten lkm',0);

        for j:=0 to VaariaVastauksia-1 do begin
          VaaraVastaus := IniFile.ReadString(KysymysObjekti,'Vr vastaus ' + IntToStr(j+1),'');
          UusiMonivalintaKysymys.VaaratVastaukset.Add(VaaraVastaus);
        end;
        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysPolku+VideonPolku;

        UusiMonivalintaKysymys.KuvanPolku := KuvanPolku;
        UusiMonivalintaKysymys.AanenPolku := AanenPolku;
        UusiMonivalintaKysymys.VideonPolku := VideonPolku;

        VastauskuvienLkm:=IniFile.ReadInteger(KysymysObjekti,'Vastauskuvien lkm',0);
        for j:=0 to VastauskuvienLkm-1 do begin
          VKPolku:=IniFile.ReadString(Kysymysobjekti,'Vastauskuva ' + IntToStr(j+1),'');
          if VKPolku<>'' then VKPolku:=KysPolku+VKPolku; // Tsskin polku absoluuttiseksi
          UusiMonivalintaKysymys.VastauksenKuvapolku.Add(VKPolku);
        end;

        KysymystenDataLista.Add(UusiMonivalintaKysymys);
        PaivitaLista;
      end

      else if Tyyppi = 'AvoinKysymys' then begin
        Kysymys := IniFile.ReadString(KysymysObjekti,'Kysymys',''{});

        // Korvataan |-merkit rivinvaihdolla
        Kysymys := StringReplace(Kysymys,'|',#13#10,[rfReplaceAll]);

        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysPolku+VideonPolku;

        // Luodaan uusi avoin kysymys
        UusiAvoinKysymys := TAvoinKysymys.Create;
        UusiAvoinKysymys.Kysymys := Kysymys;
        UusiAvoinKysymys.KuvanPolku := KuvanPolku;
        UusiAvoinKysymys.AanenPolku := AanenPolku;
        UusiAvoinKysymys.VideonPolku := VideonPolku;
        KysymystenDataLista.Add(UusiAvoinKysymys);
        PaivitaLista;
      end;
    end;
  finally
    IniFile.Free;
  end;

  // Tiedosto avattu, eik muutoksia tehty sen jlkeen
  OnkoKysymyssarjaaMuutettu := false;
end;

procedure TFormKysymystenTekeminen.MenuLopetaClick(Sender: TObject);
begin
  Close; //  Ohjautuu FormCloseen
end;

procedure TFormKysymystenTekeminen.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Arvo: Integer;
begin
  // Jos ohjelmaa ollaan lopettamassa eik muutoksia ole tallennettu, kysytn vahvistus
  if ( OnkoKysymyssarjaaMuutettu ) then begin
    Arvo := MessageDlg('Haluatko tallentaa kysymyssarjan?', mtConfirmation, [mbYes, mbNo, mbCancel], 0);
    if ( Arvo = mrNo ) then
      Action := caFree
    else if ( Arvo = mrYes ) then begin
      MenuTallennaKysymyssarjaClick(Sender);
      // jos kyttj ei tallentanut, ei poistuta ohjelmasta
      if ( OnkoKysymyssarjaaMuutettu ) then Action := caNone;
    end
    else if ( Arvo = mrCancel ) then
      Action := caNone;
  end;
end;

procedure TFormKysymystenTekeminen.TietojaohjelmastaValintaClick(
  Sender: TObject);
begin
  // Tietoja ohjelmasta -dialogia ei ole viel toteutettu
end;

procedure TFormKysymystenTekeminen.MenuUusiKysymyssarjaClick(Sender: TObject);
begin
  // Jos kysymyssarjaa on muutettu eik sit ole viel tallennettu, varmistetaan kyttjlt jatkotoimet
  if OnkoKysymyssarjaaMuutettu then begin
    if ( MessageDlg('Nykyiseen kysymyssarjaan tehtyj muutoksia ei ole viel tallennettu. Haluatko varmasti avata uuden kysymyssarjan?', mtWarning, [mbYes, mbNo], 0) = mrNo ) then begin
      exit;
    end;
  end;

  KysymystenDataLista.Clear;
  PaivitaLista;
  // Uusi tiedosto avattu, eik muutoksia tehty sen jlkeen
  OnkoKysymyssarjaaMuutettu := false;
  KysymyssarjanNimi := '';
end;

procedure TFormKysymystenTekeminen.MenuTallennaKysymyssarjaClick(
  Sender: TObject);
var
  TiedostonNimi: String;
  TiedostonPolku: String;
  TiedostonPaate: String;
  i, j: Integer;
  k: TKysymyskanta;
  Polku, Nimi, Paate: String;
  IniFile : TIniFile;
  AvoinKysymys: TAvoinkysymys;
  MonivalintaKysymys, MV : TMonivalintaKysymys;
  Tietoruutu : TTietoruutu;
  Kysymys : String;
begin
  // Jos kysymyssarjalla ei ole viel nime, avataan Save as... -dialogi
  if KysymyssarjanNimi = '' then MenuTallennanimellaKysymyssarjaClick(Sender)

  // Kysymyssarjalla on nimi, voidaan tallentaa
  else begin

    // Jos kysymyssarjaan ei ole tehty muutoksia, lhdetn pois!
    if not OnkoKysymyssarjaaMuutettu then exit;

    // Tutkitaan, lytyyk kysymyssarjan nimest pte .kys, jos ei lydy
    // niin listn se sinne itse. Ilman tt tallentamiseen tulee ongelmia
    // ainakin sellaisissa kansionimiss, joissa on piste.
    //s:='';
    //if Length(KysymyssarjanNimi)>=4 then
    //  s := Copy(KysymyssarjanNimi, Length(KysymyssarjanNimi)-3, 4); // mahdollinen pte talteen
    //if s <> '.kys' then KysymyssarjanNimi:=KysymyssarjanNimi+'.kys';


    ErotaPolkuNimiJaPaate(KysymyssarjanNimi, TiedostonPolku, TiedostonNimi, TiedostonPaate);

    if TiedostonNimi = '' then begin
      MessageDlg('VIRHE TALLENNUKSESSA: kysymyssarjalta puuttuu nimi! Kysymyssarjalla on oltava nimi tallennettaessa. YRIT UUDELLEEN, ja kirjoita kysymyssarjalle jokin nimi.',mtError	,[mbOK],0);
      exit;
    end;

    // Luodaan kansio, jonne kopioidaan kysymyksiin liitetyt tiedostot
    if not DirectoryExists(TiedostonPolku + TiedostonNimi) then
      if not CreateDir(TiedostonPolku + TiedostonNimi) then begin
        MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda kansiota "' + TiedostonPolku + TiedostonNimi + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + TiedostonPolku + '".',mtError	,[mbOK],0);
        exit;
      end;

    // Kydn lpi kaikki kysymykset ja niihin tallenntetut mediat. Tmn
    // jlkeen kopioidaan tiedostot oikeaan paikkaan. Ja jos on olemassa
    // saman niminen tiedosto, niin kirjoitetaan plle.
    for i := 0 to KysymystenDataLista.Count-1 do begin
      if KysymystenDataLista[i] is TKysymyskanta then begin
        k := TKysymyskanta(KysymystenDataLista[i]);

        ErotaPolkuNimiJaPaate(k.KuvanPolku, Polku, Nimi, Paate);

        // Tarkistetaan onko kysymyssarjalle asetettu kuvaa
        // (ja ettei yritet kopioida itsens plle kysymyssarjan mediahakemistossa)
        if ( (k.KuvanPolku <> '') and (k.KuvanPolku <> (TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate)) ) then begin
          // Yritetn kopioida kysymystietorakenteen viitaama kuva
          if not CopyFile(PAnsiChar(k.KuvanPolku), PAnsiChar(TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate), false) then begin
            MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda tiedostoa "' + TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + TiedostonPolku + TiedostonNimi + '" ja ett kopioitava tiedosto "' + k.KuvanPolku + '" lytyy.', mtError, [mbOK], 0);
            exit;
          end;
        end;
        // Pivitetn oikea polku kysymystietorakenteeseen. Polut ovat
        // oletuksena absoluuttisia, sen takia ne pit muuttaa
        // ei-absoluuttisiksi tallennusta varten --> saavutetaan parempi
        // siirrettvyys. Tt ei voi tehd edellisen if:n sisll, koska
        // muuten polut jisivt absoluuttisiksi tallennuksessa ainakin
        // joissakin tapauksissa (kun ladataan kysymyssarja ja tallennetaan,
        // oltaisiin tallentamassa itsens plle, eli if: ei suoriteta, mist
        // seuraisi, ett polkukin jisi absoluuttiseksi, jos se siis olisi
        // if:n sisll, mik aiheuttaisi taas muuta vikaa).
        if k.kuvanPolku <> '' then
          k.KuvanPolku := {TiedostonPolku + }TiedostonNimi + '\' + Nimi + Paate;


        ErotaPolkuNimiJaPaate(k.AanenPolku, Polku, Nimi, Paate);

        // Tarkistetaan onko kysymyssarjalle asetettu nt
        if ( (k.AanenPolku <> '') and (k.AanenPolku <> (TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate)) ) then begin
          // Yritetn kopioida kysymystietorakenteen viitaama kuva
          if not CopyFile(PAnsiChar(k.AanenPolku), PAnsiChar(TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate), false) then begin
            MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda tiedostoa "' + TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + TiedostonPolku + TiedostonNimi + '" ja ett kopioitava tiedosto "' + k.AanenPolku + '" lytyy.', mtError, [mbOK], 0);
            exit;
          end;
        end;
        // Pivitetn oikea polku kysymystietorakenteeseen
        if k.AanenPolku <> '' then
          k.AanenPolku :={ TiedostonPolku + }TiedostonNimi + '\' + Nimi + Paate;


        ErotaPolkuNimiJaPaate(k.VideonPolku, Polku, Nimi, Paate);

        // Tarkistetaan onko kysymyssarjalle asetettu videota
        if ( (k.VideonPolku <> '') and (k.VideonPolku <> (TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate)) ) then begin
          // Yritetn kopioida kysymystietorakenteen viitaama kuva
          if not CopyFile(PAnsiChar(k.VideonPolku), PAnsiChar(TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate), false) then begin
            MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda tiedostoa "' + TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + TiedostonPolku + TiedostonNimi + '" ja ett kopioitava tiedosto "' + k.VideonPolku + '" lytyy.', mtError, [mbOK], 0);
            exit;
          end;
        end;
        // Pivitetn oikea polku kysymystietorakenteeseen
        if k.videonPolku <> '' then
          k.VideonPolku :={ TiedostonPolku + }TiedostonNimi + '\' + Nimi + Paate;
      end;

      // Mys monivalintakysymyksen vastausvaihtoehtoihin on mahdollista
      // liitt kuvia. Kopioidaan siis nekin kysymyssarjojen yhteyteen.
      if KysymystenDataLista[i] is TMonivalintaKysymys then begin
        MV:=TMonivalintaKysymys(KysymystenDataLista[i]);

        for j:=0 to MV.VastauksenKuvapolku.Count-1 do begin
          ErotaPolkuNimiJaPaate(MV.VastauksenKuvapolku[j], Polku, Nimi, Paate);
          if ( (MV.VastauksenKuvapolku[j] <> '') and (MV.VastauksenKuvapolku[j] <> (TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate)) ) then begin
            // Yritetn kopioida kysymystietorakenteen viitaama kuva
            if not CopyFile(PAnsiChar(MV.VastauksenKuvapolku[j]), PAnsiChar(TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate), false) then begin
              MessageDlg('VIRHE TALLENNUKSESSA: ei voida luoda tiedostoa "' + TiedostonPolku + TiedostonNimi + '\' + Nimi + Paate + '"! Varmista, ett sinulla on kirjoitusoikeudet hakemistoon "' + TiedostonPolku + TiedostonNimi + '" ja ett kopioitava tiedosto "' + MV.VastauksenKuvapolku[j] + '" lytyy.', mtError, [mbOK], 0);
              exit;
            end;
          end;
          // Pivitetn oikea polku kysymystietorakenteeseen
          if MV.vastauksenKuvapolku[j] <> '' then
            MV.VastauksenKuvapolku[j] := {TiedostonPolku + }TiedostonNimi + '\' + Nimi + Paate;
        end; // for j
      end;   // if (is)
    end;     // for i

    // INI-tallennus -OSUUS
    // Jos vanha tiedosto on olemassa, poistetaan se
    if FileExists(TiedostonPolku + TiedostonNimi + '.kys') then begin
      DeleteFile(TiedostonPolku + TiedostonNimi + '.kys');
    end;

    // Aletaan tallentamaan varsinaista tekstitietoa ini-tiedostoon
    IniFile := TInifile.Create(TiedostonPolku + TiedostonNimi + '.kys');
    try
      for i:=0 to KysymystenDataLista.Count - 1 do begin
        IniFile.WriteInteger('Kysymyksia', 'Lkm', i+1);

        // Pivitetn kysymyksen ilmaisevaa kohtaa ini-tiedostossa
        Kysymys:='Kysymys ' + intToStr(i+1);
        if KysymystenDataLista[i] is TTietoruutu then begin
          Tietoruutu:=TTietoruutu(KysymystenDataLista[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Kysymys,'Tyyppi','Tietoruutu');
          IniFile.WriteString(Kysymys,'Tietoteksti',StringReplace(Tietoruutu.TietoTeksti,#13#10,'|',[rfReplaceAll]));
          IniFile.WriteString(Kysymys,'Kuva',Tietoruutu.KuvanPolku);
          IniFile.WriteString(Kysymys,'ni',Tietoruutu.AanenPolku);
          IniFile.WriteString(Kysymys,'Video',Tietoruutu.VideonPolku);
          // Muokataan polut takaisin absoluuttisiksi, sill oletuksena
          // polkuja ksitelln tss aina absoluuttisina. Ja siis
          // median polku on tss vaiheessa muotoa:
          // "kysymyssarjanNimi\medianNimi.pte"
          if Tietoruutu.KuvanPolku <> '' then
            Tietoruutu.KuvanPolku:=TiedostonPolku+Tietoruutu.KuvanPolku;
          if Tietoruutu.AanenPolku <> '' then
            Tietoruutu.AanenPolku:=TiedostonPolku+Tietoruutu.AanenPolku;
          if Tietoruutu.VideonPolku <> '' then
            Tietoruutu.VideonPolku:=TiedostonPolku+Tietoruutu.VideonPolku;
        end else
        if KysymystenDataLista[i] is TMonivalintaKysymys then begin
          MonivalintaKysymys:=TMonivalintaKysymys(KysymystenDataLista[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Kysymys,'Tyyppi','Monivalinta');
          IniFile.WriteString(Kysymys,'Kysymys',MonivalintaKysymys.Kysymys);
          IniFile.WriteString(Kysymys,'Oikea vastaus',MonivalintaKysymys.OikeaVastaus);
          IniFile.WriteInteger(Kysymys,'Vrien vastausten lkm',MonivalintaKysymys.VaaratVastaukset.Count);
          for j:=0 to MonivalintaKysymys.VaaratVastaukset.Count-1 do begin
            IniFile.WriteString(Kysymys,'Vr vastaus ' + IntToStr(j+1),MonivalintaKysymys.VaaratVastaukset[j]);
          end;
          IniFile.WriteString(Kysymys,'Kuva',MonivalintaKysymys.KuvanPolku);
          IniFile.WriteString(Kysymys,'ni',MonivalintaKysymys.AanenPolku);
          IniFile.WriteString(Kysymys,'Video',MonivalintaKysymys.VideonPolku);
          // Muokataan polut takaisin absoluuttisiksi, sill oletuksena
          // polkuja ksitelln tss aina absoluuttisina
          if MonivalintaKysymys.KuvanPolku <> '' then
            MonivalintaKysymys.KuvanPolku:=TiedostonPolku+MonivalintaKysymys.KuvanPolku;
          if MonivalintaKysymys.AanenPolku <> '' then
            MonivalintaKysymys.AanenPolku:=TiedostonPolku+MonivalintaKysymys.AanenPolku;
          if MonivalintaKysymys.VideonPolku <> '' then
            MonivalintaKysymys.VideonPolku:=TiedostonPolku+MonivalintaKysymys.VideonPolku;
          IniFile.WriteInteger(Kysymys,'Vastauskuvien lkm',MonivalintaKysymys.VastauksenKuvapolku.Count);
          for j:=0 to MonivalintaKysymys.VastauksenKuvapolku.Count-1 do begin
            IniFile.WriteString(Kysymys,'Vastauskuva ' + IntToStr(j+1),MonivalintaKysymys.VastauksenKuvapolku[j]);
            // Muokataan kysymyksen vastaukseen liitetyn kuvan polku
            // takaisin absoluuttiseksi...
            if MonivalintaKysymys.VastauksenKuvapolku[j] <> '' then
              MonivalintaKysymys.VastauksenKuvapolku[j]:=TiedostonPolku+MonivalintaKysymys.VastauksenKuvapolku[j];
          end;

        end else
        if KysymystenDataLista[i] is TAvoinKysymys then begin
          AvoinKysymys:=TAvoinkysymys(KysymystenDataLista[i]);
          // Aluksi kirjoitetaan kysymyksen tyyppi
          IniFile.WriteString(Kysymys,'Tyyppi','AvoinKysymys');
          IniFile.WriteString(Kysymys,'Kysymys',StringReplace(AvoinKysymys.Kysymys,#13#10,'|',[rfReplaceAll]));
          IniFile.WriteString(Kysymys,'Kuva',AvoinKysymys.KuvanPolku);
          IniFile.WriteString(Kysymys,'ni',AvoinKysymys.AanenPolku);
          IniFile.WriteString(Kysymys,'Video',AvoinKysymys.VideonPolku);
          // Muokataan polut takaisin absoluuttisiksi, sill oletuksena
          // polkuja ksitelln tss aina absoluuttisina
          if AvoinKysymys.KuvanPolku <> '' then
            AvoinKysymys.KuvanPolku:=TiedostonPolku+AvoinKysymys.KuvanPolku;
          if AvoinKysymys.AanenPolku <> '' then
            AvoinKysymys.AanenPolku:=TiedostonPolku+AvoinKysymys.AanenPolku;
          if AvoinKysymys.VideonPolku <> '' then
            AvoinKysymys.VideonPolku:=TiedostonPolku+AvoinKysymys.VideonPolku;
        end;
      end;
    finally
      IniFile.Free;
    end;

    // Tiedosto tallennettu, eik muutoksia tehty sen jlkeen
    OnkoKysymyssarjaaMuutettu := false;
  end;
end;

procedure TFormKysymystenTekeminen.SpeedButtonEsikatseluClick(
  Sender: TObject);
var
  t : TFormPelitietoruutu;
  a : TFormPeliavoinKysymys;
  m : TFormPeliMonivalintakysymys;
  index : integer;
  Tietoruutu : TTietoruutu;
  Monivalinta : TMonivalintakysymys;
  Avoin : TAvoinkysymys;

begin
  index:=ListBoxkysymyslista.ItemIndex;
  // Jos ei ole valintaa, niin lhdetn pois
  if index < 0 then exit;

  // Esikatsellaan...
  if (KysymystenDataLista[index] is TTietoruutu) then begin
    Tietoruutu:=TTietoruutu(KysymystenDataLista[index]).Copy; //Varmuuden vuoksi kopio-olio
    t:=TFormPeliTietoruutu.Create(nil);
    t.PuraTiedotLomakkeelle(Tietoruutu);
    t.ShowModal;
    t.Free;
    Tietoruutu.Free;
    exit;
  end;
  if (KysymystenDataLista[index] is TMonivalintaKysymys) then begin
    Monivalinta:=TMonivalintakysymys(KysymystenDataLista[index]).Copy;
    m:=TFormPeliMonivalintaKysymys.Create(nil);
    m.PuraTiedotLomakkeelle(Monivalinta);
    //m.PuraTiedotLomakkeelle(TMonivalintakysymys(KysymystenDataLista[index]));
    m.ShowModal;
    m.Free;
    Monivalinta.Free;
    exit;
  end;
  if (KysymystenDataLista[index] is TAvoinkysymys) then begin
    Avoin:=TAvoinkysymys(KysymystenDataLista[index]).Copy;
    a:=TFormPeliAvoinKysymys.Create(nil);
    a.PuraTiedotLomakkeelle(Avoin);
    a.ShowModal;
    a.free;
    Avoin.Free;
    exit;
  end;

end;

procedure TFormKysymystenTekeminen.BitBtnJarjestaClick(Sender: TObject);
var
  i : integer;
begin
  // Tietoruudut listan krkeen
  for i:=0 to KysymystenDataLista.Count-1 do begin
     if (KysymystenDataLista[i] is TTietoruutu) then begin
       KysymystenDataLista.Move(i,0);
       ListBoxKysymyslista.Items.Move(i,0);
     end;
  end;
  // Sitten avoimet kysymykset
  for i:=0 to KysymystenDataLista.Count-1 do begin
     if ((KysymystenDataLista[i] is TAvoinKysymys)and
         (not(KysymystenDataLista[i] is TMonivalintaKysymys))) then begin
       KysymystenDataLista.Move(i,0);
       ListBoxKysymyslista.Items.Move(i,0);
     end;
  end;

  // Siirretn monivalinnat krkeen
  for i:=0 to KysymystenDataLista.Count-1 do begin
     if (KysymystenDataLista[i] is TMonivalintaKysymys) then begin
       KysymystenDataLista.Move(i,0);
       ListBoxKysymyslista.Items.Move(i,0);
     end;
  end;
  // Lopuksi knnetn lista haluttuun jrjestykseen...
  for i:=0 to KysymystenDataLista.Count-1 do begin
     KysymystenDataLista.Move(KysymystenDataLista.Count-1,i);
     ListBoxKysymyslista.Items.Move(ListBoxKysymyslista.Items.Count-1,i);
  end;
end;

end.
