{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006
}
unit LuoOpettajatiliForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  //opettajatilien luontilomake
  TFormLuoOpettajatili = class(TForm)
    LabeledEditTunnus: TLabeledEdit;
    ButtonLuo: TButton;
    ButtonPeruuta: TButton;
    LabeledEditSalasana: TLabeledEdit;
    LabeledEditSalasanaUudestaan: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure ButtonLuoClick(Sender: TObject);
    procedure ButtonPeruutaClick(Sender: TObject);
  private
    function PalautaTunnus: String;
    function PalautaSalasana: String;
    function PalautaSalasanaUudestaan: String;
    { Private declarations }
  public
    { Public declarations }
    property Tunnus: String read PalautaTunnus;
    property Salasana: String read PalautaSalasana;
    property SalasanaUudestaan: String read PalautaSalasanaUudestaan;
  end;

implementation

{$R *.dfm}

uses Paketit;

{ TFormLuoOpettajatili }

//palautetaan LabeledEditSalasanan teksti
function TFormLuoOpettajatili.PalautaSalasana: String;
begin
  Result := Trim(LabeledEditSalasana.Text);
end;

//palautetaan LabeledEditTunnuksen teksti
function TFormLuoOpettajatili.PalautaTunnus: String;
begin
  Result := Trim(LabeledEditTunnus.Text);
end;

//palautetaan LabeledEditSalasanaUudestaan teksti
function TFormLuoOpettajatili.PalautaSalasanaUudestaan: String;
begin
  Result := Trim(LabeledEditSalasanaUudestaan.Text);
end;

//alustetaan lomake
procedure TFormLuoOpettajatili.FormCreate(Sender: TObject);
begin
  LabeledEditTunnus.Text := '';
  LabeledEditTunnus.MaxLength := KayttajatunnuksenMaksimipituus;

  LabeledEditSalasana.Text := '';
  LabeledEditSalasana.MaxLength := SalasananMaksimipituus;
end;

//Tarkistetaan, ett annetut arvot ovat oikeelliset.
//Jos arvot ovat oikeelliset ilmoitetaan tunnuksen luonnista.
procedure TFormLuoOpettajatili.ButtonLuoClick(Sender: TObject);
begin
  if(Salasana <> SalasanaUudestaan) then
  begin
    MessageDlg('Salasana ja salasana uudestaan eivt ole samat!', mtWarning, [mbOk], 0);
    Exit;
  end;

  if(Length(Salasana) < SalasananMinimipituus) then
  begin
    MessageDlg('Opettajatilin salasana on liian lyhyt!', mtWarning, [mbOk], 0);
    Exit;
  end;

  if(Length(Tunnus) < KayttajatunnuksenMinimipituus) then
  begin
    MessageDlg('Opettajatilin tunnus on liian lyhyt!', mtWarning, [mbOk], 0);
    Exit;
  end;

  ModalResult := mrOK;
end;

//perutetaan opettajatilin luonti
procedure TFormLuoOpettajatili.ButtonPeruutaClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
