{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

TFormLuoPeli kytetn uusien pelien luomiseen.
Vasemmalla: Kysymyssarjojen valinnan ja lismisen toiminnot
Keskell: Valitut kysymyssarjat ja niiden poistaminen
Oikealla: Pelilaudan valinta
Alhaalla: Yleiset asetukset

Siirtyy OdotushuoneForm jos luodaan peli tai edelliseen tilaan (verkossa
TFormMetaOppilaanLiittyma, verkotta TFormVerkkovalinta.
}
unit LuoPeliForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Contnrs, IniFiles, md5, Objekti, OdotushuoneForm, Pelilogiikka,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, IdFTP;

type
  TFormLuoPeli = class(TForm)
    BitBtnLuoPeli: TBitBtn;
    BitBtnPeruuta: TBitBtn;
    OpenDialogLataaPelilauta: TOpenDialog;
    LabelVaikeustaso: TLabel;
    LabelAihealue: TLabel;
    BitBtnValitseKysymyssarja: TBitBtn;
    EditKysymyssarja: TEdit;
    LabelValitseKysymyssarjaPalvelimelta: TLabel;
    ListBoxValitseKysymyssarjaPalvelimelta: TListBox;
    GroupBoxPelilauta: TGroupBox;
    BitBtnValitseLauta: TBitBtn;
    EditPelilauta: TEdit;
    LabelValitseLautaPalvelimelta: TLabel;
    ListBoxValitseLautaPalvelimelta: TListBox;
    GroupBoxKysymyssarjat: TGroupBox;
    OpenDialogLataaKysymyssarja: TOpenDialog;
    ButtonLisaa: TButton;
    ListBoxValitutKysymyssarjat: TListBox;
    LabelValitutKysymyssarjat: TLabel;
    ButtonPoista: TButton;
    ComboBoxKysymysJarjestys: TComboBox;
    ComboBoxLautaJarjestys: TComboBox;
    LabeledEditPelinNimi: TLabeledEdit;
    RadioGroupPelaajia: TRadioGroup;
    LabeledEditSalasana: TLabeledEdit;
    CheckBoxSalasana: TCheckBox;
    CheckBoxArvosana: TCheckBox;
    GroupBoxMuut: TGroupBox;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    LabelLaudanAihealue: TLabel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    IdFTPTiedostoPalvelin: TIdFTP;
    procedure BitBtnValitseLautaClick(Sender: TObject);
    procedure BitBtnValitseKysymyssarjaClick(Sender: TObject);
    procedure ButtonLisaaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonPoistaClick(Sender: TObject);
    procedure ListBoxValitseKysymyssarjaPalvelimeltaClick(Sender: TObject);
    procedure ListBoxValitseLautaPalvelimeltaClick(Sender: TObject);
    procedure LabeledEditSalasanaChange(Sender: TObject);
  private
    Kysymyssarjat: TStringList;
    Pelilauta: String;
    PelilaudanKysymyssarja: String;
    PelinHakemisto: String;
    Pelaajia: Integer;
    Luoja: THahmo;
    Verkossa: Boolean;

    {procedure LataaPelilaudanKysymyssarja;}
  public
    Salasana: String;
    procedure AlustaPelilogiikka(Pelilogiikka: TPelilogiikka);
    procedure AsetaPelinLuoja(Luoja: THahmo);
    procedure AlustaFTP(Tunnus: String; Salasana: String; Osoite: String; Portti: Integer);
  end;

  procedure ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi,
    Paate: String);

const PelilautaPolku = 'Pelilaudat\';
const KysymyssarjaPolku = 'Kysymyssarjat\';
const PlaPaate = '.pla';
const KysPaate = '.kys';

implementation

uses Paketit;

{$R *.dfm}

{ TFormLuoPeli }

{
Avataan pelin valitseminen omalta koneelta ja laitetaan valittu pelilauta talteen
ja nytlle. Lisksi laitetaan pelin luontinappi kyttn mikli kysymyssarjoja
on valittu.
}
procedure TFormLuoPeli.BitBtnValitseLautaClick(Sender: TObject);
var Polku, Nimi, Paate: String;
begin
  OpenDialogLataaPelilauta.FileName := '';
  // Avataan oletuksena kansio, josta ohjelma suoritetaan
  OpenDialogLataaPelilauta.InitialDir := ExtractFilePath(application.ExeName)+PelilautaPolku;//formcreate:ssa
  if not OpenDialogLataaPelilauta.Execute then exit;
  ErotaPolkuNimiJaPaate(OpenDialogLataaPelilauta.FileName, Polku, Nimi, Paate);
  EditPelilauta.Text := Nimi;
  Pelilauta := Nimi;
  {LataaPelilaudanKysymyssarja;}
  if not (Pelilauta = '') and (ListBoxValitutKysymyssarjat.Count > 0) then BitBtnLuoPeli.Enabled := True;
end;

{
//Avaa pelilaudan, katsoo mik kysymyssarja siihen on liitetty ja lis sen listaan
procedure TFormLuoPeli.LataaPelilaudanKysymyssarja;
var IniFile: TIniFile;
begin
  if ((Pelilauta = nil) or Pelilauta.Palvelimelta) then exit;
  // luodaan ini-tiedosto
  IniFile := TInifile.Create(Pelilauta.Nimi);
  try
    // Luetaan kysymyssarjan polku
    PelilaudanKysymyssarja := IniFile.ReadString('Kysymyssarja', 'Polku', '');
    if PelilaudanKysymyssarja <> '' then PelilaudanKysymyssarja := ExtractFilePath(application.ExeName)+KysymyssarjaPolku+PelilaudanKysymyssarja;
    ButtonLisaaClick(self);
  finally
    IniFile.Free;
  end;
end;
}

{
Avaa kysymyssarjan valitsemisen omalta koneelta ja laittaa valitun tiedoston
nimen nyttn
}
procedure TFormLuoPeli.BitBtnValitseKysymyssarjaClick(Sender: TObject);
var Polku, Nimi, Paate: String;
begin
  OpenDialogLataaKysymyssarja.FileName := '';
  // Avataan oletuksena kansio, josta ohjelma suoritetaan
  OpenDialogLataaKysymyssarja.InitialDir := ExtractFilePath(application.ExeName)+KysymyssarjaPolku;
  if not OpenDialogLataaKysymyssarja.Execute then exit;
  ErotaPolkuNimiJaPaate(OpenDialogLataaKysymyssarja.FileName, Polku, Nimi, Paate);
  EditKysymyssarja.Text := Nimi;
end;

// Erottaa annetusta tiedostonimest polun, tiedostonimen ja tiedoston ptteen
procedure ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi, Paate: String);
var
  IndexNimi: Integer;
  IndexPaate: Integer;
begin
  IndexNimi := LastDelimiter('/\', s);
  IndexPaate := LastDelimiter('.', s);

  // Jos kyttj ei kirjoita nimelleen ptett, listn
  // se itse. Tm siksi, koska halutaan vltt
  if IndexPaate <= 0 then
    IndexPaate:=Length(s) + 1; // +1 johtunee "pisteest tiedoston ptteess"

  // Otetaan talteen polku ilman tiedoston nime
  Polku := Copy(s, 1, IndexNimi);

  // Otetaan talteen tiedoston nimi polusta
  Nimi := Copy(s, IndexNimi+1, ((Length(s)-IndexNimi) - (Length(s)-IndexPaate+1)));

  // Otetaan talteen tiedoston pte polusta
  Paate := Copy(s, IndexPaate, Length(s)-IndexNimi)
end;

{
Listn valittu kysymyssarja listaan (omalta koneelta tai palvelimelta, kumpi
vain valittuna.) ja nollataan valittu kentt. Jos kysymyssarjoja on valittuna,
laitetaan poisto kyttn. Jos kysymyssarjoja on maksimimr, ei sallita enempien
lismist. Jos pelilauta ja ainakin yksi kysymyssarja on olemassa, sallitaan
pelin luominen.
}
procedure TFormLuoPeli.ButtonLisaaClick(Sender: TObject);
var Kokonimi, Polku, Nimi, Paate: String;
    KSNimi: String; //kysymyssarjan nimi
begin
{  if (PelilaudanKysymyssarja <> '') then begin
    Kokonimi := PelilaudanKysymyssarja;
    ErotaPolkuNimiJaPaate(Kokonimi, Polku, Nimi, Paate);
    Kysymyssarjat.Add(TKysymyssarja.Create(Kokonimi, false));
    ListBoxValitutKysymyssarjat.Items.Add(Nimi);
    PelilaudanKysymyssarja := '';
  end; }
  Kokonimi := OpenDialogLataaKysymyssarja.FileName;
  if (Kokonimi <> '') then begin
    ErotaPolkuNimiJaPaate(Kokonimi, Polku, Nimi, Paate);
    Kysymyssarjat.Add(Nimi);
    ListBoxValitutKysymyssarjat.Items.Add(Nimi);
    OpenDialogLataaKysymyssarja.FileName := '';
  end
  else if (ListBoxValitseKysymyssarjaPalvelimelta.ItemIndex>=0) then
  begin
    KSNimi := ListBoxValitseKysymyssarjaPalvelimelta.Items.Strings[ListBoxValitseKysymyssarjaPalvelimelta.ItemIndex];
    Kysymyssarjat.Add(KSNimi);
    ListBoxValitutKysymyssarjat.Items.Add(KSNimi);
    ListBoxValitseKysymyssarjaPalvelimelta.ItemIndex := -1; // poistetaan valinta
  end;

  EditKysymyssarja.Text := '< Kysymyssarjaa ei ole valittu >';

  if (Kysymyssarjat.Count > 0) then ButtonPoista.Enabled := True;

  if (Kysymyssarjat.Count >= KysymyssarjojenMaksimimaara) then begin
    EditKysymyssarja.Text := '< Maksimimr kysymyssarjoja valittu >';
    ButtonLisaa.Enabled := False;
    BitBtnValitseKysymyssarja.Enabled := False;
  end;

  if not (Pelilauta = '') and (ListBoxValitutKysymyssarjat.Count > 0) then BitBtnLuoPeli.Enabled := True;
end;

//keskitetn ikkuna luonnissa, luodaan kysymyssarjat, alustetaan tietoja ja
//kaivetaan esiin pelin juurihakemisto
procedure TFormLuoPeli.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
  OpenDialogLataaPelilauta.FileName := '';
  OpenDialogLataaKysymyssarja.FileName := '';
  Kysymyssarjat := TStringList.Create;
  Verkossa := False;
  PelinHakemisto := ExtractFilePath(Application.ExeName);

  //Laitetaan oikean ptteen filtterit
  OpenDialogLataaKysymyssarja.Filter := 'Kysymyssarja (*'+KysPaate+')|*'+KysPaate;
//  OpenDialogLataaKysymyssarja.InitialDir := PelinHakemisto+KysymyssarjaPolku;
  OpenDialogLataaPelilauta.Filter := 'Pelilauta (*'+PlaPaate+')|*'+PlaPaate;
//  OpenDialogLataaPelilauta.InitialDir := PelinHakemisto+PelilautaPolku;


end;

{
Poistetaan valittu kysymyssarja listasta. Jos poistetaan kysymyssarjoja on
alle maksimin, sallitaan lisys. Jos kysymyssarjoja ei ole ollenkaan, estetn
poisto ja pelin luominen
}
procedure TFormLuoPeli.ButtonPoistaClick(Sender: TObject);
var I: Integer;
begin
  while ListBoxValitutKysymyssarjat.SelCount > 0 do
  begin
    for I := 0 to ListBoxValitutKysymyssarjat.Count-1 do
    begin
      if (ListBoxValitutKysymyssarjat.Selected[I]) then
        begin
          ListBoxValitutKysymyssarjat.Items.Delete(I);
          Kysymyssarjat.Delete(I);
          Break;
        end;
    end;
  end;
  if (Kysymyssarjat.Count < KysymyssarjojenMaksimimaara) then begin
    EditKysymyssarja.Text := '< Kysymyssarjaa ei ole valittu >';
    ButtonLisaa.Enabled := True;
    BitBtnValitseKysymyssarja.Enabled := True;
  end;
  if (Kysymyssarjat.Count = 0) then begin
    ButtonPoista.Enabled := False;
    BitBtnLuoPeli.Enabled := False;
  end;
end;

//Kun kysymyssarja valitaan listasta, laitetaan se mys alas nkyviin
procedure TFormLuoPeli.ListBoxValitseKysymyssarjaPalvelimeltaClick(
  Sender: TObject);
begin
  if(ListBoxValitseKysymyssarjaPalvelimelta.ItemIndex>=0) then
  EditKysymyssarja.Text := ListBoxValitseKysymyssarjaPalvelimelta.Items.Strings[ListBoxValitseKysymyssarjaPalvelimelta.ItemIndex];
end;


//kun valitaan jokin pelilauta listasta, laitetaan se mys alas nkyviin
//ja annetaan pelin luontinappi kyttn jos kysymyssarja on jo valittu
procedure TFormLuoPeli.ListBoxValitseLautaPalvelimeltaClick(
  Sender: TObject);
begin
  if (ListBoxValitseLautaPalvelimelta.ItemIndex >= 0) then begin
    Pelilauta := ListBoxValitseLautaPalvelimelta.Items.Strings[ListBoxValitseLautaPalvelimelta.ItemIndex];
    EditPelilauta.Text := Pelilauta;
    if (ListBoxValitutKysymyssarjat.Count > 0) then BitBtnLuoPeli.Enabled := True;
  end;
end;

//Alustaa annetun pelilogiikan omilla tiedoillaan (metodi selitetty pelilogiikassa)
procedure TFormLuoPeli.AlustaPelilogiikka(Pelilogiikka: TPelilogiikka);
begin
  Pelilogiikka.Alusta(Verkossa, Kysymyssarjat, Pelilauta,
    RadioGroupPelaajia.ItemIndex+1, md5String(LabeledEditSalasana.Text),
    CheckBoxSalasana.State = cbChecked,
    CheckBoxArvosana.State = cbChecked, 0, //kun ei ole arvosanoja viel
    Luoja, PelinHakemisto, LabeledEditPelinNimi.Text);
end;

//Otetaan pelinluojan tiedot talteen. Tllin ollaan verkossa.
procedure TFormLuoPeli.AsetaPelinLuoja(Luoja: THahmo);
begin
  self.Luoja := Luoja;
  Verkossa := True;
end;

//Ottaa salasanan muistiin aina kun kentt muutetaan. Alusta ja lopusta
//poistetaan tyhjt.
procedure TFormLuoPeli.LabeledEditSalasanaChange(Sender: TObject);
begin
  Salasana := Trim(LabeledEditSalasana.Text);
end;

//Alustaa tiedot ja yhdist (kommenteissa) tiedostopalvelimelle
procedure TFormLuoPeli.AlustaFTP(Tunnus, Salasana, Osoite: String;
  Portti: Integer);
begin
  IdFTPTiedostoPalvelin.Username := Tunnus;
  IdFTPTiedostoPalvelin.Password := Salasana;
  IdFTPTiedostoPalvelin.Host := Osoite;
  IdFTPTiedostoPalvelin.Port := Portti;
{  try     //ottaa yhteyden ftp-palvelimelle ja laittaa valinnat kyttn
    IdFTPTiedostoPalvelin.Connect();
    ListBoxValitseKysymyssarjaPalvelimelta.Enabled := True;
    ListBoxValitseLautaPalvelimelta.Enabled := True;
    ComboBoxKysymysJarjestys.Enabled := True;
    ComboBoxLautaJarjestys.Enabled := True;
  except
    ShowMessage('Ei voitu yhdist tiedostopalvelimelle');
  end; }
end;

end.
