{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

MetaOppilaanLiittymaForm (mys Verkkopeli form) sislt listan saatavilla
olevista peleist. Kynnist uuden pelin luonnin sek peliin liittymisen.
}
unit MetaOppilaanLiittymaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, Paketit, md5, IlmoitusForm, Contnrs,
  ExtCtrls;

type
  TFormMetaOppilaanLiittyma = class(TForm)
    ListBoxPelit: TListBox;
    GroupBoxSaatavillaOlevatPelit: TGroupBox;
    ButtonLiity: TButton;
    ButtonLuoPeli: TButton;
    ButtonKirjauduUlos: TButton;
    LabelTervetuloa: TLabel;
    LabelNimi: TLabel;
    ButtonPaivitaLista: TButton;
    TimerListanPaivitys: TTimer;
    procedure ButtonLuoPeliClick(Sender: TObject);
    procedure ButtonPaivitaListaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonLiityClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ButtonKirjauduUlosClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure TimerListanPaivitysTimer(Sender: TObject);
  private
    Meta: TClientSocket; //yhteys metapalvelimelle
    Pelit: TObjectList; //olemassa olevat pelit tietoineen
    procedure Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
    procedure AnnaPaketti(Socket: TCustomWinSocket);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure PuraLista(Lista: TPelilista);
    procedure AsetaMaara(PelienMaara: TPelienMaara);
  public
    procedure AsetaMetaSocket(Meta: TClientSocket);
    procedure AsetaNimi(Nimi: String);
  end;

var
  FormMetaOppilaanLiittyma: TFormMetaOppilaanLiittyma;

implementation

uses PelinPelaaminenPaaForm;

{$R *.dfm}

//Pyrkii luomaan uuden pelin ja piilottaa itsens. Jos luonti peruutetaan, nytetn formi.
procedure TFormMetaOppilaanLiittyma.ButtonLuoPeliClick(Sender: TObject);
begin
  Hide;
  if not (FormPelinPelaaminen.LuoUusiPeli) then Show;
end;

//Lhett paketin sockettiin
procedure TFormMetaOppilaanLiittyma.Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
begin
  try
    Socket.SendText(Paketti.PalautaPaketti);
  finally
    FreeAndNil(Paketti);
  end;
end;

//Passaa socketin ksittelijlle kun uusia paketteja on saapunut
procedure TFormMetaOppilaanLiittyma.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  AnnaPaketti(Socket);
end;

//purkaa paketit socketista ja passaa ne omille ksittelijilleen
procedure TFormMetaOppilaanLiittyma.AnnaPaketti(Socket: TCustomWinSocket);
var PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
    Kirjautunut: TKirjautunut;
begin
  XMLPaketti := Socket.ReceiveText;
  if XMLPaketti = '' then begin
    exit;
  end;

  XMLPakettiLista := PilkoXML(XMLPaketti);

  for I := 0 to XMLPakettiLista.Count-1 do
  begin
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    case PaketinTyyppi of
      ChattaajaListaTyyppi:
        FormPelinPelaaminen.KasitteleChat(TChattaajaLista.Create(XMLPaketti));
      ChatViestiLahettajaltaTyyppi:
        FormPelinPelaaminen.KasitteleChat(TChatViestiLahettajalta.Create(XMLPaketti));
      PelilistaTyyppi:
        PuraLista(TPelilista.Create(XMLPaketti));
      PelienMaaraTyyppi:
        AsetaMaara(TPelienMaara.Create(XMLPaketti));
      TiedostopalvelimenTiedotTyyppi:
        FormPelinPelaaminen.AsetaFTP(TTiedostopalvelimenTiedot.Create(XMLPaketti));
    end;
  end;
  FreeAndNil(XMLPakettiLista);
end;


//PelienMr paketti aloittaa aina uuden pelilistan saapumisen,
//joten tapetaan ja alustetaan vanhat
procedure TFormMetaOppilaanLiittyma.AsetaMaara(PelienMaara: TPelienMaara);
begin
  Pelit.Clear;
  ListBoxPelit.Clear;
  Pelit.Capacity := PelienMaara.Maara;
  FreeAndNil(PelienMaara);
end;

{
Purkaa pelilistan, listen pelit alkuindeksist eteenpin sisiseen listaan
(tm siksi ett yksi paketti voi sislt vain tietyn verran pelej),
jonka jlkeen pivitetn nkyv komponentti.
}
procedure TFormMetaOppilaanLiittyma.PuraLista(Lista: TPelilista);
var I: Integer; Peli: TMPeli;
begin
  for I := 0 to Lista.Pelit.Count-1 do
  begin
    Peli := TMPeli(Lista.Pelit[I]);
    Peli := TMPeli.Create(Peli.PelinLuojanNimi, Peli.PelinLuojanTunnus,
      Peli.PelinNimi, Peli.Aihealue, Peli.Vaikeustaso, Peli.PelipalvelimenOsoite,
      Peli.Kaynnissa);
    Pelit.Insert(I+Lista.AloitusIndeksi, Peli);
  end;
  ListBoxPelit.Items.Clear;
  for I := 0 to Pelit.Count-1 do
  begin
    ListBoxPelit.Items.Add((Pelit.Items[I] as TMPeli).PelinNimi);
  end;
  ListBoxPelit.Invalidate;
  FreeAndNil(Lista);
end;

//Otetaan meta socket ja sen luku omaan kyttn.
procedure TFormMetaOppilaanLiittyma.AsetaMetaSocket(Meta: TClientSocket);
begin
  Self.Meta := Meta;
  Meta.OnRead := ClientSocketRead;
end;

//Lhett pyynnn pelilistasta metapalvelimelle
procedure TFormMetaOppilaanLiittyma.ButtonPaivitaListaClick(
  Sender: TObject);
begin
  Laheta(TListanPaivitys.Create, Meta.Socket);
end;

//Keskitetn luonnissa ja luodaan pelilista
procedure TFormMetaOppilaanLiittyma.FormCreate(Sender: TObject);
begin
  Pelit := TObjectList.Create;
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

//Laittaa nimen tervetuloviestiin.
procedure TFormMetaOppilaanLiittyma.AsetaNimi(Nimi: String);
begin
  LabelNimi.Caption := Nimi;
end;

//Pyrkii yhdistmn peliin
procedure TFormMetaOppilaanLiittyma.ButtonLiityClick(Sender: TObject);
var I: Integer;
    Peli: TMPeli;
begin
  if (FormPelinPelaaminen.ClientSocketPeli.Socket.Connected) then
    FormPelinPelaaminen.ClientSocketPeli.Close;
  I := Pelit.Count;
  for I := 0 to ListBoxPelit.Count-1 do
  begin
    if (ListBoxPelit.Selected[I]) then
    begin
      Peli := TMPeli(Pelit.Items[I]);
      if (FormPelinPelaaminen.YhdistaPeliin(Peli.PelipalvelimenOsoite)) then
        exit;
    end;
  end;
end;

//Pyyt listan pivityksen aina kun formi nytetn
procedure TFormMetaOppilaanLiittyma.FormShow(Sender: TObject);
begin
  Laheta(TListanPaivitys.Create, Meta.Socket);
end;

//Kirjaa pelaajan pois metapalvelimelta ja sulkee formin, palaten alkuvalikkoon
procedure TFormMetaOppilaanLiittyma.ButtonKirjauduUlosClick(
  Sender: TObject);
begin
  Meta.Close;
  Hide;
  FormPelinPelaaminen.Show;
  FormPelinPelaaminen.TimerPaavalikko.Enabled := True;
end;

//Varmistaa ettei formia voi sulkea vrin
procedure TFormMetaOppilaanLiittyma.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if Sender = Self then CanClose := False
  else CanClose := True;
end;

//Vapautetaan pelilista kun formi tuhotaan
procedure TFormMetaOppilaanLiittyma.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Pelit);
end;

//Lhett pelilistan pivityspyynnn metapalvelimelle, mikli se on asetettu ja
//formi on nkyviss.
procedure TFormMetaOppilaanLiittyma.TimerListanPaivitysTimer(
  Sender: TObject);
begin
  if not Assigned(Meta) then exit;
  if (Meta.Socket.Connected) and (Self.Visible = True) then
    ButtonPaivitaLista.Click;
end;

end.

