{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006
}

//Metapalvelimen plomake, jossa on mys melkein
//kaikki metapalvelimen toiminnallisuus.
unit MetapalvelinForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Contnrs, ExtCtrls, Grids, ComCtrls, CheckLst, md5, Paketit,
  xmldom, XMLIntf, XMLDoc, //XML-dokumentin vaatimat luokat
  ScktComp, Menus, SisallonPoistoForm, DateUtils,
  IdTCPConnection, IdTCPClient, IdFTP, IdComponent, IdBaseComponent; //FTP-clientin vaatimat luokat

type
  //varastoi opettajatilin tiedot
  TOpettajaTili = class(TObject)
    FTunnus: String;
    FSalasanaMD5: MD5Digest;
  public
    constructor Create(KTunnus: String; KSalasana: MD5Digest);

    property Tunnus: String read FTunnus;
    property Salasana: MD5Digest read FSalasanaMD5;
  end;

  //varastoi kyttjtunnuksen tiedot
  TKayttajatunnus = class(TObject)
    FPelaajanNimi: String;
    FKayttajatunnus: String;
    FSalasanaMD5: MD5Digest;
  public
    constructor Create(KNimi: String; KTunnus: String; KSalasana: MD5Digest);

    property PelaajanNimi: String read FPelaajanNimi;
    property Tunnus: String read FKayttajatunnus;
    property Salasana: MD5Digest read FSalasanaMD5;
  end;

  //varastoi kirjautuneen asiakkaan tiedot, yllpit verkkosikeen ja
  //pelaajan tilaa  
  TAsiakas = class
    AsiakkaanTunnus: TKayttajatunnus;
    AsiakkaanSaie: TCustomWinSocket;
    Kirjautunut: Boolean;
    FPelaamassa: Boolean;
    FViimeisinPing: TDateTime;
  public
    constructor Create(Saie: TCustomWinSocket);

    procedure LahetaPaketti(Paketti: TPaketti);

    procedure Kirjaudu;

    property Pelaamassa: Boolean read FPelaamassa write FPelaamassa;
    property ViimeisinPing: TDateTime read FViimeisinPing write FViimeisinPing;
  end;

  //metapalvelimen plomake
  TFormMetapalvelin = class(TForm)
    ListBoxAsiakkaat: TListBox;
    ListBoxPelit: TListBox;
    ServerSocket: TServerSocket;
    ListBoxOpettajatilit: TListBox;
    MainMenuValikko: TMainMenu;
    MenuItemMetapalvelin: TMenuItem;
    MenuItemMPPortti: TMenuItem;
    MenuItemMPSalasana: TMenuItem;
    MenuItemTiedostopalvelin: TMenuItem;
    MenuItemTiedostopalvelimenOsoite: TMenuItem;
    MenuItemTiedostopalvelimenPortti: TMenuItem;
    MenuItemOpettalatili: TMenuItem;
    MenuItemLuoOpettaja: TMenuItem;
    LabelPelisessiot: TLabel;
    LabelAsiakkaat: TLabel;
    LabelOpettajatilit: TLabel;
    BevelMenunAlaviiva: TBevel;
    LabelAvatutYhteydet: TLabel;
    LabelSuljetutYhteydet: TLabel;
    LabelVastaanotetutPaketit: TLabel;
    MenuItemPoistaSisaltoa: TMenuItem;
    ButtonPoistaPelisessio: TButton;
    LukitseMenu: TMenuItem;
    FTPClientTiedostopalvelin: TIdFTP;
    LabelAvatutYhteydetTeksti: TLabel;
    LabelSuljetutYhteydetTeksti: TLabel;
    LabelVastaanotetutYhteydetTeksti: TLabel;
    TimerPing: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure MenuItemMPPorttiClick(Sender: TObject);
    procedure MenuItemTiedostopalvelimenPorttiClick(Sender: TObject);
    procedure MenuItemLuoOpettajaClick(Sender: TObject);
    procedure MenuItemMPSalasanaClick(Sender: TObject);
    procedure MenuItemTiedostopalvelimenOsoiteClick(Sender: TObject);
    procedure ServerSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure MenuItemPoistaSisaltoaClick(Sender: TObject);
    procedure ButtonPoistaPelisessioClick(Sender: TObject);
    procedure LukitseMenuClick(Sender: TObject);
    procedure TimerPingTimer(Sender: TObject);
  private
    { Private declarations }
    MetapalvelimenPortti: Integer;

    MetapalvelimenSalasanaMD5: MD5Digest;
    MetapalvelimellaSalasana: Boolean;

    TiedostopalvelimenOsoite: String;
    TiedostopalvelimenPortti: Integer;
    TiedostopalvelimenAsiakkuus: TAsiakas;

    KayttajatunnusLista: TObjectList; //lista kyttjtunnuksista
    OpettajatiliLista: TObjectList; //ista opettajatileist

    Asiakkaat: TObjectList; //lista kirjautuneista asiakkaista

    Pelit: TObjectList; //lista kynniss olevista peleist

    function EtsiAsiakas(Saie: TCustomWinSocket): TAsiakas; overload;
    function EtsiAsiakas(Tunnus: String): TAsiakas; overload;

    procedure PoistaAsiakas(Socket: TCustomWinSocket);

    procedure SuljeServeri;

    procedure LataaOpettajatiliLista;
    procedure TallennaOpettajatiliLista;

    procedure LataaKayttajatunnusLista;
    procedure TallennaKayttajatunnusLista;

    procedure LataaAsetustiedosto;
    procedure TallennaAsetustiedosto;

    procedure TaytaOpettajatiliListBox;

    procedure LahetaVirhe(Virhe: Virhekoodi; Asiakas: TAsiakas);

    procedure LahetaKaikilleAsiakkaille(Paketti: TPaketti);

    procedure LahetaKirjaudu(Asiakas: TAsiakas);

    procedure LahetaChattaajaLista(Asiakas: TAsiakas);
    procedure LahetaChattaajaListaKaikille();

    procedure LahetaChatViestiKaikille(Paketti: TChatViesti; Asiakas: TAsiakas);

    procedure LahetaTunnuslista;

    procedure LuoTunnus(Paketti: TTunnuksenLuominen; Asiakas: TAsiakas);

    procedure KasitteleKirjautuminen(Paketti: TKirjautuminen; Asiakas: TAsiakas);

    procedure LisaaUusiPeli(Paketti: TUusiPeli; Asiakas: TAsiakas);

    procedure LahetaPelilista(Asiakas: TAsiakas);

    procedure LahetaTiedostopalvelimenTiedot(Asiakas: TAsiakas);

    procedure PeliAlkaa(Asiakas: TAsiakas);

    procedure MerkitsePelaajaksi(Paketti: TLiittyiPeliin);

    procedure PeliPaattyi(Paketti: TPeliPaattyi; Asiakas: TAsiakas);

    procedure PeliPaattynyt(Paketti: TPeliPaattynyt; Asiakas: TAsiakas);

    procedure AsiakasKatkaisiYhteyden(Asiakas: TAsiakas);

    procedure LukitseMetapalvelin;

    procedure TallenntaLokitiedosto(XMLPaketti: String);
    procedure PoistaPelaamisesta(Paketti: TPoistui);
  public
    { Public declarations }
  end;

//kytettvien asetus- ja tunnustiedostojen nimet
const MetaAsetustiedostonNimi: String = 'meta_asetukset.xml';
const KayttajatunnustiedostonNimi: String = 'tunnukset.xml';
const OpettajatilitiedostonNimi: String = 'opettajatilit.xml';

const LokitiedostonPolku: String = 'lokit\';

var
  FormMetapalvelin: TFormMetapalvelin;

implementation

{$R *.dfm}

uses LuoOpettajatiliForm, MetapalvelimenPorttiForm, MetapalvelimenSalasanaForm;

//alustetaan kyttjtunnus annetuilla parametreill
constructor TKayttajatunnus.Create(KNimi: String; KTunnus: String;
                                   KSalasana: MD5Digest);
begin
  FPelaajanNimi := KNimi;
  FKayttajatunnus := KTunnus;
  FSalasanaMD5 := KSalasana;
end;

//alustetaan asiakkaan sie annetulla parametrill ja laitetaan muihin
//attribuutteihin oletusarvot
constructor TAsiakas.Create(Saie: TCustomWinSocket);
begin
  AsiakkaanSaie := Saie;
  Kirjautunut := False;
  Pelaamassa := False;
  AsiakkaanTunnus := nil;
  ViimeisinPing := GetTime;
end;

//lhetetn asiakkaalle parametrin annettu paketti
procedure TAsiakas.LahetaPaketti(Paketti: TPaketti);
begin
  AsiakkaanSaie.SendText(Paketti.Paketti); //lhetetn paketti
  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//merkitn asiakas kirjautuneeksi
procedure TAsiakas.Kirjaudu;
begin
  Kirjautunut := True;
end;

//Etsitn asiakas verkkosikeen mukaan.
//Jos asiakas lytyy palautetaan asiakas, muuten palautetaan nil.
function TFormMetapalvelin.EtsiAsiakas(Saie: TCustomWinSocket): TAsiakas;
var I: Integer;
begin
  Result := nil;

  //kydn asikaslista lpi ja tutkitaan onko jonkin listassa olevan tunnus haluttu
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    if Saie.SocketHandle = (Asiakkaat.Items[I] as TAsiakas).AsiakkaanSaie.SocketHandle then
      Result := Asiakkaat.Items[I] as TAsiakas;
  end;
end;


//Etsitn asiakas tunnuksen mukaan.
//Jos asiakas lytyy palautetaan asiakas, muuten palautetaan nil.
function TFormMetapalvelin.EtsiAsiakas(Tunnus: String): TAsiakas;
var I: Integer;
begin
  Result := nil;

  //kydn asikaslista lpi ja tutkitaan onko jonkin listassa olevan tunnus haluttu
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    if Tunnus = (Asiakkaat.Items[I] as TAsiakas).AsiakkaanTunnus.Tunnus then
      Result := Asiakkaat.Items[I] as TAsiakas;
  end;
end;

//suljetaan metapalvelin
procedure TFormMetapalvelin.SuljeServeri;
begin
  //tyhjenn asiakaslista
  Asiakkaat.Clear;

  //tyhjenn pelilista
  Pelit.Clear;

  //suljetaan serverin kuuntelu
  ServerSocket.Active := False;
end;

//lhetetn parametrin annettu paketti kaikille asiakkaille, jotka ovat
//kirjautuneet ja eivt ole pelaamassa
procedure TFormMetapalvelin.LahetaKaikilleAsiakkaille(Paketti: TPaketti);
var I: Integer;
    Asiakas: TAsiakas;
begin
  //kydn lpi kaikki asiakkaat
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    Asiakas := Asiakkaat.Items[I] as TAsiakas;
    //jos asiakas on kirjautunut ja ei ole pelaamassa lhetetn paketti
    if(Asiakas.Kirjautunut and not Asiakas.Pelaamassa) then
      Asiakas.AsiakkaanSaie.SendText(Paketti.Paketti);
  end;
  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//lheten parametrin annetulle asiakkaalle kirjautumispaketti
procedure TFormMetapalvelin.LahetaKirjaudu(Asiakas: TAsiakas);
begin
  Asiakas.LahetaPaketti(TKirjaudu.Create);
end;

//ksitelln tunnuksen tunnuksen luomis -paketti 
procedure TFormMetapalvelin.LuoTunnus(Paketti: TTunnuksenLuominen; Asiakas: TAsiakas);
var I: Integer;
    Tunnus: TKayttajatunnus;
begin
  //jos metapalvelimella on salasana tutkitaan onko se sama kuin paketissa
  if(MetapalvelimellaSalasana) then
  begin
    //jos salasana ei ole sama lhetetn virheilmoitus
    if(MD5Match(MetapalvelimenSalasanaMD5, Paketti.MetapalvelimenSalasananMD5) = False) then
    begin
      Asiakas.LahetaPaketti(TVirhePaketti.Create(VaaraMetapalvelimenSalasanaVirhe));
      Exit;
    end;
  end;

  //tutkitaan onko tunnus jo listassa
  for I := 0 to KayttajatunnusLista.Count - 1 do
  begin
    Tunnus := KayttajatunnusLista.Items[I] as TKayttajatunnus;
    //jos tunnus on jo listassa lhetetn siit virheilmoitus
    if(Tunnus.Tunnus = Paketti.Tunnus) then
    begin
      Asiakas.LahetaPaketti(TVirhePaketti.Create(KayttajatunnusJoKaytossaVirhe));
      Exit;
    end;
  end;

  //tunnus on uusi, joten se voidaan list listaan
  KayttajatunnusLista.Add(TKayttajatunnus.Create(Paketti.PelaajanNimi, Paketti.Tunnus, Paketti.SalasananMD5));
  Asiakas.LahetaPaketti(TVirhePaketti.Create(EiVirhettaVirhe));

  //tallennetaan kyttjtunnukset tiedostoon
  TallennaKayttajatunnusLista;

  //jos tiedostopalvelin on kytss lhetetn tiedostopalvelimelle tieto uudesta tunnuksesta
  if(TiedostopalvelimenAsiakkuus <> nil) then
    TiedostopalvelimenAsiakkuus.LahetaPaketti(TLisattyTunnus.Create(Paketti.Tunnus, MD5Print(Paketti.SalasananMD5)));

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//ksitelln kirjautumispaketti
procedure TFormMetapalvelin.KasitteleKirjautuminen(Paketti: TKirjautuminen;
                                                   Asiakas: TAsiakas);
var I: Integer;
    Tunnus: TKayttajatunnus;
    VanhaAsiakas: TAsiakas;
begin
  //Tutkitaan onko samalla tunnuksella jo kirjauduttu. Jos on lhetetn siit
  //virheilmoitus.
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    VanhaAsiakas := Asiakkaat.Items[I] as TAsiakas;
    if(VanhaAsiakas.AsiakkaanTunnus = nil) then
      Continue;
    if(VanhaAsiakas.AsiakkaanTunnus.Tunnus = Paketti.Kayttajatunnus) then
    begin
      Asiakas.LahetaPaketti(TKirjautunut.Create('X', False)); //X on pelaajan nimi (ei ole en kytss)
      Exit;
    end;
  end;

  //kydn lpi kyttjtunnuslista ja tutkitaan vastaako jokin niist
  //kirjautumispakettia
  for I :=0 to KayttajatunnusLista.Count - 1 do
  begin
    Tunnus := KayttajatunnusLista.Items[I] as TKayttajatunnus;
    if((Paketti.Kayttajatunnus = Tunnus.Tunnus) and MD5Match(Paketti.SalasanaMD5, Tunnus.Salasana)) then
    begin
      //kirjautuminen onnistui, joten merkitn asiakas kirjautuneeksi ja
      //lhetetn onnistuneen kirjautumisen paketti
      Asiakas.AsiakkaanTunnus := TKayttajatunnus.Create(Tunnus.PelaajanNimi,
                                                        Tunnus.Tunnus,
                                                        Tunnus.Salasana);
      Asiakas.Kirjaudu;
      Asiakas.LahetaPaketti(TKirjautunut.Create(Tunnus.PelaajanNimi, True));
      ListBoxAsiakkaat.Items.Add(Tunnus.Tunnus);

      LahetaChattaajaListaKaikille;
      Exit;
    end;
  end;

  //asiakkaan tunnus ja salasana eivt tsmnneet metapalvelimen listaan, joten
  //lhetetn eponnistuneen kirjautumisen paketti
  Asiakas.LahetaPaketti(TKirjautunut.Create('X', False)); //X on pelaajan nimi (ei ole en kytss)

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//listn uusi peli -paketin mukainen peli pelilistaan
procedure TFormMetapalvelin.LisaaUusiPeli(Paketti: TUusiPeli; Asiakas: TAsiakas);
var I: Integer; Peli: TMPeli;
begin
  //jos asiakas ei ole kirjautunut hyltn luotu peli
  if(Asiakas.Kirjautunut = False) then
    Exit;

  //jos pelej on jo maksimimr lhetetn uuden pelin luojalle siit virheilmoitus
  if(Pelit.Count >= PelienMaksimimaara) then
  begin
    LahetaVirhe(PeliaJoMaksimimaaraVirhe, Asiakas);
    Exit;
  end;

  //tutki onko saman niminen peli jo olemassa
  for I := 0 to Pelit.Count - 1 do
  begin
    Peli := Pelit.Items[I] as TMPeli;
    //jos saman niminen peli on olemassa lhet uuden pelin luojalle siit virheilmoitus
    if(Peli.PelinNimi = Paketti.Pelinnimi) then
    begin
      LahetaVirhe(PelinNimiJoKaytossaVirhe, Asiakas);
      Exit;
    end;
  end;

  //pelill on yksilllinen nimi, joten sen voi list uusi peli listaan
  ListBoxPelit.Items.Add(Paketti.Pelinnimi);
  Pelit.Add(TMPeli.Create(
    Asiakas.AsiakkaanTunnus.PelaajanNimi,
    Asiakas.AsiakkaanTunnus.Tunnus,
    Paketti.Pelinnimi,
    Paketti.Aihealue,
    Paketti.Vaikeustaso,
    Asiakas.AsiakkaanSaie.RemoteAddress, False));

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//lhetetn parametrin olevalle asiakkaalle pelilista
procedure TFormMetapalvelin.LahetaPelilista(Asiakas: TAsiakas);
var Pelilista: TObjectList;
    PelienMaara, AloitusIndeksi, LahetettavienPelienMaara, I: Integer;
begin
  if(Asiakas.Kirjautunut = False) then
    exit; 

  //tarkistetaan, ettei pelej ole yli maksimimrn
  PelienMaara := Pelit.Count;
  if(PelienMaara > PelienMaksimimaara) then
    PelienMaara := PelienMaksimimaara;

  //lhetetn pelien mrst paketti asiakkaalle
  Asiakas.LahetaPaketti(TPelienMaara.Create(PelienMaara));

  //jos pelej on olemassa lhetetn ne asikkaalle
  if(PelienMaara > 0) then
  begin
    Pelilista := TObjectList.Create;
    AloitusIndeksi := 0;

    //lhetetn asiakkaalle pelilista osissa, LahetettavienPelienMaksimimaaran verran kerrallaan
    while(AloitusIndeksi < PelienMaara) do
    begin
      Pelilista.Clear;

      //lasketaan osassa lhetettvien mr pelien 
      LahetettavienPelienMaara := (PelienMaara - AloitusIndeksi);
      if(LahetettavienPelienMaara > LahetettavienPelienMaksimimaara) then
        LahetettavienPelienMaara := LahetettavienPelienMaksimimaara;

      //tytetn lhtetvn pelilistaan pelien tiedot [AloitusIndeksi, AloitusIndeksi+LahetettavienPelienMaara-1]
      for I := AloitusIndeksi to AloitusIndeksi + LahetettavienPelienMaara - 1 do
      begin
        Pelilista.Add(Pelit.Items[I]);
      end;

      //lhetetn pelilistan osa asiakkaalle
      Asiakas.LahetaPaketti(TPelilista.Create(AloitusIndeksi, Pelilista));

      //siirretn 
      AloitusIndeksi := AloitusIndeksi + LahetettavienPelienMaksimimaara;
    end;
  end;
end;

//merkitn peliin liittynyt pelaaja pelaajaksi ja lhetettn pivittynyt
//chattaajalista kaikille asiakkaille
procedure TFormMetapalvelin.MerkitsePelaajaksi(Paketti: TLiittyiPeliin);
var Asiakas: TAsiakas;
begin
  //asiakas liittyi peliin, joten asiakas voidaan merkit pelaavaksi
  Asiakas := EtsiAsiakas(Paketti.Tunnus);
  if(Asiakas <> nil) then
    Asiakas.Pelaamassa := True;

  //lhetettn pivittynyt chattaajalista kaikille asiakkaille
  LahetaChattaajaListaKaikille;

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//poistetaan pelist poistunut pelaaja pelaavista ja lhetettn pivittynyt
//chattaajalista kaikille asiakkaille
procedure TFormMetapalvelin.PoistaPelaamisesta(Paketti: TPoistui);
var Asiakas: TAsiakas;
begin
  //asiakas poistui pelist, joten asiakaan pelaamismerkint tulee poistaa
  Asiakas := EtsiAsiakas(Paketti.Tunnus);
  if(Asiakas <> nil) then
    Asiakas.Pelaamassa := False;

  //lhetettn pivittynyt chattaajalista kaikille asiakkaille
  LahetaChattaajaListaKaikille;

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//peli on pttynyt, joten siin olleet pelaajat voidaan poistaa pelaavista ja
//lhetettn pivittynyt chattaajalista kaikille asiakkaille
procedure TFormMetapalvelin.PeliPaattyi(Paketti: TPeliPaattyi; Asiakas: TAsiakas);
var PelinAsiakas: TAsiakas;
    Maara, I: Integer;
begin
  //peli on pttynyt, joten siin olleet pelaajat voidaan poistaa pelaavista
  Maara := Paketti.PelaajienTunnukset.Count;
  for I := 0 to Maara - 1 do
  begin
    PelinAsiakas := EtsiAsiakas(Paketti.PelaajienTunnukset[I]);
    if(PelinAsiakas <> nil) then
      PelinAsiakas.Pelaamassa := False;
  end;

  //lhetettn pivittynyt chattaajalista kaikille asiakkaille
  LahetaChattaajaListaKaikille;

  FreeAndNil(Paketti); //tuhotaan lopuksi paketin sislt
end;

//lhetetn annettu virhekoodi asiakkaalle 
procedure TFormMetapalvelin.LahetaVirhe(Virhe: Virhekoodi; Asiakas: TAsiakas);
begin
  Asiakas.LahetaPaketti(TVirhePaketti.Create(Virhe));
end;

//alustetaan metapalvelimen arvot
procedure TFormMetapalvelin.FormCreate(Sender: TObject);
begin
  //suljetaan serverin kuuntelu alustuksen ajaksi
  ServerSocket.Close;

  TimerPing.Interval := 3 * 1000; //ping-viestien saapumistarkistus

  TiedostopalvelimenAsiakkuus := nil;

  OpettajatiliLista := TObjectList.Create;
  KayttajatunnusLista := TObjectList.Create;
  Asiakkaat := TObjectList.Create;
  Pelit := TObjectList.Create;

  LataaAsetustiedosto;

  LataaKayttajatunnusLista;

  LataaOpettajatiliLista;

  TaytaOpettajatiliListBox;

  //avataan serverin kuuntelu
  ServerSocket.Open;

  FTPClientTiedostopalvelin.Port := TiedostopalvelimenPortti;
  FTPClientTiedostopalvelin.Host := TiedostopalvelimenOsoite;

  Show; //nytetn oma lomake
  LukitseMetapalvelin; //lukitaan metapalvelin lopuksi
end;

//tuhotaan metapalvelin
procedure TFormMetapalvelin.FormDestroy(Sender: TObject);
begin
  //suljetaan serverin kuuntelu
  SuljeServeri;

  FreeAndNil(Asiakkaat);
  FreeAndNil(Pelit);
  FreeAndNil(OpettajatiliLista);
  FreeAndNil(KayttajatunnusLista);
end;

//poistetaan yhteyden sulkenut asiakas lomakkeella nytettvst listasta ja
//Asiakkaat-listasta
procedure TFormMetapalvelin.AsiakasKatkaisiYhteyden(Asiakas: TAsiakas);
var I: Integer;
begin
  //etsistn ja poistetaan asiakas ListBoxAsiakkaat-listasta
  for I := 0 to ListBoxAsiakkaat.Count - 1 do
    if(ListBoxAsiakkaat.Items[I] = Asiakas.AsiakkaanTunnus.Tunnus) then
      ListBoxAsiakkaat.Items.Delete(I);

  //poistetaan asiakas Asiakkaat-listasta
  Asiakkaat.Remove(Asiakas);

  LahetaChattaajaListaKaikille;
end;

//poistetaan parametrin annetun asiakkaan luoma peli lomakkeella nytettvst
//listasta ja Pelit-listasta
procedure TFormMetapalvelin.PeliAlkaa(Asiakas: TAsiakas);
var I, J: Integer;
    Peli: TMPeli;
begin
  //kydn lpi Pelit-lista
  for I := 0 to Pelit.Count - 1 do
  begin
    Peli := Pelit[I] as TMPeli;
    //tutkitaan onko tm peli parametrein annetun asiakaan luoma
    if(Peli.PelinLuojanTunnus = Asiakas.AsiakkaanTunnus.Tunnus) then
    begin
      for J := 0 to ListBoxPelit.Count - 1 do
      begin
        if(ListBoxPelit.Items[J] = Peli.PelinNimi) then
        begin
          //poistetaan alkanut peli lomakkeella nkyvst listasta ja Pelit-listasta 
          ListBoxPelit.Items.Delete(J);
          ListBoxPelit.Update;
          Pelit.Delete(I);
          Exit;
        end;
      end;
    end;
  end;
end;

//ladataan kyttjtunnukset XML-tiedostosta KayttajatunnusListaan
procedure TFormMetapalvelin.LataaKayttajatunnusLista;
var XMLDocumentTunnukset: TXMLDocument;
    KayttajatunnuksetJuuri: IXMLNode;
    KayttajatunnusNode: IXMLNode;
    I: Integer;
    Nimi, Tunnus, Salasana: String;
begin
  KayttajatunnusLista.Clear;

  XMLDocumentTunnukset := TXMLDocument.Create(Self);

  XMLDocumentTunnukset.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentTunnukset.Active := True;
  XMLDocumentTunnukset.ParseOptions := [];

  try
    //luetaan kyttjtunnusten XML-tiedosto
    XMLDocumentTunnukset.LoadFromFile(KayttajatunnustiedostonNimi);

    KayttajatunnuksetJuuri := XMLDocumentTunnukset.DocumentElement;

    for I := 0 to KayttajatunnuksetJuuri.ChildNodes.Count - 1 do
    begin
      //luetaan kyttjtunnuksen nimi, tunnus ja salasanan MD5 ja listn se kyttjtunnuslistaan
      KayttajatunnusNode := KayttajatunnuksetJuuri.ChildNodes.Get(I);
      Nimi := KayttajatunnusNode.ChildNodes['nimi'].Text;
      Tunnus := KayttajatunnusNode.ChildNodes['tunnus'].Text;
      Salasana := KayttajatunnusNode.ChildNodes['salasana'].Text;
      KayttajatunnusLista.Add(TKayttajatunnus.Create(Nimi, Tunnus, StringToMD5(Salasana)));
    end;
  except
    on EDOMParseError do
    begin
      MessageDlg('Kyttjtunnustiedostoa "'+ KayttajatunnustiedostonNimi +'" ei voitu lukea!', mtError, [mbOk], 0);
    end;
  end;

  XMLDocumentTunnukset.Free;
end;

//tallennetaan kyttjtunnukset KayttajatunnusListasta XML-tiedostoon
procedure TFormMetapalvelin.TallennaKayttajatunnusLista;
var XMLDocumentTunnukset: TXMLDocument;
    KayttajatunnuksetNode: IXMLNode;
    KayttajatunnusNode: IXMLNode;
    NimiNode, TunnusNode, SalasanaNode: IXMLNode;
    I: Integer;
    Kayttajatunnus: TKayttajatunnus;
begin
  XMLDocumentTunnukset := TXMLDocument.Create(Self);

  XMLDocumentTunnukset.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentTunnukset.NodeIndentStr := XMLDokumentinSisennys;
  XMLDocumentTunnukset.Options := [doNodeAutoCreate,doNodeAutoIndent,doAttrNull,doAutoPrefix,doNamespaceDecl];
  XMLDocumentTunnukset.ParseOptions := [];
  XMLDocumentTunnukset.Active := True;
  XMLDocumentTunnukset.Version := XMLDokumentinVersio;
  XMLDocumentTunnukset.Encoding := XMLDokumentinMerkkienKoodaus;

  KayttajatunnuksetNode := XMLDocumentTunnukset.AddChild('kayttajatunnukset');

  for I := 0 to KayttajatunnusLista.Count - 1 do
  begin
    Kayttajatunnus := KayttajatunnusLista[I] as TKayttajatunnus;

    //listn kyttjtunnuselementti XML-dokumenttiin
    KayttajatunnusNode := KayttajatunnuksetNode.AddChild('kayttajatunnus');

    //listn kyttjtunnuksen nimi, tunnus ja salasanan MD5 elementit XML-dokumenttiin
    NimiNode := KayttajatunnusNode.AddChild('nimi');
    NimiNode.Text := Kayttajatunnus.PelaajanNimi;
    TunnusNode := KayttajatunnusNode.AddChild('tunnus');
    TunnusNode.Text := Kayttajatunnus.Tunnus;
    SalasanaNode := KayttajatunnusNode.AddChild('salasana');
    SalasanaNode.Text := MD5Print(Kayttajatunnus.Salasana);
  end;

  //kirjoitetaan kyttjtunnukset XML-tiedostoon
  XMLDocumentTunnukset.SaveToFile(KayttajatunnustiedostonNimi);
  XMLDocumentTunnukset.Free;
end;

//lhetettn chatviesti kaikille asiakkaille
procedure TFormMetapalvelin.LahetaChatViestiKaikille(Paketti: TChatViesti;
  Asiakas: TAsiakas);
begin
  LahetaKaikilleAsiakkaille(TChatViestiLahettajalta.Create(Asiakas.AsiakkaanTunnus.PelaajanNimi+': '+Paketti.Sisalto, True));
end;

//ksitelln asiakkaan yhteyden avaus
procedure TFormMetapalvelin.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var Asiakas: TAsiakas;
begin
  //listn avatut yhteydet -tekstiin yksi lis
  LabelAvatutYhteydet.Caption := IntToStr(StrToInt(LabelAvatutYhteydet.Caption) + 1);

  //Tutkitaan onko asiakas yhdistnyt aikaisemmin. Jos ei ole listn uusi
  //yhteys Asikkaat-listaan
  Asiakas := EtsiAsiakas(Socket);
  if(Asiakas = nil) then
  begin
    Asiakkaat.Add(TAsiakas.Create(Socket));
  end;
end;

//ksitelln asiakkaan yhteyden sulkeminen
procedure TFormMetapalvelin.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  //poistetaan asiakas listasta
  PoistaAsiakas(Socket);
end;

//poistetaan asiakas metapalvelimelta parametrin annetun socketin mukaan
procedure TFormMetapalvelin.PoistaAsiakas(Socket: TCustomWinSocket);
var Asiakas: TAsiakas;
    I: Integer;
begin
  //etsitn socketia vastaava asiakas
  Asiakas := EtsiAsiakas(Socket);

  if(Asiakas <> nil) then
  begin
    //jos asiakas ei ole kirjautunut voidaan lopettaa
    if(Asiakas.AsiakkaanTunnus = nil) then
      Exit;

    //listn suljetut yhteydet -tekstiin yksi lis
    LabelSuljetutYhteydet.Caption := IntToStr(StrToInt(LabelSuljetutYhteydet.Caption) + 1);
      
    for I := 0 to ListBoxAsiakkaat.Count - 1 do
    begin
      if(ListBoxAsiakkaat.Items[I] = Asiakas.AsiakkaanTunnus.Tunnus) then
      begin
        //jos asiakas on viel yhteydess katkaistaan yhteys
        if(Asiakas.AsiakkaanSaie.Connected) then Asiakas.AsiakkaanSaie.Close;

        //poistetaan asiakas sisisist listoista
        ListBoxAsiakkaat.Items.Delete(I);
        Asiakkaat.Remove(Asiakas);

        //jos asiakas on tiedostopalvelin poistetaan tiedostopalvelin metapalvelimelta
        if(TiedostopalvelimenAsiakkuus = Asiakas) then
           TiedostopalvelimenAsiakkuus := nil;

        //lhetettn kaikille asiakkaille pivitetty chattaajalista
        LahetaChattaajaListaKaikille;

        Exit;
      end;
    end;
  end;
end;

//ksitelln metapalvelimen vastaanottamat paketit
procedure TFormMetapalvelin.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var Asiakas: TAsiakas;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    PaketinTyyppi: Pakettityyppi;
    I: Integer;
begin
  //luetaan paketin sislt
  XMLPaketti := Socket.ReceiveText;

  if(XMLPaketti = '') then exit;

  //tutkitaan lytyyk lhtettj kirjautuneista asiakkaista
  Asiakas := EtsiAsiakas(Socket);

  //jos ei lydy hyltn paketit
  if(Asiakas = nil) then exit;

  //jos samalla kerralla on tullut useampi paketti erotellaan ne
  XMLPakettiLista := PilkoXML(XMLPaketti);

  //kydn vastaanotetut paketit lpi
  for I := 0  to XMLPakettiLista.Count - 1 do
  begin
    //listn lomakkeella nytettvn vastaanotetut paketit -tekstiin yksi lis
    LabelVastaanotetutPaketit.Caption := IntToStr(StrToInt(LabelVastaanotetutPaketit.Caption) + 1);

    //otetaan listasta ksiteltv paketti ja tutkitaan sen tyyppi
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);

    //suoritetaan vastaanotetun paketin aiheuttama toiminto
    case PaketinTyyppi of
      PingTyyppi:
        Asiakas.ViimeisinPing := GetTime;
      AnnaChattaajaListaTyyppi:
        LahetaChattaajaLista(Asiakas);
      ChatViestiTyyppi:
        LahetaChatViestiKaikille(TChatViesti.Create(XMLPaketti), Asiakas);
      TunnuksenLuominenTyyppi:
        LuoTunnus(TTunnuksenLuominen.Create(XMLPaketti), Asiakas);
      KirjautuminenTyyppi:
        KasitteleKirjautuminen(TKirjautuminen.Create(XMLPaketti), Asiakas);
      UusiPeliTyyppi:
        LisaaUusiPeli(TUusiPeli.Create(XMLPaketti), Asiakas);
      ListanPaivitysTyyppi:
        LahetaPelilista(Asiakas);
      LiittyiPeliinTyyppi:
        MerkitsePelaajaksi(TLiittyiPeliin.Create(XMLPaketti));
      PoistuiTyyppi:
        PoistaPelaamisesta(TPoistui.Create(XMLPaketti));
      PeliPaattyiTyyppi:
        PeliPaattyi(TPeliPaattyi.Create(XMLPaketti), Asiakas);
      PeliPaattynytTyyppi:
        PeliPaattynyt(TPeliPaattynyt.Create(XMLPaketti), Asiakas);
      KatkaiseYhteysTyyppi:
        AsiakasKatkaisiYhteyden(Asiakas);
      PeliAlkaaTyyppi:
        PeliAlkaa(Asiakas);
      AnnaTiedostopalvelimenTiedotTyyppi:
        LahetaTiedostopalvelimenTiedot(Asiakas);
      //merkitn asiakas tiedostopalvelimeksi jos lhettvn ip-osoite vastaa
      //asetuksissa mrtty
      KirjaaTiedostopalvelimeksiTyyppi:
        begin
          if(Asiakas.AsiakkaanSaie.RemoteHost = TiedostopalvelimenOsoite) then
            TiedostopalvelimenAsiakkuus := Asiakas;
        end;
      //lhetetn tiedostopalvelimena olevalle asiakkaalle kyttjtunnuslista
      AnnaTunnuslistaTyyppi:
        begin
          if(Asiakas = TiedostopalvelimenAsiakkuus) then
            LahetaTunnuslista;
        end;
      //ksitelln vastaanotettu lokitiedosto
      LokitiedostoTyyppi:
        begin
          TallenntaLokitiedosto(XMLPaketti);
        end;
    end;
  end;
end;

//ladataan opettajatilit XML-tiedostosta OpettajatiliListaan
procedure TFormMetapalvelin.LataaOpettajatiliLista;
var XMLDocumentTunnukset: TXMLDocument;
    OpettajatilitNode: IXMLNode;
    OpettajatiliNode: IXMLNode;
    I: Integer;
    Tunnus, Salasana: String;
begin
  OpettajatiliLista.Clear;

  XMLDocumentTunnukset := TXMLDocument.Create(Self);

  XMLDocumentTunnukset.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentTunnukset.Active := True;
  XMLDocumentTunnukset.ParseOptions := [];

  try
    //luetaan opettajatilien XML-tiedosto
    XMLDocumentTunnukset.LoadFromFile(OpettajatilitiedostonNimi);

    OpettajatilitNode := XMLDocumentTunnukset.DocumentElement;

    for I := 0 to OpettajatilitNode.ChildNodes.Count - 1 do
    begin
      //luetaan opettajatilin tunnus ja salasanan MD5 ja listn se opettajatililistaan
      OpettajatiliNode := OpettajatilitNode.ChildNodes.Get(I);
      Tunnus := OpettajatiliNode.ChildNodes['tunnus'].Text;
      Salasana := OpettajatiliNode.ChildNodes['salasana'].Text;
      OpettajatiliLista.Add(TOpettajaTili.Create(Tunnus, StringToMD5(Salasana)));
    end;
  except
    on EDOMParseError do
    begin
      MessageDlg('Opettajatilitiedostoa "'+ OpettajatilitiedostonNimi +'" ei voitu lukea!', mtError, [mbOk], 0);
    end;
  end;

  XMLDocumentTunnukset.Free;
end;

//tallennetaan OpettajatiliListan opettajatilit XML-tiedostoon
procedure TFormMetapalvelin.TallennaOpettajatiliLista;
var XMLDocumentTunnukset: TXMLDocument;
    OpettajatilitNode: IXMLNode;
    OpettajatiliNode: IXMLNode;
    TunnusNode, SalasanaNode: IXMLNode;
    I: Integer;
    Opettajatili: TOpettajaTili;
begin
  XMLDocumentTunnukset := TXMLDocument.Create(Self);

  XMLDocumentTunnukset.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentTunnukset.NodeIndentStr := XMLDokumentinSisennys;
  XMLDocumentTunnukset.Options := [doNodeAutoCreate,doNodeAutoIndent,doAttrNull,doAutoPrefix,doNamespaceDecl];
  XMLDocumentTunnukset.ParseOptions := [];
  XMLDocumentTunnukset.Active := True;
  XMLDocumentTunnukset.Version := XMLDokumentinVersio;
  XMLDocumentTunnukset.Encoding := XMLDokumentinMerkkienKoodaus;

  OpettajatilitNode := XMLDocumentTunnukset.AddChild('opettajatilit');

  for I := 0 to OpettajatiliLista.Count - 1 do
  begin
    Opettajatili := OpettajatiliLista[I] as TOpettajaTili;

    //listn opettajatili XML-dokumenttiin
    OpettajatiliNode := OpettajatilitNode.AddChild('opettajatili');

    //listn tunnus ja salasanan MD5 elementit XML-dokumenttiin
    TunnusNode := OpettajatiliNode.AddChild('tunnus');
    TunnusNode.Text := Opettajatili.Tunnus;
    SalasanaNode := OpettajatiliNode.AddChild('salasana');
    SalasanaNode.Text := MD5Print(Opettajatili.Salasana);
  end;

  //kirjoitetaan kyttjtunnukset XML-tiedostoon
  XMLDocumentTunnukset.SaveToFile(OpettajatilitiedostonNimi);
  XMLDocumentTunnukset.Free;
end;

{ TOpettajaTili }

//alustetaan opettajatili annetuilla parametreill
constructor TOpettajaTili.Create(KTunnus: String; KSalasana: MD5Digest);
begin
  FTunnus := KTunnus;
  FSalasanaMD5 := KSalasana;
end;

//tytetn lomakkeella nytettv opettajatililista OpettajatiliListan mukaiseksi
procedure TFormMetapalvelin.TaytaOpettajatiliListBox;
var I: Integer;
begin
  //tyhjennetn nytettv lista
  ListBoxOpettajatilit.Clear;

  //listn nytettvn listaan opettajatilit
  for I := 0 to OpettajatiliLista.Count - 1 do
  begin
    ListBoxOpettajatilit.AddItem((OpettajatiliLista[I] as TOpettajaTili).Tunnus, nil);
  end;
end;

//metapalvelimen portin vaihto
procedure TFormMetapalvelin.MenuItemMPPorttiClick(Sender: TObject);
var MetapalvelimenPorttiForm: TFormMetapalvelimenPortti;
begin
  //alustetaan nytettv lomake
  MetapalvelimenPorttiForm := TFormMetapalvelimenPortti.Create(Self);
  MetapalvelimenPorttiForm.Alusta(MetapalvelimenPortti, 'Metapalvelimen portti');

  //nytetn lomake
  if MetapalvelimenPorttiForm.ShowModal = mrOk then
  begin
    //Tutkitaan onko annettu portti eri kuin nyt kytss oleva.
    //Jos on vaihdetaan metapalvelimen portti.
    if(MetapalvelimenPortti <> MetapalvelimenPorttiForm.Portti) then
    begin
      MetapalvelimenPortti := MetapalvelimenPorttiForm.Portti;
      SuljeServeri;
      ServerSocket.Port := MetapalvelimenPortti;
      ServerSocket.Active := True;
      MessageDlg('Metapalvelimen portti vaihdettu!', mtInformation, [mbOk], 0);
      //tallennetaan muutetut asetukset asetustiedostoon 
      TallennaAsetustiedosto;
    end;
  end;
end;

//vaihdetaan tiedostopalvelimen portti
procedure TFormMetapalvelin.MenuItemTiedostopalvelimenPorttiClick(Sender: TObject);
var TiedostopalvelimenPorttiForm: TFormMetapalvelimenPortti;
begin
  //alustetaan nytettv lomake
  TiedostopalvelimenPorttiForm := TFormMetapalvelimenPortti.Create(Self);
  TiedostopalvelimenPorttiForm.Alusta(TiedostopalvelimenPortti, 'Tiedostopalvelimen portti');

  //nytetn lomake ja ksitelln siihen sytetyt tiedot
  if TiedostopalvelimenPorttiForm.ShowModal = mrOk then
  begin
    if(TiedostopalvelimenPortti <> TiedostopalvelimenPorttiForm.Portti) then
    begin
      TiedostopalvelimenPortti := TiedostopalvelimenPorttiForm.Portti;
      MessageDlg('Tiedostopalvelimen portti vaihdettu!', mtInformation, [mbOk], 0);
      TallennaAsetustiedosto;
    end;
  end;
end;

//luodaan uusi opettajatili
procedure TFormMetapalvelin.MenuItemLuoOpettajaClick(Sender: TObject);
var TilinLuontiForm: TFormLuoOpettajatili;
    Tunnus, Salasana: String;
begin
  //alustetaan nytettv lomake
  TilinLuontiForm := TFormLuoOpettajatili.Create(Self);
  //nytetn lomake ja ksitelln siihen sytetyt tiedot
  if(TilinLuontiForm.ShowModal = mrOk) then
  begin
    Tunnus := TilinLuontiForm.Tunnus;
    Salasana := TilinLuontiForm.Salasana;

    OpettajatiliLista.Add(TOpettajaTili.Create(Tunnus, MD5String(Salasana)));

    //pivitetn metapalvelimella nytett opettajatililista
    TaytaOpettajatiliListBox;
    //tallenneetaan OpettajatiliLista XML-muotoiseen opettajatilitiedostoon
    TallennaOpettajatiliLista;

    TilinLuontiForm.Free;
  end;
end;

//vaihdetaan metapalvelimen salasana
procedure TFormMetapalvelin.MenuItemMPSalasanaClick(Sender: TObject);
var MetapalvelimenSalasanaForm: TFormMetapalvelimenSalasana;
    UusiSalasanaMD5: MD5Digest;
    SalasananPituus: Integer;
    LomakkeenPalaute: Integer;
begin
  //alustetaan nytettv lomake
  MetapalvelimenSalasanaForm := TFormMetapalvelimenSalasana.Create(Self);
  MetapalvelimenSalasanaForm.Alusta('', SalasananMaksimipituus, 'Metapalvelimen salasana', 'Vaihda salasana', False);

  //nytetn lomake
  LomakkeenPalaute := MetapalvelimenSalasanaForm.ShowModal;
  //ksitelln siihen sytetyt tiedot
  if LomakkeenPalaute = mrOk then
  begin
    UusiSalasanaMD5 := MD5String(MetapalvelimenSalasanaForm.Salasana);
    if(MD5Match(MetapalvelimenSalasanaMD5, UusiSalasanaMD5)) then
    begin
      MessageDlg('Antamasi salasana on sama kuin vanha salasana!', mtInformation, [mbOk], 0);
      Exit;
    end;

    SalasananPituus := Length(MetapalvelimenSalasanaForm.Salasana);

    if(SalasananPituus = 0) then
    begin
      MetapalvelimellaSalasana := False;
      MessageDlg('Metapalvelimen salasana poistettu kytst!', mtInformation, [mbOk], 0);
      TallennaAsetustiedosto;
      Exit;
    end;

    if(SalasananPituus < SalasananMinimipituus) then
    begin
      MessageDlg('Antamasi salasana on liian lyhyt!', mtInformation, [mbOk], 0);
      Exit;
    end;

    MetapalvelimellaSalasana := True;
    MetapalvelimenSalasanaMD5 := UusiSalasanaMD5;
    MessageDlg('Metapalvelimen salasana vaihdettu!', mtInformation, [mbOk], 0);
    TallennaAsetustiedosto;
  end
  else if LomakkeenPalaute = mrCancel then
  begin
    MessageDlg('Antamasi salasana ja salasana uudestaan eivt olleet samat!', mtInformation, [mbOk], 0);
    Exit;
  end;
end;

//vaihdetaan tiedostopalvelien osoite
procedure TFormMetapalvelin.MenuItemTiedostopalvelimenOsoiteClick(
  Sender: TObject);
var MetapalvelimenSalasanaForm: TFormMetapalvelimenSalasana;
    const IPOsoitteenMaksimipituus: Integer = 15;
begin
  //alustetaan nytettv lomake
  MetapalvelimenSalasanaForm := TFormMetapalvelimenSalasana.Create(Self);
  MetapalvelimenSalasanaForm.Alusta(TiedostopalvelimenOsoite, IPOsoitteenMaksimipituus, 'Metapalvelimen salasana', 'Vaihda salasana', False);

  //nytetn lomake ja ksitelln siihen sytetyt tiedot
  if(MetapalvelimenSalasanaForm.ShowModal = mrOk) then
  begin
    if(MetapalvelimenSalasanaForm.Salasana <> '') then
    begin
      if(MetapalvelimenSalasanaForm.Salasana <> TiedostopalvelimenOsoite) then
      begin
        TiedostopalvelimenOsoite := MetapalvelimenSalasanaForm.Salasana;
        MessageDlg('Tiedostopalvelimen osoite vaihdettu!', mtInformation, [mbOk], 0);
        TallennaAsetustiedosto;
      end;
    end
    else
      MessageDlg('Anna tiedostopalvelimen osoite!', mtWarning, [mbOk], 0);
  end;
end;

//ladataan metapalvelimen asetukset XML-tiedostosta
procedure TFormMetapalvelin.LataaAsetustiedosto;
var XMLDocumentAsetustiedosto: TXMLDocument;
    JuuriNode, ApuNode: IXMLNode;
    Salasana: String;
begin
  XMLDocumentAsetustiedosto := TXMLDocument.Create(Self);

  XMLDocumentAsetustiedosto.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentAsetustiedosto.Active := True;
  XMLDocumentAsetustiedosto.ParseOptions := [];

  try
    //luetaan opettajatilien XML-tiedosto
    XMLDocumentAsetustiedosto.LoadFromFile(MetaAsetustiedostonNimi);

    JuuriNode := XMLDocumentAsetustiedosto.DocumentElement;

    ApuNode := JuuriNode.ChildNodes['metapalvelin'];

    MetapalvelimenPortti := StrToInt(ApuNode.ChildNodes['portti'].Text);

    Salasana := ApuNode.ChildNodes['salasana'].Text;
    if(Salasana <> '') then
    begin
      try
        MetapalvelimenSalasanaMD5 := StringToMD5(Salasana);
        MetapalvelimellaSalasana := True;
      except
        on EConvertError do
          MetapalvelimellaSalasana := False;
      end;
    end
    else
      MetapalvelimellaSalasana := False;

    ApuNode := JuuriNode.ChildNodes['tiedostopalvelin'];
    TiedostopalvelimenOsoite := ApuNode.ChildNodes['osoite'].Text;
    TiedostopalvelimenPortti := StrToInt(ApuNode.ChildNodes['portti'].Text);
  except
    on EDOMParseError do
    begin
      MessageDlg('Asetustiedostoa "'+ MetaAsetustiedostonNimi +'" ei voitu lukea!', mtError, [mbOk], 0);
    end;
  end;

  ServerSocket.Port := MetapalvelimenPortti;

  XMLDocumentAsetustiedosto.Free;
end;

//tallennetaan metapalvelimen asetukset XML-tiedostoon
procedure TFormMetapalvelin.TallennaAsetustiedosto;
var XMLDocumentAsetustiedosto: TXMLDocument;
    JuuriNode, ApuNode, ApuNode2: IXMLNode;
begin
  XMLDocumentAsetustiedosto := TXMLDocument.Create(Self);

  XMLDocumentAsetustiedosto.DOMVendor := GetDOMVendor(XMLDokumentinDOM);
  XMLDocumentAsetustiedosto.NodeIndentStr := XMLDokumentinSisennys;
  XMLDocumentAsetustiedosto.Options := [doNodeAutoCreate,doNodeAutoIndent,doAttrNull,doAutoPrefix,doNamespaceDecl];
  XMLDocumentAsetustiedosto.ParseOptions := [];
  XMLDocumentAsetustiedosto.Active := True;
  XMLDocumentAsetustiedosto.Version := XMLDokumentinVersio;
  XMLDocumentAsetustiedosto.Encoding := XMLDokumentinMerkkienKoodaus;

  JuuriNode := XMLDocumentAsetustiedosto.AddChild('asetukset');

  ApuNode := JuuriNode.AddChild('metapalvelin');
  ApuNode2 := ApuNode.AddChild('portti');
  ApuNode2.Text := IntToStr(MetapalvelimenPortti);
  ApuNode2 := ApuNode.AddChild('salasana');
  if MetapalvelimellaSalasana then
    ApuNode2.Text := MD5Print(MetapalvelimenSalasanaMD5);

  ApuNode := JuuriNode.AddChild('tiedostopalvelin');
  ApuNode2 := ApuNode.AddChild('osoite');
  ApuNode2.Text := TiedostopalvelimenOsoite;
  ApuNode2 := ApuNode.AddChild('portti');
  ApuNode2.Text := IntToStr(TiedostopalvelimenPortti);

  XMLDocumentAsetustiedosto.SaveToFile(MetaAsetustiedostonNimi);
  XMLDocumentAsetustiedosto.Free;
end;

//ksitelln asiakkaan socketin palauttamat virheet
procedure TFormMetapalvelin.ServerSocketClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  //virhetilanteessa poistetaan asiakas Asikkaat-listasta
  try
  except
    on ESocketError do
    begin
      PoistaAsiakas(Socket);
    end;
  end;

  ErrorCode := 0;
end;

//uuden yhteyden hyvksymisen jlkeen lhetetn kirjautimisviesti
procedure TFormMetapalvelin.ServerSocketAccept(Sender: TObject; Socket: TCustomWinSocket);
var Asiakas: TAsiakas;
begin
  Asiakas := EtsiAsiakas(Socket);
  if(Asiakas <> nil) then
    LahetaKirjaudu(Asiakas);
end;

//avataan tiedostopalvelimen sisllnpoistolomake
procedure TFormMetapalvelin.MenuItemPoistaSisaltoaClick(Sender: TObject);
var FormSisallonPoistaminen: TFormSisallonPoistaminen;
begin
  FormSisallonPoistaminen := TFormSisallonPoistaminen.Create(self);
  FormSisallonPoistaminen.Alusta(FTPClientTiedostopalvelin);
  FormSisallonPoistaminen.ShowModal;
  FormSisallonPoistaminen.Free;
end;

//poistetaan lomakkeella nytettvst pelilistasta valittu pelisessio
procedure TFormMetapalvelin.ButtonPoistaPelisessioClick(Sender: TObject);
begin
  if(ListBoxPelit.ItemIndex >= 0) then
  begin
    Pelit.Delete(ListBoxPelit.ItemIndex);
    ListBoxPelit.Items.Delete(ListBoxPelit.ItemIndex);
  end;
end;

//lukitaan metapalvelin
procedure TFormMetapalvelin.LukitseMetapalvelin;
var PaaKirjautuminen: TFormMetapalvelimenSalasana;
begin
  PaaKirjautuminen := TFormMetapalvelimenSalasana.Create(Self);
  PaaKirjautuminen.Alusta('', SalasananMaksimipituus, 'Anna metapalvelimen salasana', 'Avaa', True);

  //Jos salasana ei ole oikea nytettn uudestaan lukituslomake.
  //Muuten suljetaan lukituslomake
  if(PaaKirjautuminen.ShowModal = mrOk) then
  begin
    if(MetapalvelimellaSalasana) then
    begin
      if(MD5Match(MD5String(PaaKirjautuminen.Salasana), MetapalvelimenSalasanaMD5) = false) then
      begin
        PaaKirjautuminen.Free;
        LukitseMetapalvelin;
      end;
    end;
  end
  else
  begin
    PaaKirjautuminen.Free;
    LukitseMetapalvelin;
  end;

  PaaKirjautuminen.Free;
end;

//avataan lukituslomake
procedure TFormMetapalvelin.LukitseMenuClick(Sender: TObject);
begin
  LukitseMetapalvelin;
end;

//lheten tiedostopalvelimen tiedot niit pyytvlle asiakkaalle
procedure TFormMetapalvelin.LahetaTiedostopalvelimenTiedot(Asiakas: TAsiakas);
begin
  if(Asiakas.Kirjautunut) then
    Asiakas.LahetaPaketti(TTiedostopalvelimenTiedot.Create(TiedostopalvelimenOsoite, TiedostopalvelimenPortti));
end;

//lhetetn tiedostopalvelimelle kyttjtunnuslista
procedure TFormMetapalvelin.LahetaTunnuslista;
var Tunnukset: TStringList;
    SalasanatMD5: TStringList;
    I: Integer;
    Tunnus: TKayttajatunnus;
begin
  if (TiedostopalvelimenAsiakkuus <> nil) then
  begin
    Tunnukset := TStringList.Create;
    SalasanatMD5 := TStringList.Create;
    for I := 0 to KayttajatunnusLista.Count - 1 do
    begin
      Tunnus := KayttajatunnusLista[I] as TKayttajatunnus;
      Tunnukset.Add(Tunnus.Tunnus);
      SalasanatMD5.Add(MD5Print(Tunnus.Salasana));
    end;

    TiedostopalvelimenAsiakkuus.LahetaPaketti(TTunnusLista.Create(Tunnukset, SalasanatMD5));
  end;
end;

//poistetaan pttynyt peli Pelit-listasta
procedure TFormMetapalvelin.PeliPaattynyt(Paketti: TPeliPaattynyt; Asiakas: TAsiakas);
var I: Integer;
    Peli: TMPeli;
begin
  for I := 0 to Pelit.Count - 1 do
  begin
    Peli := Pelit[I] as TMPeli;

    if((Peli.PelinNimi = Paketti.LoginNimi) and (Peli.PelinLuojanTunnus = Asiakas.AsiakkaanTunnus.Tunnus)) then
    begin
      Pelit.Delete(I);
      ListBoxPelit.Items.Delete(I);
      ListBoxPelit.Update;
      //lis arvostelujen ksittely
      Exit;
    end;
  end;

  FreeAndNil(Paketti);
end;

//tallennetaan XML-muotoinen loki XML-tiedostoksi
procedure TFormMetapalvelin.TallenntaLokitiedosto(XMLPaketti: String);
var XMLTulkki: TXMLDocument;
    Juuri, TiedotNode, AikaNode, PelaajatNode, PelinLuojaNode, ApuNode: IXMLNode;
    LokitiedostonNimi: String;
begin
  LokitiedostonNimi := LokitiedostonPolku;

  XMLTulkki := TXMLDocument.Create(Self);
  XMLTulkki.Active := True;
  XMLTulkki.LoadFromXML(XMLPaketti);

  Juuri := XMLTulkki.DocumentElement;

  TiedotNode := Juuri.ChildNodes['pelisession_tiedot'];
  AikaNode := TiedotNode.ChildNodes['aika'];

  ApuNode := AikaNode.ChildNodes['vuosi'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;
  ApuNode := AikaNode.ChildNodes['kuukausi'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;
  ApuNode := AikaNode.ChildNodes['paiva'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;

  ApuNode := AikaNode.ChildNodes['tunti'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;
  ApuNode := AikaNode.ChildNodes['minuutti'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;
  ApuNode := AikaNode.ChildNodes['sekuntti'];
  LokitiedostonNimi := LokitiedostonNimi + ApuNode.Text;

  PelaajatNode := TiedotNode.ChildNodes['pelaajat'];
  PelinLuojaNode := PelaajatNode.ChildNodes['pelaaja'];
  ApuNode := PelinLuojaNode.ChildNodes['nimi'];
  LokitiedostonNimi := LokitiedostonNimi +'_'+ ApuNode.Text;

  ApuNode := TiedotNode.ChildNodes['nimi'];
  LokitiedostonNimi := LokitiedostonNimi +'_'+ ApuNode.Text;

  LokitiedostonNimi := LokitiedostonNimi + '.xml';

  XMLTulkki.SaveToFile(LokitiedostonNimi);

  XMLTulkki.Active := False;
  XMLTulkki.Free;
end;

//lhetetn parametrin annetulle asiakkaalle chattaajalista
procedure TFormMetapalvelin.LahetaChattaajaLista(Asiakas: TAsiakas);
var ChattaajaLista: TStringList;
    ListaAsiakas: TAsiakas;
    I: Integer;
begin
  ChattaajaLista := TStringList.Create;

  //muodostetaan asiakkaista chattaajalista
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    ListaAsiakas := Asiakkaat.Items[I] as TAsiakas;
    //jos asiakas on kirjautunut ja ei ole pelaamassa lhetetn paketti
    if(ListaAsiakas.Kirjautunut and not ListaAsiakas.Pelaamassa) then
      ChattaajaLista.Add(ListaAsiakas.AsiakkaanTunnus.PelaajanNimi);
  end;

  //lhetetn chattaajalista asiakkaalle
  Asiakas.LahetaPaketti(TChattaajaLista.Create(ChattaajaLista));

  FreeAndNil(ChattaajaLista);
end;

//lhetetn chattaajalista kaikille asiakkaalle
procedure TFormMetapalvelin.LahetaChattaajaListaKaikille;
var ChattaajaLista: TStringList;
    Asiakas: TAsiakas;
    I: Integer;
begin
  ChattaajaLista := TStringList.Create;

  //muodostetaan asiakkaista chattaajalista
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    Asiakas := Asiakkaat.Items[I] as TAsiakas;
    //jos asiakas on kirjautunut ja ei ole pelaamassa lhetetn paketti
    if(Asiakas.Kirjautunut and not Asiakas.Pelaamassa) then
      ChattaajaLista.Add(Asiakas.AsiakkaanTunnus.PelaajanNimi);
  end;

  //lhetetn chattaajalista kaikille asiakkaalle
  LahetaKaikilleAsiakkaille(TChattaajaLista.Create(ChattaajaLista));
end;

//kydn Asiakkaat-lista lpi ja poistetaan ne, ketk eivt ole lhettneet
//ping-viesti riittvn usein
procedure TFormMetapalvelin.TimerPingTimer(Sender: TObject);
var I: Integer;
    Asiakas: TAsiakas;
    NykyinenAika: TDateTime;
    //odotettava aika 30 sekunttia ennen kuin asiakas poistetaan
    const PingEpaonnisumisienMaksimiaika: Integer = 30 * 1000;
begin
  NykyinenAika := GetTime;

  //kydn Asiakkaat-lista lpi ja poistetaan ne kenenk yhteys katsotaan katkenneen
  for I := 0 to Asiakkaat.Count - 1 do
  begin
    Asiakas := Asiakkaat.Items[I] as TAsiakas;
    //jos asiakas ei ole lhettnyt ping-viesti 30 sekunttiin oletetaan yhteyden katkenneen
    if(not WithinPastMilliSeconds(NykyinenAika, Asiakas.ViimeisinPing, PingEpaonnisumisienMaksimiaika)) then
    begin
      //poistetaan asiakas ja poistutaan
      //seuraava poisto tehdn seuraavalla ajastimen kierroksella
      PoistaAsiakas(Asiakas.AsiakkaanSaie);
      Exit;
    end;
  end;
end;

end.

