// Talariuksen uusien kysymysten luomiseen ja editointiin liittyvt lomake
// monivalintakysymyksille.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 15.2.2006
//

// Tiedettyj bugeja:
// Vastausvaihtoehtojen ScrollBarin kanssa on piirto-ongelmia, jos se
// pyyhitn pois jollakin toisella ikkunalla. Asia korjautuu, jos ikkunan
// pienent nkyvist. (Tlle ei voi kovin helposti tehd mitn!) Kytnnss
// ongelma ilmenee vain jos on listty tarpeeksi vastausvaihtoehtoja ja sitten
// listn kuvaa, nt, videota tms. Tmn asian korjaamiseksi on tehty
// viritys vastausvaihtoehtojen yhteydess kuvien lismiseen, miss bugi
// ilmenee kaikista selvimmin. Voitaisiin tietysti tehd sama homma
// muillekin. --> TEHTY!
//
// Jos formin kokoa muutetaan, uusien vrien vastausten lisminen
// alkaa kyttytymn kummallisesti. Listyt vastaukset jvt piiloon ja
// menevt muutenkin jrjestyksen puolesta sekaisin. Tt ei kuitenkaan
// tapahdu jokaisella formin koolla. Sama bugi on ilmennyt jokaisella
// kolmella tai neljll Talariuksen kehityskerralla ja se on korjattu
// aina jokaisella kerralla erikseen, mutta se tulee silti takaisin...
// (eli bugia ei ole korjattu oikein). Tll kertaa ongelmaa kierretn
// siten, ett kyttj ei voi muuttaa formin kokoa.

unit MoniValintaKysymysForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Kysymysluokat, ExtDlgs, ComCtrls,
  Contnrs;

type
  TFormMonivalintaKysymys = class(TForm)
    ButtonOK: TButton;
    ButtonPeruuta: TButton;
    SpeedButtonLisaaVideo: TSpeedButton;
    SpeedButtonLisaaAani: TSpeedButton;
    SpeedButtonLisaaKuva: TSpeedButton;
    LabelMonivalintaKysymys: TLabel;
    ImageMonivalintaKysymyskuvaVasen: TImage;
    ImageMonivalintaKysymyskuvaOikea: TImage;
    SpeedButtonPoistaKuva: TSpeedButton;
    SpeedButtonPoistaAani: TSpeedButton;
    SpeedButtonPoistaVideo: TSpeedButton;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialogVideo: TOpenDialog;
    OpenDialogAani: TOpenDialog;
    PanelOtsikko: TPanel;
    PanelNappulat: TPanel;
    PanelNapitAlusta: TPanel;
    PanelTietoTeksti: TPanel;
    ScrollBoxAlusta: TScrollBox;
    EditKysymys: TEdit;
    PanelKysymys: TPanel;
    LabelKysymys: TLabel;
    PanelOikeavastaus: TPanel;
    LabelOikeaVastaus: TLabel;
    EditOikeaVastaus: TEdit;
    BevelRaja: TBevel;
    PanelVaaraVastaus: TPanel;
    LabelEnsVaaraVastaus: TLabel;
    EditEnsVaaraVastaus: TEdit;
    ButtonLisaaVaara: TButton;
    ButtonPoistaVaara: TButton;
    SpeedButtonVastausKuva_2: TSpeedButton;
    SpeedButtonVastauskuva_1: TSpeedButton;
    ImageGlyphPoista: TImage;
    ImageGlyphLisaa: TImage;
    Label1: TLabel;
    Label2: TLabel;
    procedure ButtonOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MemoTietotekstiChange(Sender: TObject);
    procedure SpeedButtonLisaaKuvaClick(Sender: TObject);
    procedure SpeedButtonPoistaKuvaClick(Sender: TObject);
    procedure SpeedButtonLisaaAaniClick(Sender: TObject);
    procedure SpeedButtonPoistaAaniClick(Sender: TObject);
    procedure SpeedButtonLisaaVideoClick(Sender: TObject);
    procedure SpeedButtonPoistaVideoClick(Sender: TObject);
    procedure ButtonLisaaVaaraClick(Sender: TObject);
    procedure EditMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonPoistaVaaraClick(Sender: TObject);
    procedure EditChange(Sender: TObject);
    procedure EditExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButtonVastauskuvaClick(Sender: TObject);
  private
    FMuokattuSisalto : Boolean;
    FVideonPolku: string;
    FAanenPolku: string;
    FKuvanPolku: string;
    PaneeliLista : TObjectList; // Lista paneelien osoittimista vri vastauksia varten
    FVastauksenKuvapolku : TStringlist; // Vastauksiin liitettvien kuvien polut
    function puraTag(Sender : TObject) : integer;
    procedure hoidaScrollBarNakyvaksi;

  public
    { Public declarations }
  published
    property MuokattuSisalto : Boolean read FMuokattuSisalto write FMuokattuSisalto;
    property KuvanPolku : string read FKuvanPolku write FKuvanPolku;
    property AanenPolku : string read FAanenPolku write FAanenPolku;
    property VideonPolku : string read FVideonPolku write FVideonPolku;
    property VastauksenKuvapolku : TStringlist read FVastauksenKuvaPolku write FVastauksenKuvaPolku;

  end;

var
  FormMonivalintaKysymys: TFormMonivalintaKysymys;

procedure MuokkaaMonivalintaKysymys(MonivalintaKysymysRakenne:TMonivalintaKysymys; OnkoUusiMonivalintaKysymys:Boolean; var OnkoMuokattu:Boolean);

implementation

uses KysymystenTekoPaaForm;

const Vastausvaihtoehtoja=10000; // Ilmoittaa montako vaihtoehtoa monivalintakysymyksiin voidaan maksimissaan antaa.

{$R *.dfm}

procedure MuokkaaMonivalintaKysymys(MonivalintaKysymysRakenne:TMonivalintaKysymys; OnkoUusiMonivalintaKysymys:Boolean; var OnkoMuokattu:Boolean);
var
  f: TFormMonivalintaKysymys;
  p: TPanel;
  e: TEdit;
  l: TLabel;
  i,j,k, Apukoko: Integer;
  n : TSpeedButton;
begin
  // MUISTA alkuun tutkia, onko uusi ruutu vai editoidaanko!!!
  f := TFormMonivalintaKysymys.Create(nil);
  f.MuokattuSisalto:=true; // Asetetaan trueksi, jotta uuden saa vain listty OK:lla
  if not OnkoUusiMonivalintaKysymys then begin
    f.MuokattuSisalto:=false; // Editoitavaa ei ole heti muokattu...
    // Muokataan lomaketta editointiasuun
    f.EditKysymys.Text := MonivalintaKysymysRakenne.Kysymys;
    f.Caption:='Monivalintakysymyksen muokkaaminen';
    // Sytytetn oikeat napit sen mukaan, onko editoitavaan avoimeen kysymykseen
    // liitetty kuvia, ni tai videota
    if ( MonivalintaKysymysRakenne.KuvanPolku <> '' ) then begin
      f.SpeedButtonPoistaKuva.Visible:=true;
      f.SpeedButtonLisaaKuva.Visible:=false;
    end;
    if ( MonivalintaKysymysRakenne.AanenPolku <> '' ) then begin
      f.SpeedButtonPoistaAani.Visible:=true;
      f.SpeedButtonLisaaAani.Visible:=false;
    end;
    if ( MonivalintaKysymysRakenne.VideonPolku <> '' ) then begin
      f.SpeedButtonPoistaVideo.Visible:=true;
      f.SpeedButtonLisaaVideo.Visible:=false;
    end;
    // Puretaan vanhat polkutiedot
    f.KuvanPolku:=MonivalintaKysymysRakenne.KuvanPolku;
    f.AanenPolku:=MonivalintaKysymysRakenne.AanenPolku;
    f.VideonPolku:=MonivalintaKysymysRakenne.VideonPolku;
    f.EditOikeaVastaus.Text := MonivalintaKysymysRakenne.OikeaVastaus;
    f.EditEnsVaaraVastaus.Text := MonivalintaKysymysRakenne.VaaratVastaukset[0];
    // Vastausvaihtoehtoihin liitettvien kuvien polut
    f.VastauksenKuvapolku.clear;
    f.VastauksenKuvapolku.Add(MonivalintaKysymysrakenne.VastauksenKuvapolku[0]);
    f.VastauksenKuvapolku.Add(MonivalintaKysymysrakenne.VastauksenKuvapolku[1]);
    // Asetetaan mys napit oikeaan asentoonsa...
    if (MonivalintaKysymysrakenne.VastauksenKuvapolku[0] <> '') then begin
      f.SpeedButtonVastauskuva_1.Glyph:=f.ImageGlyphPoista.Picture.Bitmap;
      f.SpeedButtonVastauskuva_1.Tag:=f.SpeedButtonVastauskuva_1.Tag+Vastausvaihtoehtoja;
    end else
      f.SpeedButtonVastauskuva_1.Glyph:=f.ImageGlyphLisaa.Picture.Bitmap;
    if (MonivalintaKysymysrakenne.VastauksenKuvapolku[1] <> '') then begin
      f.SpeedButtonVastauskuva_2.Glyph:=f.ImageGlyphPoista.Picture.Bitmap;
      f.SpeedButtonVastauskuva_2.Tag:=f.SpeedButtonVastauskuva_2.Tag+Vastausvaihtoehtoja;
    end else
      f.SpeedButtonVastauskuva_2.Glyph:=f.ImageGlyphLisaa.Picture.Bitmap;

    Apukoko:=f.ScrollBoxAlusta.VertScrollBar.Range;
    for k := 1 to MonivalintaKysymysRakenne.VaaratVastaukset.Count-1 do begin

      // Luodaan uusi vr vastaus
      // Ensin tehdn paneeli alustaksi
      p := TPanel.Create(f);
      p.Parent := f.ScrollBoxAlusta;
      p.Align := alTop;
      p.Top := p.Parent.ClientHeight + Apukoko; // Synnytetn boksin pohjalle
      p.Height := f.PanelVaaraVastaus.Height;
      p.BevelOuter := bvNone;

      l := TLabel.Create(f);
      l.Parent := p;
      l.Top := 0;
      l.Left := 4;
      l.Caption := intToStr(k+1) + '. Vr vastaus';
      l.Font.Size := 10;
      l.Font.Style := [fsBold];

      // Luodaan paneelin sisn edit-boksi mihin vr vastaus voidaan kirjoittaa
      e := TEdit.Create(f);
      e.Parent := p;
      e.Top := 20;
      e.Left := 4;
      e.Width := f.EditKysymys.Width;
      e.Anchors := [akLeft, akTop, akRight];
      e.Font.Size := 12;
      e.Font.Name := 'Courier';
      e.Text := MonivalintaKysymysRakenne.VaaratVastaukset[k];
      e.OnMouseUp := f.EditMouseUp;
      e.OnChange := f.EditChange;
      e.OnExit := f.EditExit;

      // Luodaan nappi, jolla liitetn kuva vastausvaihtoehdon yhteyteen
      // Indeksikikkailua: formilla valmiina 2 vaihtoehtoa, indeksi alkaa nollasta.
      // Haluttu seuraava indeksi on 2. k alkaa kuitenkin 1:st, joten siihen tulee
      // list 1.
      f.VastauksenKuvapolku.Add(MonivalintaKysymysrakenne.VastauksenKuvapolku[k+1]); // Uutta nappia varten uusi merkkijono
      n := TSpeedButton.Create(f);
      n.Parent := p;
      n.Anchors:=f.SpeedButtonVastauskuva_1.Anchors;
      n.Width:=f.SpeedButtonVastauskuva_1.Width;
      n.Height:=f.SpeedButtonVastauskuva_1.Height;
      n.Top:=f.SpeedButtonVastauskuva_1.Top;
      n.Left:=f.SpeedButtonVastauskuva_1.Left;
      n.OnClick:=f.SpeedButtonVastauskuvaClick;
      // napille tagi ja sopiva kuva siihen nhden (voidaan kytt Vastauksenkuvapolkua
      // laskurina, koska listn aina loppuun ja listaan listtiin tt nappia varten
      // polku hetki sitten.
      if (f.VastauksenKuvapolku[f.VastauksenKuvapolku.Count-1] <> '') then begin
        n.Glyph:=f.ImageGlyphPoista.Picture.Bitmap;
        n.Tag:=(f.VastauksenKuvaPolku.Count-1)+Vastausvaihtoehtoja; // Katso tag-kikkailu tiedoston alusta!
      end else begin
        n.Glyph:=f.ImageGlyphLisaa.Picture.Bitmap;
        n.Tag:=f.VastauksenKuvaPolku.Count-1; // Asetetaan tag. TRKE!
      end;

      if ((p.Top + p.Height)>=f.ScrollBoxAlusta.Height) then begin
        // Kasvatetaan vierityspalkin koon ilmaisevaa apumuuttujaa.
        // Jos kasvatettaisiin suoraan vierityspalkin kokoa, niin silloin
        // TEditien koot jvt jostain syyst liian pitkiksi.
        Apukoko:=Apukoko + p.ClientHeight;
        //f.ScrollBoxAlusta.VertScrollBar.Range := f.ScrollBoxAlusta.VertScrollBar.Range + p.ClientHeight;
        //f.ScrollBoxAlusta.VertScrollBar.Position := f.ScrollBoxAlusta.VertScrollBar.Range {- ScrollBoxAlusta.ClientHeight};
      end;
      f.PaneeliLista.Add(p);

    end;
    f.ScrollBoxAlusta.VertScrollBar.Range:=Apukoko; // Asetetaan varsinainen koko

  end;
  // Jos painetaan Ok-nappia, tehdn tarvittavat toimenpiteet
  if ( f.ShowModal = mrOK ) then begin
    // kopiodaan olioon tiedot lomakkeelta
    if MonivalintaKysymysRakenne<>nil then begin

      // Kopioidaan polut tietorakenteeseen
      MonivalintaKysymysRakenne.Kysymys:=f.EditKysymys.Text;
      MonivalintaKysymysRakenne.KuvanPolku:=f.KuvanPolku;
      MonivalintaKysymysRakenne.AanenPolku:=f.AanenPolku;
      MonivalintaKysymysRakenne.VideonPolku:=f.VideonPolku;

      MonivalintaKysymysRakenne.OikeaVastaus := f.EditOikeaVastaus.Text;

      // Tyhjtn vanha lista vrist kysymyksist aluksi
      MonivalintaKysymysRakenne.VaaratVastaukset.Clear;
      MonivalintaKysymysRakenne.VaaratVastaukset.Add(f.EditEnsVaaraVastaus.Text);

      // Kydn lpi paneelistan alkiot ja kopioidaan paneelien omistamien
      // edittien sisltmt vrt vastaukset monivalintakysymyksen varsinaiseen
      // tietorakenteeseen
      for i := 0 to f.PaneeliLista.Count-1 do begin
        if f.PaneeliLista[i] is TPanel then begin
          p := TPanel(f.PaneeliLista[i]);
          // Etsitn edit-boksi paneelin omistamista kontrolleista
          for j := 0 to p.ControlCount-1 do begin
            if p.Controls[j] is TEdit then begin
              MonivalintaKysymysRakenne.VaaratVastaukset.Add(TEdit(p.Controls[j]).Text);
            end;
          end;
        end;
      end;

      // Puretaan tietorakenteeseen mys polut niist kuvista, jotka on
      // mahdollisesti mrtty vastausvaihtoehtojen yhteyteen.
      MonivalintaKysymysrakenne.VastauksenKuvapolku.Clear;
      for i:=0 to f.VastauksenKuvapolku.Count-1 do begin
        MonivalintaKysymysrakenne.VastauksenKuvapolku.Add(f.VastauksenKuvapolku[i]);
      end;
    end;  
    // Asetetaan viesti muokatusta tai muokkaamattomasta
    // sisllst KysymystenTekoPaaFormille.
    OnkoMuokattu:=f.MuokattuSisalto;
  end
  // Jos on painettu Cancel-nappia, ilmoitetaan tieto siten
  // ettei muokkausta ole tapahtunut. Tm siksi, ettei
  // KysymystenTekoPaaFormilla aleta kopioimaan tietoja
  // kopio-oliosta oikeaan olioon.
  else OnkoMuokattu := false;
  f.Free;
end;

procedure TFormMonivalintaKysymys.ButtonOKClick(Sender: TObject);
begin
  //FormKysymystenTekeminen.ListBoxKysymyslista.Items.Add(EditMonivalintaKysymysTeksti.Text);
end;

procedure TFormMonivalintaKysymys.FormCreate(Sender: TObject);
begin
  // Luodaan lista paneelien osoittimista vri vastauksia varten
  PaneeliLista := TObjectList.Create;
  // Luodaan lista ilmoittamaan vastauksen polkuja
  VastauksenKuvapolku := TStringlist.Create;
  // Listn listaan kaksi tyhj alkuun, koska formilla on aina kaksi
  // vastausta, joihin voi mahdollisesti list kuvan
  VastauksenKuvapolku.Add('');
  VastauksenKuvapolku.Add('');

  MuokattuSisalto:=false;
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);
end;

procedure TFormMonivalintaKysymys.MemoTietotekstiChange(Sender: TObject);
begin
  // Muokattaessa asetetaan muokkausta kuvaava muuttuja oikeaan arvoonsa
  MuokattuSisalto:=true;
end;

procedure TFormMonivalintaKysymys.SpeedButtonLisaaKuvaClick(Sender: TObject);
begin
  if not OpenPictureDialog.Execute then begin
    hoidaScrollBarNakyvaksi;
    exit;
  end;
  KuvanPolku := OpenPictureDialog.FileName;
  SpeedButtonLisaaKuva.Visible:=false;
  SpeedButtonPoistaKuva.Visible:=true;
  MuokattuSisalto:=true;
  hoidaScrollBarNakyvaksi;
end;

procedure TFormMonivalintaKysymys.SpeedButtonPoistaKuvaClick(Sender: TObject);
begin
  KuvanPolku:='';
  SpeedButtonPoistaKuva.Visible:=false;
  SpeedButtonLisaaKuva.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormMonivalintaKysymys.SpeedButtonLisaaAaniClick(Sender: TObject);
begin
  if not OpenDialogAani.Execute then begin
    exit;
    hoidaScrollBarNakyvaksi;
  end;
  AanenPolku := OpenDialogAani.FileName;
  SpeedButtonLisaaAani.Visible:=false;
  SpeedButtonPoistaAani.Visible:=true;
  MuokattuSisalto:=true;
  hoidaScrollBarNakyvaksi;
end;

procedure TFormMonivalintaKysymys.SpeedButtonPoistaAaniClick(Sender: TObject);
begin
  AanenPolku:='';
  SpeedButtonPoistaAani.Visible:=false;
  SpeedButtonLisaaAani.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormMonivalintaKysymys.SpeedButtonLisaaVideoClick(Sender: TObject);
begin
  if not OpenDialogVideo.Execute then begin
    exit;
    hoidaScrollBarNakyvaksi;
  end;
  VideonPolku := OpenDialogVideo.FileName;
  SpeedButtonLisaaVideo.Visible:=false;
  SpeedButtonPoistaVideo.Visible:=true;
  MuokattuSisalto:=true;
  hoidaScrollBarNakyvaksi;
end;

procedure TFormMonivalintaKysymys.SpeedButtonPoistaVideoClick(Sender: TObject);
begin
  VideonPolku:='';
  SpeedButtonPoistaVideo.Visible:=false;
  SpeedButtonLisaaVideo.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormMonivalintaKysymys.ButtonLisaaVaaraClick(Sender: TObject);
var
  p: TPanel; // alustapaneeli
  l: TLabel; // vastausvaihtoehdon nimi ja numero
  e: TEdit;  // itse vaihtoehto
  n: TSpeedButton; // nappi kuvan lismiseksi
begin
  // Varmistetaan, ettei voida list yli 10000:tta vastausvaihtoehtoa.
  // Tm kytnnss mukana tag-virityksen takia (katso kommentit ohjelman alusta).
  // Hihavakio 2 tulee tulee siit, ett lomakkeella on aina vhintn 2
  // vastausvaihtoehtoa, eli 2:lla vhennetty vaihtoehtojen mr on tllin
  // kokonaisuudessaan Vastausvaihtoehtojen ilmoittaman vakion mr.
  if Paneelilista.Count >= Vastausvaihtoehtoja-2 then exit;

  MuokattuSisalto := true;

  // Vieritetn ensin pohjalle, ettei list uutta keskelle
  ScrollBoxAlusta.VertScrollBar.Position := ScrollBoxAlusta.VertScrollBar.Range;

  // Luodaan uusi vr vastaus
  // Ensin tehdn paneeli alustaksi
  p := TPanel.Create(self);
  p.Parent := ScrollBoxAlusta;
  p.Align := alTop;
  p.Top := p.Parent.ClientHeight; // Synnytetn boksin pohjalle
  p.Height := PanelVaaraVastaus.Height;
  p.BevelOuter := bvNone;

  l := TLabel.Create(self);
  l.Parent := p;
  l.Top := 0;
  l.Left := 4;
  l.Caption := intToStr(PaneeliLista.Count+2) + '. Vr vastaus';
  l.Font.Size := 10;
  l.Font.Style := [fsBold];

  // Luodaan paneelin sisn edit-boksi mihin vr vastaus voidaan kirjoittaa
  e := TEdit.Create(self);
  e.Parent := p;
  e.Top := 20;
  e.Left := 4;
  e.Width := EditKysymys.Width;
  e.Anchors := [akLeft, akRight, akTop];
  e.Font.Size := 12;
  e.Font.Name := 'Courier';
  e.Text := 'Kirjoita thn vr vastaus';
  e.OnMouseUp := EditMouseUp;
  e.OnChange := EditChange;
  e.OnExit := EditExit;

  // Luodaan nappi, jolla liitetn kuva vastausvaihtoehdon yhteyteen
  VastauksenKuvapolku.Add(''); // Uutta nappia varten uusi merkkijono
  n := TSpeedButton.Create(self);
  n.Parent := p;
  n.Anchors:=SpeedButtonVastauskuva_1.Anchors;
  n.Width:=SpeedButtonVastauskuva_1.Width;
  n.Height:=SpeedButtonVastauskuva_1.Height;
  n.Top:=SpeedButtonVastauskuva_1.Top;
  n.Left:=SpeedButtonVastauskuva_1.Left;
  n.Glyph:=ImageGlyphLisaa.Picture.Bitmap;
  n.OnClick:=SpeedButtonVastauskuvaClick;
  n.Tag:=VastauksenKuvaPolku.Count-1; // Asetetaan tag. TRKE!

  // Jos ollaan synnyttmss uusi vr vastaus "vrien vastausten alueen"
  // (=ScrollBoxAlusta) ulkopuolelle, niin listn vertikaalisen vierityspalkin
  // pituutta ja asetetaan nkym vierityspalkin alaphn (jonne juuri
  // listtiin tilaa).
  if ((p.Top + p.Height)>=ScrollBoxAlusta.Height) then begin
    ScrollBoxAlusta.VertScrollBar.Range := ScrollBoxAlusta.VertScrollBar.Range + p.ClientHeight;
    ScrollBoxAlusta.VertScrollBar.Position := ScrollBoxAlusta.VertScrollBar.Range {- ScrollBoxAlusta.ClientHeight};
  end;

  PaneeliLista.Add(p);
end;

procedure TFormMonivalintaKysymys.EditMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  e : TEdit;

begin
  // TEdit bugittaa ainakin testikoneella. Teksti ei saa valittua muutoin kuin
  // tll tavalla, jos hiirell klikataan editi. Luultavasti johtuu siit,
  // ett teksti kyll tulee valituksi, kun focus siirtyy kontrolliin mutta
  // sitten rekisteridn hiiren painallus, joka purkaa tekstin valinnan... :-(

  // Tehty tag-viritys, koska nykyisell jrjestelyll valittua teksti ei
  // voida purkaa painamalla hiirell uudelleen valittua teksti. Tageissa
  // 0 tarkoittaa, ett teksti ei ole valittuna ja se voidaan valita, 1 taas
  // tarkoittaa pinvastaista.
  if (Sender is TEdit) then begin
    e := TEdit(Sender);
    if e.Tag = 1 then begin e.Tag := 0; exit; end;
    e.SelectAll;
    e.Tag:=1;
  end;
end;

procedure TFormMonivalintaKysymys.FormDestroy(Sender: TObject);
begin
  PaneeliLista.Free;
  VastauksenKuvapolku.Free;
end;

procedure TFormMonivalintaKysymys.ButtonPoistaVaaraClick(Sender: TObject);
var
  Apulista : TStringlist;
  i : integer;

begin
  // Jos lista on tyhj, lhdetn pois
  if PaneeliLista.Count <= 0 then exit;

  MuokattuSisalto := true;

  if PaneeliLista.Last is TPanel then begin
   // Kun poistetaan vri vastauksia ja niiden kirjoittamiseen tarkoitettuja
   // edit-bokseja, muokataan vierityspalkkiin liittyvi arvoja (sen pituutta),
   // lyhyemmksi, jos poistettavat ovat poistettavien alustan
   // (=ScrollBoxAlusta) nkyvn alueen ulkopuolella.
   if ScrollBoxAlusta.VertScrollBar.Range > ScrollBoxAlusta.Height then begin
      ScrollBoxAlusta.VertScrollBar.Range := ScrollBoxAlusta.VertScrollBar.Range - PanelVaaraVastaus.ClientHeight;
      ScrollBoxAlusta.VertScrollBar.Position := ScrollBoxAlusta.VertScrollBar.Range {- ScrollBoxAlusta.ClientHeight};
    end;
    PaneeliLista.Remove(PaneeliLista.Last);
  end;

  // Nhtvsti Stringlist EI OSAA st kokoaan sen mukaan, jos sielt
  // poistetaan jseni. Eli Count-muuttuja j liian suureksi ja listaa
  // muokataan vain tyhjksi. Tst johtuen tm tehdn vaikeimman ja
  // tylimmn kautta... :-Z (thn pitisi keksi jokin parempi keino).
  Apulista:=TStringlist.Create;
  for i:=0 to VastauksenKuvapolku.Count-2 do
    Apulista.Add(VastauksenKuvapolku[i]);
  Vastauksenkuvapolku.Clear;
  for i:=0 to Apulista.Count-1 do
    VastauksenKuvapolku.Add(Apulista[i]);
  Apulista.Free;
end;

procedure TFormMonivalintaKysymys.EditChange(Sender: TObject);
begin
  // Muokattaessa asetetaan muokkausta kuvaava muuttuja oikeaan arvoonsa
  MuokattuSisalto:=true;
end;

procedure TFormMonivalintaKysymys.EditExit(Sender: TObject);
begin
  // Tehdn tm, ett tekstin valinta aina painettaessa hiirell
  // edit-boksia toimisi samalla tavalla. Jos tt ei tehd, tagit jvt
  // vrn asentoon ja toisinaan teksti sitten valitaan ja toisinaan
  // taas ei...
  if Sender is TEdit then TEdit(Sender).Tag := 0;
end;

procedure TFormMonivalintaKysymys.FormShow(Sender: TObject);
begin
  EditKysymys.SetFocus;
  EditKysymys.Tag := 1;
end;


// Hoitaa monivalintakysymysten vaihtoehtojen yhteydess toiminnan napeille,
// jotka ovat kuvien lismist varten vaihtoehdon yhteyteen.
procedure TFormMonivalintaKysymys.SpeedButtonVastauskuvaClick(
  Sender: TObject);
var
  nappi : TSpeedButton;

begin
  if not (sender is TSpeedButton) then exit;
  nappi:=TSpeedbutton(Sender);

  if nappi.Tag < Vastausvaihtoehtoja then begin
    if not OpenPictureDialog.Execute then begin hoidaScrollBarNakyvaksi; exit; end;
    VastauksenKuvapolku[PuraTag(nappi)]:=OpenPictureDialog.FileName;
    MuokattuSisalto:=true;
  end;

  // Tutkitaan, mik kuva napille laitetaan (katso tag-selvennys ohjelman alusta)
  if nappi.Tag >= Vastausvaihtoehtoja then begin
    nappi.Glyph:=ImageGlyphLisaa.Picture.Bitmap;
    nappi.Tag:=nappi.Tag-Vastausvaihtoehtoja;
    VastauksenKuvapolku[PuraTag(nappi)]:=''; // Poistetaan polku
    MuokattuSisalto:=true;
  end else begin
    nappi.Glyph:=ImageGlyphPoista.Picture.Bitmap;
    nappi.Tag:=nappi.Tag+Vastausvaihtoehtoja;
  end;
  hoidaScrollBarNakyvaksi;
end;

// Funktio purkaa tag-virityksest oikean tag-arvon
function TFormMonivalintaKysymys.puraTag(Sender: TObject): integer;
var
  nappi : TSpeedButton;
begin
  Result:=0;
  if not (Sender is TSpeedButton) then exit;
  nappi:=TSPeedButton(Sender);
  if nappi.Tag<Vastausvaihtoehtoja then result:=nappi.Tag
  else Result:=nappi.Tag-Vastausvaihtoehtoja;
end;

// Seuraavaa tarvitaan vain sen takia, koska Delphin omissa komponenteissa
// tuntuu riittvn bugeja: ScrollBoxin vierityspalkki hvi, kun avataan
// kuvanpiirto ja liikutellaan sit edestakaisin scrollbarin pll.
// Kun painetaan open, palkki ei en piirrykn takaisin! :-Z
// No, tm aliohjelma hoitaa palkin piiloon ja nytt sen taas, niin ett
// se piirretn uudelleen. Purkkaviritys, mutta minks teet...
procedure TFormMonivalintaKysymys.hoidaScrollBarNakyvaksi;
var
  apu : integer;

begin
  apu:=ScrollBoxAlusta.VertScrollBar.Position;
  ScrollBoxAlusta.VertScrollBar.Visible:=false;
  ScrollBoxAlusta.VertScrollBar.Visible:=true;
  ScrollBoxAlusta.VertScrollBar.Position:=apu;
end;


end.
