// Talariuksen pelin pelaamiseen liittyv lomake, jossa kyttj valitsee
// peliin osallistuvien pelaajien mrn sek asettaa heille haluamansa
// nimet ja mahdolliset pelikuvat.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 2.2.2006
//

unit MontakoPelaajaaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Contnrs, ExtDlgs;

type
  TFormMontakoPelaajaa = class(TForm)
    RadioGroupPelaajienLkm: TRadioGroup;
    ButtonOK: TButton;
    ButtonCancel: TButton;
    BitBtnPelaaja1: TBitBtn;
    BitBtnPelaaja2: TBitBtn;
    BitBtnPelaaja3: TBitBtn;
    BitBtnPelaaja4: TBitBtn;
    OpenDialogVaihdaKuva_OLD: TOpenDialog;
    PanelPelaajienLkm: TPanel;
    PanelPelaajienNimet: TPanel;
    EditPelaaja1: TEdit;
    EditPelaaja2: TEdit;
    EditPelaaja3: TEdit;
    EditPelaaja4: TEdit;
    OpenDialogVaihdaKuva: TOpenPictureDialog;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    procedure BitBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RadioGroupPelaajienLkmClick(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
  private

  public
    
  end;

var
  FormMontakoPelaajaa: TFormMontakoPelaajaa;

implementation

uses PelinPelaaminenPaaForm, Objekti, MedioidenLataajat;

{$R *.dfm}

procedure TFormMontakoPelaajaa.BitBtnClick(Sender: TObject);
var
  UudenKuvanPolku: TFileName;
  UusiBitmap: TBitmap;
  Kuva : TPicture;
begin
  // jos kyttj painaa cancelia, lhdetn pois
  if not OpenDialogVaihdaKuva.Execute then exit;

  // polku talteen
  UudenKuvanPolku := OpenDialogVaihdaKuva.FileName;

  // luodaan nappulaan uusi kuva
  UusiBitmap := TBitmap.Create;
  Kuva:=TPicture.Create;
  //LataaKuva(UusiBitmap,UudenKuvanPolku);
  LataaKuva(Kuva,UudenKuvanPolku);
  UusiBitmap.Height:=Kuva.Height;
  UusiBitmap.Width:=Kuva.Width;
  UusiBitmap.Canvas.Draw(0,0,Kuva.Graphic);

  if ( TBitBtn(Sender).Tag = 1 ) then BitBtnPelaaja1.Glyph.Canvas.StretchDraw(Rect(0,0,BitBtnPelaaja1.Glyph.Width,BitBtnPelaaja1.Glyph.Height),UusiBitmap)
  else if ( TBitBtn(Sender).Tag = 2 ) then BitBtnPelaaja2.Glyph.Canvas.StretchDraw(Rect(0,0,BitBtnPelaaja2.Glyph.Width,BitBtnPelaaja1.Glyph.Height),UusiBitmap)
  else if ( TBitBtn(Sender).Tag = 3 ) then BitBtnPelaaja3.Glyph.Canvas.StretchDraw(Rect(0,0,BitBtnPelaaja3.Glyph.Width,BitBtnPelaaja1.Glyph.Height),UusiBitmap)
  else if ( TBitBtn(Sender).Tag = 4 ) then BitBtnPelaaja4.Glyph.Canvas.StretchDraw(Rect(0,0,BitBtnPelaaja4.Glyph.Width,BitBtnPelaaja1.Glyph.Height),UusiBitmap)
  else begin end; // ei tehd mitn

  UusiBitmap.Free;
  Kuva.Free;
end;

procedure TFormMontakoPelaajaa.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);

  // oletuksena yksi pelaaja
  BitBtnPelaaja1.Visible := true;
  BitBtnPelaaja2.Visible := false;
  BitBtnPelaaja3.Visible := false;
  BitBtnPelaaja4.Visible := false;

  EditPelaaja1.Visible := true;
  EditPelaaja2.Visible := false;
  EditPelaaja3.Visible := false;
  EditPelaaja4.Visible := false;
end;

procedure TFormMontakoPelaajaa.RadioGroupPelaajienLkmClick(
  Sender: TObject);
begin

  // yksi pelaaja
  if ( RadioGroupPelaajienLkm.ItemIndex = 0 ) then begin
    BitBtnPelaaja1.Visible := true;
    BitBtnPelaaja2.Visible := false;
    BitBtnPelaaja3.Visible := false;
    BitBtnPelaaja4.Visible := false;

    EditPelaaja1.Visible := true;
    EditPelaaja2.Visible := false;
    EditPelaaja3.Visible := false;
    EditPelaaja4.Visible := false;
  end

  // kaksi pelaajaa
  else if ( RadioGroupPelaajienLkm.ItemIndex = 1 ) then begin
    BitBtnPelaaja1.Visible := true;
    BitBtnPelaaja2.Visible := true;
    BitBtnPelaaja3.Visible := false;
    BitBtnPelaaja4.Visible := false;

    EditPelaaja1.Visible := true;
    EditPelaaja2.Visible := true;
    EditPelaaja3.Visible := false;
    EditPelaaja4.Visible := false;
  end

  // kolme pelaajaa
  else if ( RadioGroupPelaajienLkm.ItemIndex = 2 ) then begin
    BitBtnPelaaja1.Visible := true;
    BitBtnPelaaja2.Visible := true;
    BitBtnPelaaja3.Visible := true;
    BitBtnPelaaja4.Visible := false;

    EditPelaaja1.Visible := true;
    EditPelaaja2.Visible := true;
    EditPelaaja3.Visible := true;
    EditPelaaja4.Visible := false;
  end

  // nelj pelaajaa
  else begin
    BitBtnPelaaja1.Visible := true;
    BitBtnPelaaja2.Visible := true;
    BitBtnPelaaja3.Visible := true;
    BitBtnPelaaja4.Visible := true;

    EditPelaaja1.Visible := true;
    EditPelaaja2.Visible := true;
    EditPelaaja3.Visible := true;
    EditPelaaja4.Visible := true;
  end;
end;

procedure TFormMontakoPelaajaa.ButtonOKClick(Sender: TObject);
var
  Pelaaja: THahmo;
  Pelaajat: TObjectList;
begin
  Pelaajat := TObjectList.Create;

  // yksi pelaaja
  if ( RadioGroupPelaajienLkm.ItemIndex >= 0 ) then begin
    Pelaaja := THahmo.Create;
    if ( EditPelaaja1.Text <> '' ) then Pelaaja.Nimi := EditPelaaja1.Text
    else Pelaaja.Nimi := 'Nimetn1';
//    Pelaaja.Hahmo := BitBtnPelaaja1.Glyph; //There is no pelaaja.hahmo
    Pelaajat.Add(Pelaaja);

    // kaksi pelaajaa
    if ( RadioGroupPelaajienLkm.ItemIndex >= 1 ) then begin
      Pelaaja := THahmo.Create;
      if ( EditPelaaja2.Text <> '' ) then Pelaaja.Nimi := EditPelaaja2.Text
      else Pelaaja.Nimi := 'Nimetn2';
//      Pelaaja.Hahmo := BitBtnPelaaja2.Glyph;
      Pelaajat.Add(Pelaaja);

      // kolme pelaajaa
      if ( RadioGroupPelaajienLkm.ItemIndex >= 2 ) then begin
        Pelaaja := THahmo.Create;
        if ( EditPelaaja3.Text <> '' ) then Pelaaja.Nimi := EditPelaaja3.Text
        else Pelaaja.Nimi := 'Nimetn3';
//        Pelaaja.Hahmo := BitBtnPelaaja3.Glyph;
        Pelaajat.Add(Pelaaja);

        // nelj pelaajaa
        if ( RadioGroupPelaajienLkm.ItemIndex >= 3 ) then begin
            Pelaaja := THahmo.Create;
            if ( EditPelaaja4.Text <> '' ) then Pelaaja.Nimi := EditPelaaja4.Text
            else Pelaaja.Nimi := 'Nimetn4';
//          Pelaaja.Hahmo := BitBtnPelaaja4.Glyph;
          Pelaajat.Add(Pelaaja);
        end;
      end;
    end;
  end;

  FormPelinPelaaminen.AsetaHahmot(Pelaajat);
end;

end.
