// Opettajan kyttliittym on pyritty tekemn riippumattomaksi kysymysten
// tyypeist. Eli kytnnss tm on vain ns. selain, joka purkaa tiedot
// .ini -tiedostosta ja nytt ne ruudulla. Kysymysten edess pyritn silti
// esittmn mahdollinen kysymyksen tyyppi kuten (M) tai (A) esim. mutta
// nm kuitenkin tallennetaan suoraan tiedostoon pelin pelaamisen yhteydess.
// Nin opettajan kyttliittymss ei tarvitse vlitt kysymysten tyypeist
// ja lisksi tll tavalla sen pelkk selainmaisuus korostuu...
//
// Salasana on vanha tuttu: kaikkilaivaan
//
// Tekij:
//   Heikki Nevala
//
// Luotu: 29.11.2005
// Viimeksi muokattu: 1.2.2006
//


unit OpettajanKayttoliittymaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Grids, ValEdit, inifiles, Contnrs, xmldom,
  XMLIntf, msxmldom, XMLDoc;

type
  TFormOpettajanKayttoliittyma = class(TForm)
    PanelKaikenAlusta: TPanel;
    PanelMenualusta: TPanel;
    PanelPelaajatOtsikko: TPanel;
    PanelPelaajaAlusta: TPanel;
    ListBoxPelaajat: TListBox;
    ButtonLataaTulokset: TButton;
    ButtonPoistu: TButton;
    PanelKVAlusta: TPanel;
    StringGridSisalto: TStringGrid;
    PanelVastausOtsikko: TPanel;
    PanelKysymysOtsikko: TPanel;
    PanelSisaltoOtsikkoAlusta: TPanel;
    PanelSisaltoAlusta: TPanel;
    OpenDialogTulokset: TOpenDialog;
    XMLPeliloki: TXMLDocument;
    procedure ButtonPoistuClick(Sender: TObject);
    procedure ButtonLataaTuloksetClick(Sender: TObject);
    procedure PanelSisaltoAlustaResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxPelaajatClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StringGridSisaltoClick(Sender: TObject);
  private
    Pelaajat : TObjectList;

    procedure PaivitaPelaajaLista;
    procedure PaivitaStringList(index : integer);
    procedure TyhjennaStringGrid(S:TStringGrid);

  public
    { Public declarations }
  end;

var
  FormOpettajanKayttoliittyma: TFormOpettajanKayttoliittyma;

implementation

{$R *.dfm}

uses PelaajaVastaukset, SalasanaForm;


procedure TFormOpettajanKayttoliittyma.ButtonPoistuClick(Sender: TObject);
begin
  Close;
end;

procedure TFormOpettajanKayttoliittyma.ButtonLataaTuloksetClick(
  Sender: TObject);

var
  TiedostonNimi: TFileName;
  Pelaaja : TPelaajanVastaukset;
  Vastaus : TKysymyksenVastaus;
  PelaajienLkm, KysymystenLkm, I, J: Integer;
  JuuriNode, ApuNode, ApuNode2, PelisessioNode, TunnusNode,
  PelaajaNode, KysymyksetNode, KysymysNode: IXMLNode;
  PelaajanTunnus, Kysymys, VastausKysymykseen, Oikea : String;
begin
  // Jos kyttj painaa dialogin cancel-nappulaa, poistutaan
  if not OpenDialogTulokset.Execute then exit;
  Pelaajat.Clear;

  TiedostonNimi := OpenDialogTulokset.FileName;
  XMLPeliloki.LoadFromFile(TiedostonNimi);
  try
    JuuriNode := XMLPeliloki.DocumentElement;
    ApuNode := JuuriNode.ChildNodes['pelisession_tiedot'].ChildNodes['pelaajat'];
    PelaajienLkm :=ApuNode.ChildNodes.Count;

    for I := 0 to PelaajienLkm - 1 do
    begin
      // Luetaan pelaajien nimet ja asetetaan ne tietorakenteeseen
      Pelaaja:=TPelaajanVastaukset.Create;
      ApuNode2 := ApuNode.ChildNodes.Get(I);
      Pelaaja.nimi:= ApuNode2.ChildNodes['nimi'].Text;
      Pelaaja.tunnus:= ApuNode2.ChildNodes['tunnus'].Text;
      Pelaajat.Add(Pelaaja);
    end;

    PelisessioNode := JuuriNode.ChildNodes['pelisessio'];
    PelaajienLkm := PelisessioNode.ChildNodes.Count;

    for I := 0 to PelaajienLkm -1 do
    begin
      PelaajaNode := PelisessioNode.ChildNodes.Get(I);

      TunnusNode := PelaajaNode.ChildNodes['tunnus'];
      PelaajanTunnus := TunnusNode.Text;

      for J := 0 to Pelaajat.Count -1 do
      begin
        if (PelaajanTunnus = (Pelaajat[J] as TPelaajanVastaukset).tunnus) then
        begin
          Pelaaja := Pelaajat[J] as TPelaajanVastaukset;
          break;
        end;
      end;

      KysymyksetNode := PelaajaNode.ChildNodes['kysymykset'];

      KysymystenLkm := KysymyksetNode.ChildNodes.Count;

      for J := 0 to KysymystenLkm - 1 do
      begin
        KysymysNode := KysymyksetNode.ChildNodes.Get(J);

        Kysymys := KysymysNode.ChildNodes['kysymysteksti'].Text;
        VastausKysymykseen := KysymysNode.ChildNodes['vastaus'].Text;
        Oikea := KysymysNode.ChildNodes['oikea'].Text;

        Vastaus:=TKysymyksenVastaus.Create;
        Vastaus.Kysymys := Kysymys;
        Vastaus.Vastaus := VastausKysymykseen;
        Vastaus.OikeaVastaus := Oikea;
        if (Oikea = VastausKysymykseen) then
        begin
          Vastaus.Oikein := true;
        end
        else
        begin
          Vastaus.Oikein := false;
          if Oikea <> '' then
            Vastaus.Vastaus := Vastaus.Vastaus + ' ('+Oikea+')'
          else
            Vastaus.Kysymys := Vastaus.Kysymys + ' [Avoin kysymys]';
        end;
        Pelaaja.Vastaukset.Add(Vastaus);
      end;
    end;
  finally
  end;

  // Pivit pelaajalista ja laita, ett ensimminen niist on valittuna
  PaivitaPelaajaLista;
  TyhjennaStringGrid(StringGridSisalto);
end;

procedure TFormOpettajanKayttoliittyma.PanelSisaltoAlustaResize(
  Sender: TObject);
begin
  StringGridSisalto.DefaultColWidth:=(PanelSisaltoAlusta.ClientWidth div 2)-11;
  PanelKysymysOtsikko.ClientWidth:=StringGridSisalto.DefaultColWidth+2;
  PanelVastausOtsikko.ClientWidth:=StringGridSisalto.DefaultColWidth+2;
end;

procedure TFormOpettajanKayttoliittyma.FormCreate(Sender: TObject);
//var
  //r : TGridRect;

begin
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);

  Pelaajat:=TObjectlist.create;

  // Pakotetaan valinta listan ulkopuolelle, niin ei ny sinist valintaa
  // Hieman arvelluttavaa koodia, kyll...
  //r.Left:=-1; r.Right:=-1; r.Top:=-1; r.Bottom:=-1;
  //StringGridSisalto.Selection:=r;
end;

// Koekyttn... Tekee .ini ennalta mrttyyn paikkaan, jotta voidaan testata
// opettajan kyttliittymn toimivuutta.


// Pivitt graafisen pelaajalistan yhdenmukaiseksi tietorakenteessa olevien
// pelaajien nimien ja mrn mukaan.
procedure TFormOpettajanKayttoliittyma.PaivitaPelaajaLista;
var
  i : integer;
begin
  ListBoxPelaajat.Clear;
  for i:=0 to (Pelaajat.Count-1) do
    ListBoxPelaajat.Items.Add(TPelaajanVastaukset(Pelaajat[i]).nimi);
end;

// Tyhjent graafisen stringGridin sislln.
procedure TFormOpettajanKayttoliittyma.TyhjennaStringGrid(S : TStringGrid);
var
  i,j : integer;

begin
  for i:=0 to S.ColCount do begin
    for j:=0 to S.RowCount do begin
      S.Cells[i,j]:='';
    end;
  end;
end;

// Pivitt graafisen stringlistin sen mukaan, mit tietoa lytyy
// tietorakenteesta. index-muuttuja viittaa pelaajan numeroon pelaajat-
// objectlistiss.
procedure TFormOpettajanKayttoliittyma.PaivitaStringList(index : integer);
var
  Pelaaja : TPelaajanVastaukset;
  S : TStringGrid;
  i : integer;

begin
  // Varmistetaan, ett ei viitata listasta ohi
  if (index < 0) or (index >= Pelaajat.Count) then exit;

  // Viitteet talteen laiskuuden takia...
  Pelaaja:=TPelaajanVastaukset(Pelaajat.Items[index]);
  S:=StringGridSisalto;

  // Tyhjtn vanha StringGrid etteivt vanhat tiedot j sinne kummittelemaan
  TyhjennaStringGrid(S);
  // Tarkistetaan, ett StringGridiss riitt tilaa nytt kaikki kysymykset
  // ja vastaukset. Jos tilaa ei ole niin listn sit.
  if Pelaaja.Vastaukset.Count > S.RowCount then
    S.RowCount:=Pelaaja.Vastaukset.Count;
  // Tytetn StringGrid tiedoilla. Kytetn ColCountia... Sen pitisi
  // olla muuttumaton (ainakin tss versiossa ;-) ).
  for i:=0 to (Pelaaja.Vastaukset.Count-1) do begin
    S.Cells[0,i]:=TKysymyksenVastaus(Pelaaja.Vastaukset[i]).Kysymys;
    S.Cells[1,i]:=TKysymyksenVastaus(Pelaaja.Vastaukset[i]).Vastaus;
  end;
end;

procedure TFormOpettajanKayttoliittyma.ListBoxPelaajatClick(
  Sender: TObject);
var
  index : integer;

begin
  Index := ListBoxPelaajat.ItemIndex;
  PaivitaStringList(index);
end;

procedure TFormOpettajanKayttoliittyma.FormDestroy(Sender: TObject);
begin
  Pelaajat.Free;
end;

procedure TFormOpettajanKayttoliittyma.StringGridSisaltoClick(
  Sender: TObject);
//var
//  r : TGridRect;

begin
  // Pakotetaan valinta listan ulkopuolelle
  // (Jokin fiksumpi tapa thn?)
//  r.Left:=-1; r.Right:=-1; r.Top:=-1; r.Bottom:=-1;
//  StringGridSisalto.Selection:=r;
end;

// Salasanan toteutus on kyll jotenkin huono... Pitisi keksi parempi keino.
// self.releasea kytettess pformin luonnin yhteydess ji kuitenkin
// prosessi viel plle...
{procedure TFormOpettajanKayttoliittyma.TimerSalasanaTimer(Sender: TObject);
var
  f : TFormSalasana;

begin
  TimerSalasana.Enabled:=false;
  f:=TFormSalasana.Create(nil);
  if (f.ShowModal=mrOK) then begin // OK:lla tarkistetaan salasana
    if (f.MaskEditSalasanakentta.Text='kaikkilaivaan') then begin
      f.free;
      exit;
    end;
  end else begin // muutoin suljetaan...
    f.free;
    self.Close;
    exit;
  end;
  f.Free;
  TimerSalasana.Enabled:=true;
end;}

end.
