// Talariuksen pohjelma. Sislt lomakkeen, josta kynnistetn
// Talariukseen liittyvt eri osiot, kuten Pelilaudan tekeminen,
// pelin pelaaminen tai kysymyssarjojen tekeminen.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 16.2.2006
//

unit PaaohjelmaForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ShellApi,KysymystenTekoPaaForm;

type
  TFormPaaohjelma = class(TForm)
    BitBtnKysymykset: TBitBtn;
    BitBtnPelilauta: TBitBtn;
    BitBtnPelaaminen: TBitBtn;
    ButtonPoistu: TButton;
    BitBtnOpettajanKayttoliittyma: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BitBtnPelilautaClick(Sender: TObject);
    procedure BitBtnKysymyksetClick(Sender: TObject);
    procedure BitBtnPelaaminenClick(Sender: TObject);
    procedure ButtonPoistuClick(Sender: TObject);
    procedure BitBtnOpettajanKayttoliittymaClick(Sender: TObject);
  private
    Polku: String;
    function KillApp(const sCapt: PChar) : boolean;
  public

  end;

var
  FormPaaohjelma: TFormPaaohjelma;

implementation

{$R *.dfm}

procedure TFormPaaohjelma.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);

  Polku := ExtractFilePath(application.ExeName);
end;

procedure TFormPaaohjelma.BitBtnPelilautaClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(Polku + 'PelilaudanTeko.exe'), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormPaaohjelma.BitBtnKysymyksetClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(Polku + 'KysymystenTeko.exe'), nil, nil, SW_SHOWNORMAL);
  //KT:=TFormKysymystenTekeminen.Create(self);
  //KT.Show;
end;

procedure TFormPaaohjelma.BitBtnPelaaminenClick(Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(Polku + 'PelinPelaaminen.exe'), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormPaaohjelma.ButtonPoistuClick(Sender: TObject);
begin
  // Tapetaan kaikki avoinna olevat sovellukset...
  // !! Tm ei ole kuitenkaan mikn hyv ratkaisu. Menetelmll saadaan
  // suljettua ainoastaan yksi kyseisen lainen sovellus. Eik tmkn
  // aina sulkeudu, jos ohjelmassa on pll esim. avausdialogi tms.
  // Jos taas eri osioiden formit luodaan pohjelman alaisuuteen, ei
  // saada windows-palkkiin ohjelmien "ajotietoja", eli ei voida vaihdella
  // lomakkeiden kesken alt-tabilla jne.
  // !! Nit ei kytet, koska tappoivat mys Delphin, ja siin sivussa
  // hvisi tallentamaton projekti...
  //KillApp('Pelin pelaaminen');
  //KillApp('Pelilaudan tekeminen');
  //KillApp('Opettajan kyttliittym');
  //KillApp('Kysymysten tekeminen');

  Close;
end;

procedure TFormPaaohjelma.BitBtnOpettajanKayttoliittymaClick(
  Sender: TObject);
begin
  ShellExecute(Handle, 'open', PChar(Polku + 'OpettajanKayttoliittyma.exe'), nil, nil, SW_SHOWNORMAL);
end;

// Tm on tlt: http://delphi.about.com/cs/adptips2000/a/bltip0100_2.htm
Function TFormPaaohjelma.KillApp(const sCapt: PChar) : boolean;
  var AppHandle:THandle;
begin
  AppHandle:=FindWindow(Nil, sCapt) ;
  Result:=PostMessage(AppHandle, WM_QUIT, 0, 0) ;
end;


end.
