{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

Sislt kaiken pelilogiikan ja kommunikoinnin mit tarvitaan pelin pelaamiseen
palvelimen pss.

Alustus: TFormLuoPeli
Omistaja: TFormPelinPelaaminen
}
unit Pelilogiikka;

interface

uses Classes, Contnrs, IdBaseComponent, IdComponent, ScktComp, Paketit, md5,
  objekti, SyncObjs, ExtCtrls;

type PelinTila =
  (Odotushuoneessa,
  OdotaHeittoa,
  OdotaSiirtoa,
  OdotaVastausta,
  OdotaArvosteluita);

const EhdotonMaksimi = 4;

type

  TPelilogiikka = class(TComponent)

  private
    Tila: PelinTila; //Miss ollaan menossa
    Verkossa: Boolean; //Onko verkkopeli vai ei
    ServerSocketPeli: TServerSocket; //Palvelimen verkkoyhteys
    OfflineIP: String; //IP-osoite, jonne lhetetn offlinepeliss
    OfflinePort: Integer; //portti, jonne lhetetn offlinepeliss
    Nappulat: TObjectList; //Loogiset nappulat
    Ruudut: TObjectList; //Pelilaudan ruudut
    Kysymykset: TObjectList; //Pelin kysymykset
    KysymyssarjaListaus: TStringList; //Kysymyssarjojen nimet
    Vastaukset: TObjectList; //Sislt pelaajien antamat vastaukset
    PelaajaLista: TObjectList; //Lista pelin pelaajista
    Luoja: THahmo; //pelin tekij
    Pelivuorossa: Integer; //arvot vlilt [0, Pelaajia - 1]
    Pelaajia: Integer; //Pelaajien lukumr
    MaxPelaajia: Integer; //Pelaajien maksimimr
    Sarja: Integer; //Esitetyn kysymyksen sarja
    Kysymys: Integer; //Esitetyn kysymyksen sarjan kysymys
    Arvosana: Integer; //Pelin arvosana (ei kytss)
    OikeaVastaus: String; //Esitetyn kysymyksen oikea vastaus
    PelilaudanNimi: String; //Pelilaudan nimi (ts. tiedosto ilman polkua ja ptett)
    Pelilauta: String; //pelilaudan tiedosto
    Salasana: MD5Digest; //pelin salasana
    PelinHakemisto: String; //Pelin juurihakemisto
    Arvostellaanko: Boolean; //arvostellaanko peli ptyttyn (ei kytss)
    Suojattu: Boolean; //Onko peli suojattu salasanalla
    OnkoPeliKesken: Boolean; //onko pelin pelaaminen kesken
    OnkoPeliLadattu: Boolean; //onko pelin lataaminen valmis
    PelinNimi: String; //pelin nimi
    Pelissa: array[0..EhdotonMaksimi-1] of Boolean; //ketk kaikki on viel peliss
    Alkuaika: TDateTime; //milloin pelaaminen alkoi
    Loppuaika: TDateTime; //milloin pelaaminen loppui
    LokinTiedosto: String; //Lokin tiedostonnimi
    SulkuTarkistin: TTimer; //Kun pll, sulkee palvelimen jos asiakkaita ei liittyneen
    PingTarkistin: TTimer;

    PoistoKesken: Boolean; //jos poisto on kesken, ei koiteta poistaa (vltetn roikkuvat viitteet)
    Sammuu: Boolean; //Jos palvelin sammutetaan, ei lhetell/poistella turhia (vltetn virheit)
    Siirretty: array[0..EhdotonMaksimi-1] of Boolean; //kirjaus ketk kaikki siirtneet

    ViimePing: array[0..EhdotonMaksimi-1] of TDateTime; //pit kirjaa viime pingin saapumisajasta.

    procedure Laheta(Paketti: TPaketti; Asiakas: TCustomWinSocket); overload;
    procedure Laheta(Paketti: TPaketti); overload;
    procedure LahetaKaikille(Paketti: TPaketti);

    function EtsiPelaaja(Asiakas: TCustomWinSocket): Integer;

    procedure SuljeServeri;

    function LiikutaPelinappulaa(PelaajaID: Integer): boolean;
    procedure KasitteleRuutu;
    procedure KasitteleVastaus(Vastaus: String);
    procedure LisaaVastausPelisessionKirjanpitoon(ID, kyssar, kysnum,
      pisteet: integer; kys, vas, oik: string; Oikeellisuus: Integer);
    procedure SeuraavaVuoro;
    procedure ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi,
      Paate: String);
    procedure TallennaPelisessionKirjanpito;
    function LataaKysymyssarja(Sarja: String): TObjectList;
    procedure LataaPelilauta(Sender: TObject);
//    procedure TyhjennaPelilauta;
    procedure AsetaPelaaja(PelaajaID: Integer);
//    procedure PelaajatAlkuun;
    procedure TeeUusiPelisessionKirjanpito;
    procedure HeitaNoppaa;

    procedure LahetaPelinTarkemmatTiedot(Saie: TCustomWinSocket);
    procedure LahetaLiityitPeliin(Saie: TCustomWinSocket; Paketti: TLiityPeliin);

    procedure ServeriVastaanotto(Sender: TObject; AThread: TCustomWinSocket);
    procedure ServeriYhteysAvattu(Sender: TObject; AThread: TCustomWinSocket);
    procedure ServeriYhteysSuljettu(Sender: TObject; AThread: TCustomWinSocket);
    procedure PoistuuPelista(PoistuvaPelaaja: String);
    procedure LahetaPelinTiedostot(Saie: TCustomWinSocket);
    procedure LataaKysymyssarjat;
    procedure LahetaPelaajalista(Saie: TCustomWinSocket);
    procedure ServerError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    function EtsiSaie(Pelaaja: THahmo): TCustomWinSocket; overload;
    function EtsiSaie(IP: String; Port: Integer): TCustomWinSocket; overload;
    procedure TarkistaSulkeminen(Sender: TObject);
    procedure TarkistaPing(Sender: TObject);
    function PidennaNumero(Pidennettava: Integer): String;
    procedure KasitteleChat(Paketti: TChatViesti; AThread: TCustomWinSocket);
    function KaikkiSiirtaneet(Siirtaja: Integer): Boolean;

  public
    procedure PeliLoppui;
    procedure LiittyyPeliin(UusiPelaaja: THahmo);
    procedure Alusta(Verkossa: Boolean; KysymyssarjaListaus: TStringList;
      Pelilauta: String; MaxPelaajia: Integer; Salasana: MD5Digest;
      Suojattu: Boolean; Arvostelu: Boolean; Arvosana: Integer; Luoja: THahmo;
      PelinHakemisto, PelinNimi: String);
    procedure AsetaLukko(PaaLukko: TCriticalSection);

    procedure LisaaOfflinePelaajat(Pelaajat: TObjectList);

    constructor Create(AOwner:TComponent; Portti:Integer); reintroduce; overload;
    destructor Destroy; override;

  end;


var
  Lukko: TCriticalSection;

const LokiKansio = '\lokit\';

implementation

uses PelinPelaaminenPaaForm, KysymysLuokat, PelaajaVastaukset, SysUtils,
  IniFiles, Windows, IdTCPConnection, XMLDoc, XMLintf, DateUtils, Math, Dialogs,
  XMLDom;

{ TPelilogiikka }

const NopanSilmaluku: Integer = 6;

//Vastauksen oikeellisuus
const Maarittelematon: Integer = 2;
const Oikein: Integer = 1;
const Vaarin: Integer = 0;

//Luodaan ja alustetaan muuttujat
constructor TPelilogiikka.Create(AOwner:TComponent;Portti:Integer);
begin
  inherited Create(AOwner);
  Sammuu := False;
  Randomize();
  OikeaVastaus:='';
  PelilaudanNimi:='';
  Pelilauta:=''; //pelilaudan tiedosto
  Nappulat := TObjectList.Create;
  Ruudut := TObjectList.Create;
  Kysymykset := TObjectList.Create;
  PelaajaLista := TObjectList.Create;
  Lukko := TCriticalSection.Create;
  Vastaukset := TObjectList.Create;

  //luodaan ja alustetaan palvelimen socket
  ServerSocketPeli := TServerSocket.Create(self);
  ServerSocketPeli.Active := False;
  ServerSocketPeli.Port := Portti;
  ServerSocketPeli.OnClientRead := ServeriVastaanotto;
  ServerSocketPeli.OnClientConnect := ServeriYhteysAvattu;
  ServerSocketPeli.OnClientDisconnect := ServeriYhteysSuljettu;
  ServerSocketPeli.OnClientError := ServerError;
  ServerSocketPeli.Active := True;

  //pivitetn tila
  Tila := Odotushuoneessa;

  //Luodaan ja alustetaan sulkutarkistin
  SulkuTarkistin := TTimer.Create(self);
  SulkuTarkistin.Enabled := False;
  SulkuTarkistin.Interval := 1*1000;
  SulkuTarkistin.OnTimer := TarkistaSulkeminen;

  //Luodaan ja alustetaan pingtarkistin
  PingTarkistin := TTimer.Create(Self);
  PingTarkistin.Interval := 10*1000;
  PingTarkistin.Enabled := True;
  PingTarkistin.OnTimer := TarkistaPing;

  //alustetaan taulukko mist katsotaan mitk pelaajat ovat peliss
  Pelissa[0] := False;
  Pelissa[1] := False;
  Pelissa[2] := False;
  Pelissa[3] := False;
end;

//vapautetaan luodut muuttujat, lukitaan rinnakkaissuoritukselta.
//lhetetn kaikille asiakkaille tieto lopettamisesta.
destructor TPelilogiikka.Destroy;
begin
  Lukko.Acquire;
  Sammuu := True;
  if (OnkoPeliKesken) then Peliloppui;
  SuljeServeri;
  FreeAndNil(SulkuTarkistin);
  FreeAndNil(Nappulat);
  FreeAndNil(Ruudut);
  FreeAndNil(Kysymykset);
//  FreeAndNil(PelaajaLista);  //Aiheuttaa EExternalException
  FreeAndNil(Luoja);
  Lukko.Release;
  inherited Destroy;
end;

//Asiakas on liittynyt peliin, pivitetn omat tiedot.
procedure TPelilogiikka.LiittyyPeliin(UusiPelaaja: THahmo);
var I: Integer;
begin
//  if PelaajaLista.Capacity <> MaxPelaajia then PelaajaLista.Capacity := MaxPelaajia;
  if (Pelaajia < MaxPelaajia) then begin
//    if not (PelaajaLista.Items[Pelaajia] = nil) then PelaajaLista.Items[Pelaajia].Free;
    for I := 0 to MaxPelaajia-1 do
    begin
      if (not Pelissa[I]) then
      begin
        //PelaajaLista.Items[I].Free; //kyseenalainen
        PelaajaLista.Insert(I, UusiPelaaja);
        Pelissa[I] := True;
        Pelaajia := Pelaajia + 1;
        ViimePing[I] := GetTime;
        exit;
      end;
    end;
  end;
end;

{
Asiakas poistuu/on poistunut/poistetaan pelist. Pivitetn omat tiedot
ja lhetetn tieto kaikille liittyneille pelaajille.
Jos poistunut pelaaja oli vuorossa, vaihdetaan vuoroa.
}
procedure TPelilogiikka.PoistuuPelista(PoistuvaPelaaja: String);
var I: Integer;
begin
  if Sammuu then exit;
  if (Pelaajia > 1) then
    for I := 0 to Pelaajia-1 do begin
      if (AnsiCompareStr((PelaajaLista.Items[I] as THahmo).Tunnus, PoistuvaPelaaja) = 0) then
      begin
        LahetaKaikille(TPoistui.Create((PelaajaLista.Items[I] as THahmo).Nimi, (PelaajaLista.Items[I] as THahmo).Tunnus));
        if Tila = Odotushuoneessa then PelaajaLista.Delete(I);
        Pelaajia := Pelaajia - 1;
        Pelissa[Pelaajia] := False;
        if (OnkoPeliKesken) and (I = Pelivuorossa) then SeuraavaVuoro;
        exit;
      end;
    end;
end;

{
Ksittelij palvelimen socketin virheille (kytnnss piilotetaan kyttjilt
tarpeettomat virheilmoitukset)
}
procedure TPelilogiikka.ServerError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
  if (ErrorEvent = eeSend) then //virhe kirjoitettaessa
  begin
    //Vltelln virheilmoitukset siit ett peli katkaistiin "vkisin".
    //ShowMessage('Server error: eeSend. ErrorCode: ' + IntToStr(Integer(ErrorCode))); //debuggaukseen
    ErrorCode := 0;
  end;
  if (ErrorEvent = eeReceive) then //virhe luettaessa
  begin
    //Vltetn virheilmoitukset siit ett peli katkaistiin "vkisin" odotushuoneessa?
    //ShowMessage('Server error: eeReceive. ErrorCode: ' + IntToStr(Integer(ErrorCode))); //debuggaukseen
    ErrorCode := 0; //Code 10053
  end;
end;

{
Lukee, purkaa ja ksittelee palvelimelle tulevat viestit.
}
procedure TPelilogiikka.ServeriVastaanotto(Sender: TObject; AThread: TCustomWinSocket);
var {KokoPakettiTaulu: array of Byte;
    KokoTaulu: array[0..1] of Byte;
    PaketinKoko: Word;            }
    PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
    J: Integer;
    Paketti: TPaketti;
begin
  XMLPaketti := AThread.ReceiveText;
  if (XMLPaketti = '') then exit;

  XMLPakettiLista := PilkoXML(XMLPaketti);

  for I := 0 to XMLPakettiLista.Count-1 do
  begin
    XMLPaketti := XMLPakettiLista[I];

    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    //Kuka tahansa saa poistua koska tahansa
    if (PaketinTyyppi = PoistuTyyppi) then begin
      J := EtsiPelaaja(AThread);
      if J >= 0 then
        PoistuuPelista((PelaajaLista.Items[J] as THahmo).Tunnus);
    end;
    if (PaketinTyyppi = PingTyyppi) then
    begin
      J := EtsiPelaaja(AThread);
      if ((J >= 0) and (J < Pelaajia)) then
        ViimePing[J] := GetTime;
    end;


    //Chatviestej voi tulla milloin hyvns
    if (PaketinTyyppi = ChatViestiTyyppi) then
      KasitteleChat(TChatViesti.Create(XMLPaketti), AThread);

    //Jos ollaan odotushuoneessa
    if(Tila = Odotushuoneessa) then begin
      case PaketinTyyppi of
        AnnaPelinTarkemmatTiedotTyyppi:
          LahetaPelinTarkemmatTiedot(AThread);
        LiityPeliinTyyppi:
          LahetaLiityitPeliin(AThread, TLiityPeliin.Create(XMLPaketti));
        AnnaPelaajalistaTyyppi:
          LahetaPelaajalista(AThread);
        PoistuiTyyppi:
          begin
            try
              //tarvitaan tunnus joten luodaan paketti, otetaan tunnus ja tuhotaan paketti
              Paketti := TPoistui.Create(XMLPaketti);
              PoistuuPelista((Paketti as TPoistui).Tunnus);
            finally
              FreeAndNil(Paketti);
            end;
          end;
      //poistu pelist tyyppi:
        PeliAlkaaTyyppi:
        //Jos peli ei ole verkossa, niin toimitaan vaikka pelaajaa ei listalla olisikaan.
          if not Verkossa or (EtsiPelaaja(AThread) = 0) then begin
            Alkuaika := Now;
            TeeUusiPelisessionKirjanpito;
            LahetaKaikille(TPeliAlkaa.Create);
            Pelivuorossa := Random(Pelaajia);
            LataaPelilauta(Self);
            LataaKysymyssarjat;
            LahetaKaikille(TKenenVuoro.Create(Pelivuorossa));
            Tila := OdotaHeittoa;
          end;
      end;
    end
    //Odotushuoneen tuolla puolen toimitaan jos ei ole verkkopeli tai jos lhettj
    //on vuorossa TAI jos kyseess on siirron vahvistus.
    else if (not Verkossa or (EtsiPelaaja(AThread) = Pelivuorossa) or (PaketinTyyppi = SiirrettyTyyppi)) then
    begin
      case PaketinTyyppi of
        HeitaTyyppi:
          HeitaNoppaa;
        SiirrettyTyyppi:
          begin
          //jos kaikki on siirtneet
            if (KaikkiSiirtaneet(EtsiPelaaja(AThread))) then
              //jos odotetaan siirtoa (ettei ksitell montaa kertaa)
              if (Tila = OdotaSiirtoa) then KasitteleRuutu;
            //LahetaKaikille(TOdota.Create);
          end;
        VastausTyyppi:
          begin
            Paketti := TVastaus.Create(XMLPaketti);
            KasitteleVastaus(TVastaus(Paketti).Vastaus);
            FreeAndNil(Paketti);
          end;
      end;
    end;
  end;

//  finally
//    Lukko.Release;
//  end;
FreeAndNil(XMLPakettiLista);
end;

//Palauttaa tosi jos kaikki pelaajat ovat siirtneet
function TPelilogiikka.KaikkiSiirtaneet(Siirtaja: Integer): Boolean;
var I: Integer;
begin
  Result := False;
  if (Siirtaja < 0) or (Siirtaja > EhdotonMaksimi-1) then exit;
  Siirretty[Siirtaja] := True; //merkataan siirtjn siirto tehdyksi
  for I := 0 to Pelaajia-1 do
  begin
    //jos jollain on siirto kesken, poistutaan (palautta false)
    if ((Pelissa[I] = True) and (Siirretty[I] = False)) then exit;
  end;
  //kaikki siirtneet, palautetaan true
  Result := True;
end;

//Ksittelee chat viestit. Lis viestiin lhettjn ja lhett sen kaikille
//pelaajille.
procedure TPelilogiikka.KasitteleChat(Paketti: TChatViesti; AThread: TCustomWinSocket);
var I: Integer;
begin
  I := EtsiPelaaja(AThread);
  if (I >= 0) then
  begin
    LahetaKaikille(TChatViestiLahettajalta.Create((PelaajaLista[I] as THahmo).Nimi + ': ' + Paketti.Sisalto, True));
  end;
  FreeAndNil(Paketti);
end;

//Lhett pelin kyttmien tiedostojen nimet asiakkaalle.
procedure TPelilogiikka.LahetaPelinTiedostot(Saie: TCustomWinSocket);
begin
  Laheta(TPelinTiedostot.Create(PelilaudanNimi, KysymyssarjaListaus), Saie);
end;

//Lhett pelin tarkemmat tiedot asiakkaalle
procedure TPelilogiikka.LahetaPelinTarkemmatTiedot(Saie: TCustomWinSocket);
var Pelaajat: TStringList; I: Integer; Tunnukset: TStringList;
begin
  Pelaajat := TStringList.Create;
  Tunnukset := TStringList.Create;
  for I:= 0 to Pelaajia-1 do begin
    Pelaajat.Add((PelaajaLista.Items[I] as THahmo).Nimi);
    Tunnukset.Add((PelaajaLista.Items[I] as THahmo).Tunnus);
  end;
  Laheta(TPelinTarkemmatTiedot.Create(MaxPelaajia, 0, //arvosana sitte ku o hieno laskusysteemihrpkk
    Arvostellaanko, Suojattu, Pelaajat, Tunnukset, PelinNimi), Saie);
  LahetaPelinTiedostot(Saie);
end;

//Lhett pelaajalistan asiakkaalle
procedure TPelilogiikka.LahetaPelaajalista(Saie: TCustomWinSocket);
var I: Integer;
Pelaajat, Tunnukset: TStringList;
begin
  Pelaajat := TStringList.Create;
  Tunnukset := TStringList.Create;
  for I:= 0 to Pelaajia-1 do begin
    Pelaajat.Add((PelaajaLista.Items[I] as THahmo).Nimi);
    Tunnukset.Add((PelaajaLista.Items[I] as THahmo).Tunnus);
  end;
  Laheta(TPelaajalista.Create(Pelaajat, Tunnukset), Saie);
end;

{Katsotaan voiko pelaaja liitty peliin ja lhetetn asianmukainen palaute.
Mikli pelaaja pystyy liitty peliin, listn se omiin tietoihin ja tiedotetaan
kaikille pelaajille (mys vastaliittyneelle)
}
procedure TPelilogiikka.LahetaLiityitPeliin(Saie: TCustomWinSocket; Paketti: TLiityPeliin);
var UusiPelaaja: THahmo;
begin
  try
    if not Verkossa then begin
      OfflineIP := Saie.RemoteHost;
      OfflinePort := Saie.RemotePort;
      Laheta(TLiittyiPeliin.Create('offline', 'offline'));
      exit;
    end;

    if Suojattu then begin
      if not (MD5Match(Paketti.SalasanaMD5, Salasana)) then
      begin
        Laheta(TLiityitPeliin.Create(VaaraSalasanaIlmoitus), Saie);
        exit;
      end
      else if (Pelaajia = MaxPelaajia) then
      begin
        Laheta(TLiityitPeliin.Create(PeliJoTaynnaIlmoitus), Saie);
        exit;
      end;
    end;
    UusiPelaaja := THahmo.Create;
    UusiPelaaja.Nimi := Paketti.PelaajanNimi;
    UusiPelaaja.Tunnus := Paketti.Tunnus;
    UusiPelaaja.IPOsoite := Saie.RemoteHost;
    UusiPelaaja.Portti := Saie.RemotePort;
    LiittyyPeliin(UusiPelaaja);
    Laheta(TLiityitPeliin.Create(HyvaksyttyIlmoitus), Saie);
    LahetaKaikille(TLiittyiPeliin.Create(UusiPelaaja.Nimi, UusiPelaaja.Tunnus));
  finally
    FreeAndNil(Paketti);
  end;
end;



procedure TPelilogiikka.ServeriYhteysAvattu(Sender: TObject; AThread: TCustomWinSocket);
begin
  //Jos joskus tarvitsee
end;

//Asiakas on katkaissut yhteyden. Rinnakkaissuoritussuojattu. Poistaa asiakkaan
//Palvelimen tiedoista. Mikli peli on pttynyt, ei poistumisia ksitell.
procedure TPelilogiikka.ServeriYhteysSuljettu(Sender: TObject; AThread: TCustomWinSocket);
var I:Integer; Poistunut: THahmo;
begin
  Lukko.Acquire;
  if Sammuu then exit;
  if not Verkossa then exit;
  if PoistoKesken then exit;
  PoistoKesken := True;
  I := EtsiPelaaja(AThread);
  if (I >= 0) then begin
    Poistunut := THahmo(PelaajaLista.Items[I]);
    if (Pelissa[I]) then PoistuuPelista(Poistunut.Tunnus);
//    PelaajaLista.Delete(I);  //kyseenalainen
//    if (Poistunut <> Luoja) then
//      Poistunut.Free;
  end;
  PoistoKesken := False;
  Lukko.Release;
end;

//Sulkee palvelimen
procedure TPelilogiikka.SuljeServeri;
begin
  ServerSocketPeli.Active := False;
end;

//Lhett paketin sockettiin
procedure TPelilogiikka.Laheta(Paketti: TPaketti; Asiakas: TCustomWinSocket);
begin
  try
    if not Verkossa and not ((OfflineIP = '') or (OfflinePort = 0)) then Asiakas := EtsiSaie(OfflineIP, OfflinePort);
    Asiakas.SendText(Paketti.PalautaPaketti);
  finally
    Paketti.Free;
  end;
end;

//Lhett paketin vuorossa olevalle pelaajalle. Jos ei olla verkossa, lhetetn
//viesti offline osoitteeseen.
procedure TPelilogiikka.Laheta(Paketti: TPaketti);
begin
  if not Verkossa and not ((OfflineIP = '') or (OfflinePort = 0)) then
  begin
    Laheta(Paketti, EtsiSaie(OfflineIP, OfflinePort));
    exit;
  end;
  Laheta(Paketti, EtsiSaie(PelaajaLista.Items[Pelivuorossa] as THahmo));
end;

//Etsii ja palauttaa sikeen pelaajan perusteella
function TPelilogiikka.EtsiSaie(Pelaaja: THahmo): TCustomWinSocket;
var I: Integer;
begin
  Result := nil;
  for I := 0 to ServerSocketPeli.Socket.ActiveConnections-1 do
  begin
    if ((ServerSocketPeli.Socket.Connections[I].RemoteHost = Pelaaja.IPOsoite) and
      (ServerSocketPeli.Socket.Connections[I].RemotePort = Pelaaja.Portti)) then
      begin
        Result := ServerSocketPeli.Socket.Connections[I];
        exit;
      end;
  end;
end;

//Etsii ja palauttaa sikeen ip-osoitteen ja portin perusteella
function TPelilogiikka.EtsiSaie(IP: String; Port: Integer): TCustomWinSocket;
var I: Integer;
begin
  Result := nil;
  for I := 0 to ServerSocketPeli.Socket.ActiveConnections-1 do
  begin
    if ((ServerSocketPeli.Socket.Connections[I].RemoteHost = OfflineIP) and
      (ServerSocketPeli.Socket.Connections[I].RemotePort = OfflinePort)) then
      begin
        Result := ServerSocketPeli.Socket.Connections[I];
        exit;
      end;
  end;
end;

//Lhett paketin kaikille pelaajille tai offline osoitteeseen, mikli offline peli.
procedure TPelilogiikka.LahetaKaikille(Paketti: TPaketti);
var I: Integer; Pelaaja: THahmo; Saie: TCustomWinSocket;
begin
  if not Verkossa and not ((OfflineIP = '') or (OfflinePort = 0)) then
  begin
    Laheta(Paketti, EtsiSaie(OfflineIP, OfflinePort));
    exit;
  end;
  try
    for I := 0 to PelaajaLista.Count - 1 do
    begin
      if Pelissa[I] then
      begin
        Pelaaja := THahmo(PelaajaLista.Items[I]);
        Saie := EtsiSaie(Pelaaja);
        if (Saie = nil) then continue;
        Saie.SendText(Paketti.PalautaPaketti);
      end;
    end;
  finally
    FreeAndNil(Paketti);
  end;
end;

//Etsii pelaajan socketin (sikeen) perusteella
function TPelilogiikka.EtsiPelaaja(Asiakas: TCustomWinSocket): Integer;
var I: Integer; Saie: TCustomWinSocket;
begin
  Result := -1;
  if not Verkossa then exit;
  if Asiakas = nil then exit;

  for I := 0 to PelaajaLista.Count - 1 do
  begin
    if Pelissa[I] then
    begin
      Saie := EtsiSaie(PelaajaLista.Items[I] as THahmo);
      if Saie = nil then exit;
      if(EtsiSaie(PelaajaLista.Items[I] as THahmo).SocketHandle = Asiakas.SocketHandle) then
      begin
        Result := I;
        Exit;
      end;
    end;
  end;
end;

{
Alustaa pelilogiikan.
Verkossa: Onko kyseess verkkopeli.
KysymyssarjaListaus: Kysymyssarjojen nimet.
Pelilauta: Kytss olevan pelilaudan nimi.
MaxPelaajia: Monenko pelaajan peli on kyseess.
Salasana: Peli suojaava salasana.
Suojattu: Kytetnk salasanaa.
Arvostelu: Arvostellaanko peli sen ptytty. (ei kytss)
Arvosana: Mik on pelin arvosana. (ei kytss)
Luoja: Kuka on luonut pelin.
PelinHakemisto: Mik on pelin juurihakemisto.
PelinNimi: Minkniminen peli on.
}
procedure TPelilogiikka.Alusta(Verkossa: Boolean; KysymyssarjaListaus: TStringList;
  Pelilauta: String; MaxPelaajia: Integer; Salasana: MD5Digest;
  Suojattu: Boolean; Arvostelu: Boolean; Arvosana: Integer; Luoja: THahmo;
  PelinHakemisto, PelinNimi: String);
begin
  Self.Verkossa := Verkossa;
  Self.KysymyssarjaListaus.Free;
  Self.KysymyssarjaListaus := TStringList.Create;
  Self.KysymyssarjaListaus.AddStrings(KysymyssarjaListaus);
  Self.PelilaudanNimi := Pelilauta;
  Self.Pelilauta := Pelilauta;
  Self.MaxPelaajia := MaxPelaajia;
  Self.Suojattu := Suojattu;
  Self.Arvostellaanko := Arvostelu;
  Self.Arvosana := Arvosana;
  Self.Luoja := THahmo.Create;
  if Luoja = nil then
  begin
    Self.Luoja.Nimi := 'Offline';
    Self.Luoja.Tunnus := 'offline';
  end
  else
  begin
    Self.Luoja.Nimi := Luoja.Nimi;
    Self.Luoja.Tunnus := Luoja.Tunnus;
  end;
  Self.PelinHakemisto := PelinHakemisto;
  Self.Salasana := Salasana;
  Self.PelinNimi := PelinNimi;
end;

//Laitetaan rinnakkaissuorituslukko talteen.
procedure TPelilogiikka.AsetaLukko(PaaLukko: TCriticalSection);
begin
  Lukko := PaaLukko;
end;

//Suorittaa nopan heiton, lhett tuloksen asiakkaille ja nollaa siirtotaulukon
//Uusi tila: OdotaSiirtoa
procedure TPelilogiikka.HeitaNoppaa;
var
  Value: Integer;
  I: Integer;
  Siirtyma: Integer;
begin
  Value := Random(NopanSilmaluku) + 1; // satunnaisluku vlilt [1, 6]

  // jos ei ole pelinappuloita joita liikuttaa, lhdetn pois
  if Nappulat.Count <= 0 then exit;

  Siirtyma := 0;
  // liikutetaan nappulaa nopan silmluvun verran
  for I := 1 to Value do begin
    Siirtyma := I;

    // Jos pelaaja on maalissa, ei liikuta turhanpiten
    if TPelinappula(Nappulat.Items[Pelivuorossa]).Maalissa then Break;

    //liikutetaan pelaajaa. Jos ei voi liikuttaa sen jlkeen (pakollinen pyshtyminen)
    //jdn siihen.
    if not LiikutaPelinappulaa(Pelivuorossa) then Break;
  end;
  //lhetetn heiton tulos asianomaisille.
  LahetaKaikille(THeitonTulos.Create(Value, Siirtyma));
  Tila := OdotaSiirtoa;

  //Nollataan siirtotaulukko
  Siirretty[0] := False;
  Siirretty[1] := False;
  Siirretty[2] := False;
  Siirretty[3] := False;


end;

//Liitkuttaa pelinappulan paikalleen
function TPelilogiikka.LiikutaPelinappulaa(PelaajaID: Integer): boolean;
var Pelaaja: TPelinappula;
begin
  Pelaaja := TPelinappula(Nappulat.Items[PelaajaID]); //pelaajan nappula
  result := true;{jos ei kummempia satu (pakollinen pyshtyminen)
                 niin voi jatkaa siirron jlkeen}
  // Jos voidaan viel liikkua eteenpin..
  if Pelaaja.Paikka < Ruudut.Count-1 then begin
    Pelaaja.Paikka := Pelaaja.Paikka + 1;

    //jos oli pakollinen pyshtyminen niin palautetaan eptosi
    if TPelilaudanObjekti(Ruudut.Items[Pelaaja.Paikka]).Pakollinen then result := false;

    // jos pelaaja saapui viimeiseen ruutuun, se pit tutkia erikseen
    if Pelaaja.Paikka = Ruudut.Count-1 then
      Pelaaja.Maalissa := true;
  end
  else begin
    // pelaaja on maalissa
    Pelaaja.Maalissa := true;
    exit;
  end;
end;

//Ksitelln se ruutu miss vuorossaoleva pelaaja on.
//Uusi tila ruudun mukaan. Jos tavallinen ruutu, vuoro vaihtuu
procedure TPelilogiikka.KasitteleRuutu;
var Ruutu: TPelilaudanObjekti; Pelaaja: TPelinappula;
begin
  Pelaaja := TPelinappula(Nappulat.Items[Pelivuorossa]); //pelaajan nappula
  Ruutu := TPelilaudanObjekti(Ruudut.Items[Pelaaja.Paikka]); //ruutu jossa pelaaja on
    // UUSI HEITTO
  if ( Ruutu.Tyyppi = ttUusiHeitto ) then begin
    // Jos on laitettu uuden heiton antava ruutu viimeiseksi eli maaliruuduksi,
    // ei huomioida uuden heiton mahdollisuutta. Tm siksi, koska muuten
    // jtisiin ikuisesti heittmn maalissa noppaa...
    if not Pelaaja.Maalissa then begin
      LahetaKaikille(TTulos.Create(UusiHeittoReaktio));
      Tila := OdotaHeittoa;
      exit; //ei niit muita katota, mennn poies
    end;
  end;

  // KYSYMYS
  if ( Ruutu.Tyyppi = ttKysymys ) then begin
    //arvotaan kysymyssarja ja kysymys sarjasta, joka lhetetn eteenpin.
    if ( Kysymykset.Count > 0 ) then begin
      Sarja := Random(Kysymykset.Count);
      if ( (Kysymykset[Sarja] as TObjectList).Count > 0) then begin
        Kysymys := Random((Kysymykset[Sarja] as TObjectList).Count);
        Laheta(TKysymys.Create(Sarja, Kysymys));
        LahetaKaikille(TOdota.Create);
        Tila := OdotaVastausta;
      end;
    end;
  exit; //ei niit muita katota, mennn poies
  end;
  SeuraavaVuoro;
end;

//Aliohjelma hoitaa vastauksen ksittelyn ja lhett pelaajille tuloksen
procedure TPelilogiikka.KasitteleVastaus(Vastaus: String);
var Oikeellisuus: integer; Kys: TAvoinKysymys;
begin
  Oikeellisuus := Maarittelematon;
  if ( (Kysymykset[Sarja] as TObjectList).Items[Kysymys] is TAvoinKysymys ) then
  begin
    Kys := TAvoinKysymys((Kysymykset[Sarja] as TObjectList).Items[Kysymys]);
    if ( Kys is TMonivalintaKysymys ) then
    begin
      OikeaVastaus := TMonivalintaKysymys(Kys).OikeaVastaus;
      if ( CompareStr(Vastaus, OikeaVastaus + ' (Oikein)') = 0 ) then begin
        LahetaKaikille(TTulos.Create(OikeaTulosReaktio)); //oikein
        Oikeellisuus := Oikein;
      //vuoro ei vaihdu jos pelaaja ei ollut maalissa
        if not TPelinappula(Nappulat.Items[Pelivuorossa]).Maalissa then
        begin
          LisaaVastausPelisessionKirjanpitoon(Pelivuorossa, Sarja, Kysymys, 1 {pisteet},
            Kys.Kysymys, Vastaus, OikeaVastaus, Oikeellisuus);
          exit;
        end;
      end
      else begin
        LahetaKaikille(TTulos.Create(VaaraTulosReaktio)); //vrin
        Oikeellisuus := Vaarin;
      end;
    end;
    if not (Kys is TMonivalintaKysymys) then OikeaVastaus := '';
    LisaaVastausPelisessionKirjanpitoon(Pelivuorossa, Sarja, Kysymys, 1 {pisteet},
      Kys.Kysymys, Vastaus, OikeaVastaus, Oikeellisuus);
  end;
  SeuraavaVuoro;
end;

// Aliohjelma lis yhden opettajan kyttliittymn tarvitseman vastauksen
// ja kysymyksen sisiseen tietorakenteeseen.
procedure TPelilogiikka.LisaaVastausPelisessionKirjanpitoon(
  ID, kyssar, kysnum, pisteet: integer; kys, vas, oik: string; Oikeellisuus: Integer);
var
  Vastaus : TKysymyksenVastaus;
begin
  Vastaus:=TKysymyksenVastaus.Create;
  Vastaus.Kysymys := kys;
  Vastaus.Vastaus := vas;
  Vastaus.OikeaVastaus := oik;
  Vastaus.SarjaNumero := kyssar;
  Vastaus.KysymysNumero := kysnum;
  Vastaus.Pisteet := pisteet;
  if (Oikeellisuus = Oikein) then Vastaus.Oikein := true
  else if (Oikeellisuus = Vaarin) then Vastaus.Oikein := false;
  TPelaajanVastaukset(Vastaukset.Items[ID]).Vastaukset.Add(Vastaus);
end;

//Vaihtaa vuoroon seuraavan pelaajan ja tiedottaa kuka se on kaikille pelaajille.
procedure TPelilogiikka.SeuraavaVuoro();
var JoMaalissa: Integer;
begin
  Tila := OdotaHeittoa;
  JoMaalissa := 0;
  if (Pelivuorossa >= Pelaajia-1) then Pelivuorossa := 0
    else Pelivuorossa := Pelivuorossa + 1;

   // jos pelivuorossa oleva on jo maalissa, siirrytn seuraavaan pelaajaan
  while ((not Pelissa[Pelivuorossa]) or TPelinappula(Nappulat.Items[Pelivuorossa]).Maalissa) do
  begin
    if Pelivuorossa < Nappulat.Count-1 then
      Pelivuorossa := Pelivuorossa + 1
    else
      Pelivuorossa := 0;

    // jos kaikki kyty lpi niin kaikki on silloin maalissa
    if ( JoMaalissa >= Nappulat.Count-1 ) then begin
      PeliLoppui();
      exit;
    end;
    JoMaalissa := JoMaalissa+1;
  end;

{  if not Pelissa[Pelivuorossa] then
  begin
    SeuraavaVuoro;
    exit;
  end; }

  LahetaKaikille(TKenenVuoro.Create(Pelivuorossa));
end;

//Varmistetaan, ett numerosta merkkijonoksi muunnettaessa pituus on vhintn kaksi.
//Eli listn alkuun '0', jos parametrin numeri on alle 10.
//Parametrin annetun arvon ei saa olla negatiivinen.
function TPelilogiikka.PidennaNumero(Pidennettava: Integer): String;
begin
  Result := IntToStr(Pidennettava);
  if Pidennettava < 10 then Result := '0'+Result;
end;

{
Aliohjelma tallentaa pelisession kirjanpidon opettajan kyttliittym
varten. Pelilokit lhetetn metapalvelimelle, mikli kyseess on verkkopeli.
Muussa tapauksessa talletetaan peliloki lokit-kansioon.

Nimemiskytnt:
YYYYMMDDHHMMSS_PelinluojanNimi_PelinNimi.xml
}
procedure TPelilogiikka.TallennaPelisessionKirjanpito();
var
  J, K : Integer;
  Pelaaja : TPelaajanVastaukset;
  Vastaus : TKysymyksenVastaus;
  XMLTulkki: TXMLDocument;
  JuuriNode: IXMLNode;
  PelisessionTiedotNode: IXMLNode;
  ApuNode: IXMLNode;
  AikaNode: IXMLNode;
  KestoNode: IXMLNode;
  KysymyssarjatNode: IXMLNode;
  PelaajatNode: IXMLNode;
  PelaajaNode: IXMLNode;
  PelisessioNode: IXMLNode;
  KysymyksetNode: IXMLNode;
  KysymysNode: IXMLNode;
  Valiaika: Double;
  Tunnit: Integer;
  Minuutit: Integer;
  Sekunnit: Integer;
  XMLPaketti: String;
begin

  Valiaika := HourSpan(Alkuaika, Loppuaika);
  Tunnit := Floor(Valiaika);
  Valiaika := 60*(Valiaika-Floor(Valiaika));
  Minuutit := Floor(Valiaika);
  Sekunnit := Floor(60*(Valiaika-Floor(Valiaika)));


  if (Vastaukset.Count <=0)OR(PelilaudanNimi='') then exit; // ei pelaajia
                                                              // tai lautaa,
                                                              // joten ei
                                                              // tallenneta.

  XMLTulkki := TXMLDocument.Create(Self);
  XMLTulkki.DOMVendor := GetDOMVendor(XMLDokumentinDom);
  XMLTulkki.NodeIndentStr := XMLDokumentinSisennys;
  XMLTulkki.Options := [doNodeAutoCreate, doNodeAutoIndent, doAttrNull, doAutoPrefix, doNamespaceDecl];
  XMLTulkki.Active := True;
  XMLTulkki.Version := XMLDokumentinVersio;
  XMLTulkki.Encoding := XMLDokumentinMerkkienKoodaus;

  JuuriNode := XMLTulkki.AddChild('peliloki');

  ApuNode := JuuriNode.AddChild('tyyppi');
  ApuNode.Text := IntToStr(Integer(LokitiedostoTyyppi));

  PelisessionTiedotNode := JuuriNode.AddChild('pelisession_tiedot');

  AikaNode := PelisessionTiedotNode.AddChild('aika');
  ApuNode := AikaNode.AddChild('paiva');
  ApuNode.Text := PidennaNumero(DayOf(Alkuaika));
  ApuNode := AikaNode.AddChild('kuukausi');
  ApuNode.Text := PidennaNumero(MonthOf(Alkuaika));
  ApuNode := AikaNode.AddChild('vuosi');
  ApuNode.Text := PidennaNumero(YearOf(Alkuaika));
  ApuNode := AikaNode.AddChild('tunti');
  ApuNode.Text := PidennaNumero(HourOf(Alkuaika));
  ApuNode := AikaNode.AddChild('minuutti');
  ApuNode.Text := PidennaNumero(MinuteOf(Alkuaika));
  ApuNode := AikaNode.AddChild('sekuntti');
  ApuNode.Text := PidennaNumero(SecondOf(Alkuaika));

  KestoNode := PelisessionTiedotNode.AddChild('kesto');
  ApuNode := KestoNode.AddChild('tunti');
  ApuNode.Text := PidennaNumero(Tunnit);
  ApuNode := KestoNode.AddChild('minuutti');
  ApuNode.Text := PidennaNumero(Minuutit);
  ApuNode := KestoNode.AddChild('sekuntti');
  ApuNode.Text := PidennaNumero(Sekunnit);

  ApuNode := PelisessionTiedotNode.AddChild('nimi');
  ApuNode.Text := PelinNimi;
  Apunode := PelisessionTiedotNode.AddChild('pelilauta');
  ApuNode.Text := PelilaudanNimi;

  KysymyssarjatNode := PelisessionTiedotNode.AddChild('kysymyssarjat');
  for J := 0 to KysymyssarjaListaus.Count-1 do
  begin
    ApuNode := KysymyssarjatNode.AddChild('kysymyssarja');
    ApuNode.Text := KysymyssarjaListaus[J];
  end;

  PelaajatNode := PelisessionTiedotNode.AddChild('pelaajat');
  for J := 0 to Vastaukset.Count-1 do
  begin
    PelaajaNode := PelaajatNode.AddChild('pelaaja');
    ApuNode := PelaajaNode.AddChild('nimi');
    ApuNode.Text := (Vastaukset[J] as TPelaajanVastaukset).Nimi;
    ApuNode := PelaajaNode.AddChild('tunnus');
    ApuNode.Text := (Vastaukset[J] as TPelaajanVastaukset).Tunnus;
  end;

  PelisessioNode := JuuriNode.AddChild('pelisessio');
  for J := 0 to Vastaukset.Count-1 do
  begin
    PelaajaNode := PelisessioNode.AddChild('pelaaja');
    ApuNode := PelaajaNode.AddChild('tunnus');
    ApuNode.Text := (Vastaukset[J] as TPelaajanVastaukset).Tunnus;
    KysymyksetNode := PelaajaNode.AddChild('kysymykset');
    Pelaaja := TPelaajanVastaukset(Vastaukset[J]);

    for K := 0 to Pelaaja.Vastaukset.Count-1 do
    begin
      KysymysNode := KysymyksetNode.AddChild('kysymys');
      Vastaus := TKysymyksenVastaus(Pelaaja.Vastaukset[K]);
      ApuNode := KysymysNode.AddChild('sarja');
      ApuNode.Text := IntToStr(Vastaus.SarjaNumero);
      ApuNode := KysymysNode.AddChild('numero');
      ApuNode.Text := IntToStr(Vastaus.KysymysNumero);
      ApuNode := KysymysNode.AddChild('kysymysteksti');
      ApuNode.Text := Vastaus.Kysymys;
      ApuNode := KysymysNode.AddChild('vastaus');
      ApuNode.Text := Vastaus.Vastaus;
      ApuNode := KysymysNode.AddChild('oikea');
      ApuNode.Text := Vastaus.OikeaVastaus;
      ApuNode := KysymysNode.AddChild('pisteet');
      ApuNode.Text := IntToStr(Vastaus.Pisteet);
    end;
  end;



//  if not Verkossa then
//  begin
  //kehitetn nimi tiedostolle
  LokinTiedosto := PelinHakemisto+LokiKansio;

  LokinTiedosto := LokinTiedosto+PidennaNumero(YearOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+PidennaNumero(MonthOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+PidennaNumero(DayOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+PidennaNumero(HourOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+PidennaNumero(MinuteOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+PidennaNumero(SecondOf(Alkuaika));
  LokinTiedosto := LokinTiedosto+'_'+Luoja.Nimi+'_'+PelinNimi+'.xml';
  //tallennetaan juuri kehitettyyn tiedostoon
  XMLTulkki.SaveToFile(LokinTiedosto);
{Alunperin lhetti metapalvelimelle verkkopeliss, mutta paketti katkotaan
automaattisesti, mink seurauksena pakettien luku hajoaa. Tmn takia lhetys
on poistettu ja tulee ottaa kyttn vasta kun tiedostopalvelin on
menestyksekksti otettu kyttn. Nyt loki talletetaan aina oman koneen
lokikansioon.}
//  end
//  else
//  begin
//    XMLTulkki.SaveToXML(XMLPaketti); //huom: PelaajaLista[0] on aina pelin luoja.
//    J := Length(XMLPaketti);//test
//    EtsiSaie((PelaajaLista[0] as THahmo)).SendText(XMLPaketti);
//  end;

  XMLTulkki.Active := False;

end;

// Erottaa annetusta tiedostonimest polun, tiedostonimen ja tiedoston ptteen
procedure TPelilogiikka.ErotaPolkuNimiJaPaate(s: String; var Polku, Nimi, Paate: String);
var
  IndexNimi: Integer;
  IndexPaate: Integer;
begin
  IndexNimi := LastDelimiter('/\', s);
  IndexPaate := LastDelimiter('.', s);

  // Jos kyttj ei kirjoita nimelleen ptett, listn
  // se itse. Tm siksi, koska halutaan vltt
  if IndexPaate <= 0 then
    IndexPaate:=Length(s) + 1; // +1 johtunee "pisteest tiedoston ptteess"

  // Otetaan talteen polku ilman tiedoston nime
  Polku := Copy(s, 1, IndexNimi);

  // Otetaan talteen tiedoston nimi polusta
  Nimi := Copy(s, IndexNimi+1, ((Length(s)-IndexNimi) - (Length(s)-IndexPaate+1)));

  // Otetaan talteen tiedoston pte polusta
  Paate := Copy(s, IndexPaate, Length(s)-IndexNimi)
end;

//Peli on pttynyt (joko kaikki maalissa tai peruutettu/lopetettu ennen aikojaan)
//Tekee lokin ja lhett kaikille tiedon pelin pttymisest.
procedure TPelilogiikka.PeliLoppui;
var PelaajienTunnukset: TStringList;
    I: Integer;
begin
  Sammuu := True;
  Loppuaika := Now;
  if OnkoPeliKesken then TallennaPelisessionKirjanpito;
  OnkoPeliKesken:=False;
  PelaajienTunnukset := TStringList.Create;
  if Verkossa then for I := 0 to Pelaajia - 1 do
  begin
    PelaajienTunnukset.Add((PelaajaLista.Items[I] as THahmo).Tunnus);
  end;
  LahetaKaikille(TPeliPaattyi.Create(PelaajienTunnukset));
  SulkuTarkistin.Enabled := True;
end;

//lataa pelin kaikki kysymyssarjat muistiin
procedure TPelilogiikka.LataaKysymyssarjat();
var I: Integer;
begin
  for I:= 0 to KysymyssarjaListaus.Count-1 do begin
    Kysymykset.Add(LataaKysymyssarja(KysymyssarjaListaus[I]));
  end;
end;

//Lataa yhden kysymyssarjan ja palauttaa sen
function TPelilogiikka.LataaKysymyssarja(Sarja: String): TObjectList;
var
  IniFile: TIniFile;
  i,j: Integer;
  KysymysObjekti: String;
  KysymystenLkm: Integer;
  VaariaVastauksia: Integer;
  VaaraVastaus: String;
  Tyyppi: String;
  Tietoteksti: String;
  Kysymys: String;
  OikeaVastaus: String;
  KuvanPolku: String;
  AanenPolku: String;
  VideonPolku: String;
  UusiTietoRuutu: TTietoruutu;
  UusiMonivalintaKysymys: TMonivalintaKysymys;
  UusiAvoinKysymys : TAvoinKysymys;
  VastauskuvienLkm : integer;
  VKPolku : String;
  KysymPolku, KysymNimi, KysymPaate : String;
  TaysiPolku: String; //tarkka polku ja tiedosto kokonaisuudessaan
begin
  //Kysymykset.Clear;
  Result := TObjectList.Create;
  TaysiPolku := PelinHakemisto+KysymyssarjaPolku+Sarja+KysPaate;
  ErotaPolkuNimiJaPaate(TaysiPolku,KysymPolku,KysymNimi,KysymPaate);
  // Aletaan lataamaan varsinaista tekstitietoa ini-tiedostoon
  IniFile := TInifile.Create(TaysiPolku);
  try
    KysymystenLkm := IniFile.ReadInteger('Kysymyksia', 'Lkm', 0);

    for i:=0 to KysymystenLkm-1 do begin
      // Pivitetn kysymyksen ilmaisevaa kohtaa ini-tiedostossa
      KysymysObjekti := 'Kysymys ' + intToStr(i+1);
      Tyyppi := IniFile.ReadString(KysymysObjekti,'Tyyppi','');

      if Tyyppi = 'Tietoruutu' then begin
        Tietoteksti := IniFile.ReadString(KysymysObjekti,'Tietoteksti','');

        // Korvataan |-merkit rivinvaihdolla
        Tietoteksti := StringReplace(TietoTeksti,'|',#13#10,[rfReplaceAll]);

        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysymPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysymPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysymPolku+VideonPolku;


        // Luodaan uusi tietoruutu
        UusiTietoruutu := TTietoruutu.Create;
        UusiTietoruutu.TietoTeksti := Tietoteksti;
        UusiTietoruutu.KuvanPolku := KuvanPolku;
        UusiTietoruutu.AanenPolku := AanenPolku;
        UusiTietoruutu.VideonPolku := VideonPolku;
        Result.Add(UusiTietoruutu);
      end

      else if Tyyppi = 'Monivalinta' then begin
        // Luodaan uusi tietoruutu
        UusiMonivalintaKysymys := TMonivalintaKysymys.Create;

        Kysymys := IniFile.ReadString(KysymysObjekti,'Kysymys','');
        OikeaVastaus := IniFile.ReadString(KysymysObjekti,'Oikea vastaus','');

        UusiMonivalintaKysymys.Kysymys := Kysymys;
        UusiMonivalintaKysymys.OikeaVastaus := OikeaVastaus;

        VaariaVastauksia := IniFile.ReadInteger(KysymysObjekti,'Vrien vastausten lkm',0);

        for j:=0 to VaariaVastauksia-1 do begin
          VaaraVastaus := IniFile.ReadString(KysymysObjekti,'Vr vastaus ' + IntToStr(j+1),'');
          UusiMonivalintaKysymys.VaaratVastaukset.Add(VaaraVastaus);
        end;
        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysymPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysymPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysymPolku+VideonPolku;


        UusiMonivalintaKysymys.KuvanPolku := KuvanPolku;
        UusiMonivalintaKysymys.AanenPolku := AanenPolku;
        UusiMonivalintaKysymys.VideonPolku := VideonPolku;

        VastauskuvienLkm:=IniFile.ReadInteger(KysymysObjekti,'Vastauskuvien lkm',0);
        for j:=0 to VastauskuvienLkm-1 do begin
          VKPolku:=IniFile.ReadString(Kysymysobjekti,'Vastauskuva ' + IntToStr(j+1),'');
          if VKPolku<>'' then VKPolku:=KysymPolku+VKPolku; // Tsskin polku absoluuttiseksi
          UusiMonivalintaKysymys.VastauksenKuvapolku.Add(VKPolku);
        end;

        Result.Add(UusiMonivalintaKysymys);
      end

      else if Tyyppi = 'AvoinKysymys' then begin
        Kysymys := IniFile.ReadString(KysymysObjekti,'Kysymys',''{});

        // Korvataan |-merkit rivinvaihdolla
        Kysymys := StringReplace(Kysymys,'|',#13#10,[rfReplaceAll]);

        KuvanPolku := IniFile.ReadString(KysymysObjekti,'Kuva','');
        AanenPolku := IniFile.ReadString(KysymysObjekti,'ni','');
        VideonPolku := IniFile.ReadString(KysymysObjekti,'Video','');
        // Polut absoluuttisiksi, ett osataan ladata aina oikeasta paikasta
        if KuvanPolku<>'' then KuvanPolku:=KysymPolku+KuvanPolku;
        if AanenPolku<>'' then AanenPolku:=KysymPolku+AanenPolku;
        if VideonPolku<>'' then VideonPolku:=KysymPolku+VideonPolku;


        // Luodaan uusi avoin kysymys
        UusiAvoinKysymys := TAvoinKysymys.Create;
        UusiAvoinKysymys.Kysymys := Kysymys;
        UusiAvoinKysymys.KuvanPolku := KuvanPolku;
        UusiAvoinKysymys.AanenPolku := AanenPolku;
        UusiAvoinKysymys.VideonPolku := VideonPolku;
        Result.Add(UusiAvoinKysymys);
      end;
    end;
  finally
    IniFile.Free;
  end;
end;

procedure TPelilogiikka.LataaPelilauta(Sender: TObject);
var
  IniFile: TIniFile;
  Tyyppi: String;
  i: Integer;
  Objekti: String;
  UusiObjekti: TPelilaudanObjekti;
  ObjektienLkm: Integer;
//  Polku,Nimi,Paate : string;
begin
  // Aluksi tallennetaan vanhan pelisession tiedot opettajan kyttliittym
  // varten.

  if (Pelilauta = '') then exit;

 { // tyhjennetn edellinen pelilauta
  TyhjennaPelilauta(); //Ei tt en, hajottaa kaiken}

  // luodaan ini-tiedosto
  IniFile := TInifile.Create(PelinHakemisto+PelilautaPolku+Pelilauta+PlaPaate);

  // otetaan pelilaudan nimi talteen
//  ErotaPolkuNimiJaPaate(Pelilauta,Polku,Nimi,Paate);
  PelilaudanNimi := Pelilauta;

  try
    // Luetaan objektien lukumr
    ObjektienLkm := IniFile.ReadInteger('Objektit', 'Lkm', 0);

    for i:=0 to ObjektienLkm-1 do begin

      // Pivitetn objekteihin ilmaisevaa kohtaa ini-tiedostossa
      Objekti := 'Objekti ' + intToStr(i+1);

      // Luetaan ini-tiedostosta objektin arvot
      Tyyppi := IniFile.ReadString( Objekti, 'Tyyppi', '' );

      UusiObjekti := TPelilaudanObjekti.Create;

      // Jos objekti on "Uusi heitto"
      if ( Tyyppi = 'UusiHeitto' ) then begin
        UusiObjekti.Tyyppi := ttUusiHeitto;
      end

      // Jos objekti on "Siirtym"
      else if ( Tyyppi = 'Siirtyma' ) then begin
        UusiObjekti.Tyyppi := ttSiirtyma;
      end

      // Jos objekti on "Kysymys"
      else if ( Tyyppi = 'Kysymys' ) then begin
        UusiObjekti.Tyyppi := ttKysymys;
      end;

      // Listn objekti objektilistaan
      Ruudut.Add(UusiObjekti);
    end;
  finally
    IniFile.Free;
  end;

  // jos ei ole pelaajia niin antaa olla...
  if (Pelaajia = 0) then exit;

  // asetaan pelaajat paikoilleen pelin alussa
  for i:=0 to Pelaajia-1 do begin
    AsetaPelaaja(i);
  end;

  // Jos pelilaudalla ei ole ruutuja, niin ei ole mitn mielt alkaa
  // pelaamaankaan
  if Ruudut.Count > 0 then begin
    OnkoPeliLadattu := true;
    OnkoPeliKesken := true;
  end;

  // Pelisessiolle uusi kirjanpito
  TeeUusiPelisessionKirjanpito;
end;

procedure TPelilogiikka.AsetaPelaaja(PelaajaID: Integer);
var
  UusiNappula: TPelinappula;
  PelaajanNimi: String;
begin
  // jos ei ole objekteja joihin voi jotain asettaa, lhdetn pois
  if ( Ruudut.Count <= 0 )or( Pelaajalista.Count <= 0) then exit;

  UusiNappula := TPelinappula.Create;

  // haetaan pelaajan nimi
  PelaajanNimi := THahmo(PelaajaLista[PelaajaID]).Nimi;

  UusiNappula.ID := PelaajaID;
  // pelaaja aloittaa aina ensimmisest ruudusta
  UusiNappula.Paikka := 0;
  // pelaaja ei ole maalissa
  UusiNappula.Maalissa := false;
  // pelaajan nimi
  UusiNappula.Nimi := PelaajanNimi;

  // Listn nappula nappulalistaan
  Nappulat.Add(UusiNappula);
end;

// Aliohjelma opettajan kyttliittymn tarvitsemia vastauksia ja kysymyksi
// varten. Tyhjent vanhan vastauslistan ja tytt sen uudestaan peliin
// osallistuvilla pelaajilla.
procedure TPelilogiikka.TeeUusiPelisessionKirjanpito;
var
  Pelaaja : TPelaajanVastaukset;
  i : integer;
begin
  Vastaukset.Clear;
  for i := 0 to PelaajaLista.Count-1 do begin
    Pelaaja := TPelaajanVastaukset.Create;
    Pelaaja.nimi := THahmo(PelaajaLista.Items[i]).Nimi;
    Pelaaja.tunnus := THahmo(PelaajaLista.Items[i]).Tunnus;
    Vastaukset.Add(Pelaaja);
  end;
end;

//Lis pelaajat, jos kyseess on offline peli
procedure TPelilogiikka.LisaaOfflinePelaajat(Pelaajat: TObjectList);
var I: Integer;
begin
  if PelaajaLista = nil then PelaajaLista.Create;
  for I:= 0 to Pelaajat.Count-1 do
  begin
    LiittyyPeliin(Pelaajat[I] as THahmo);
  end;
end;

//Jos palvelimelle ei ole ketn yhdistettyn, sammutetaan verkkoyhteys
procedure TPelilogiikka.TarkistaSulkeminen(Sender: TObject);
begin
  if (ServerSocketPeli.Socket.ActiveConnections = 0) or (ServerSocketPeli.Active = False) then
  begin
    ServerSocketPeli.Close;
    SulkuTarkistin.Enabled := False;
  end;
end;

//Jos viime pingist on liikaa aikaa, poistetaan pelaaja.
procedure TPelilogiikka.TarkistaPing(Sender: TObject);
var I: Integer; Nyt: TDateTime;
const LiianPitkaAika: Integer = 60*1000;
begin
  Nyt := GetTime;
  for I := 1 to Pelaajia-1 do
  begin
    if Pelissa[I] then
      if (not WithinPastMilliSeconds(Nyt, ViimePing[I], LiianPitkaAika)) then
      begin
        PoistuuPelista((PelaajaLista[I] as THahmo).Tunnus);
        exit;
      end;
  end;
end;

end.
