// Talariuksen pelin pelaamiseen liittyv lomake, joka sislt
// avointen kysymysten esittmisess tarvittavan toiminnallisuuden
// pelitilanteessa.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 16.2.2006
//

unit PelinPelaaminenAvoinKysymysForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MPlayer, Kysymysluokat;

type
  TFormPeliAvoinKysymys = class(TForm)
    ButtonOK: TButton;
    MemoAvoinKysymys: TMemo;
    ImageAvoinKysymys: TImage;
    MediaPlayerAani: TMediaPlayer;
    MediaPlayerVideo: TMediaPlayer;
    EditVastaus: TEdit;
    LabelVastaus: TLabel;
    LabelKysymyksenKuva: TLabel;
    PanelKysKuva: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Sisalto : TAvoinkysymys;
  public
    procedure PuraTiedotLomakkeelle(a : TAvoinkysymys);
    procedure PelaajanVastaus(var kysymys : String; var vastaus : String);
  end;

var
  FormPeliAvoinKysymys: TFormPeliAvoinKysymys;

implementation

{$R *.dfm}
uses MedioidenLataajat;


procedure TFormPeliAvoinKysymys.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

// Palauttaa pelaajan antaman vastauksen oikeasta kentst.
procedure TFormPeliAvoinKysymys.PelaajanVastaus(var kysymys:string; var vastaus:String);
begin
  kysymys:='(A): ' + MemoAvoinKysymys.Text;
  // Korvataan rivinvaihdot tyhjll ja mahdollisesti syntyvt kaksi tyhj
  // yhdell tyhjll (tmn pitisi luultavasti olla opettajan kyttliittym
  // varten tehtvn pelisession tallennuksen yhteydess, mutta on yksittisen
  // tapauksensa vuoksi (tss vaiheessa) laitettu tnne...). Jos ilmenee outoja bugeja
  // myhemmin joidenkin avoimen kysymyksen tekstiin liittyen, lhinn ettei ole
  // rivinvaihtoja, niin siirr tm tallennuksen yhteyteen).
  Kysymys := StringReplace(Kysymys,#13#10,' ',[rfReplaceAll]);
  Kysymys :=  StringReplace(Kysymys,'  ',' ',[rfReplaceAll]);
  vastaus:=EditVastaus.Text;
end;

// Purkaa parametrina saadusta oliosta lomakkeelle sopivat tiedot oikeisiin
// kohtiin. Ja laittaa videon pyrimn ja nen soimaan jos ne lytyvt.
procedure TFormPeliAvoinKysymys.PuraTiedotLomakkeelle(a: TAvoinkysymys);
var
  Kuva : TPicture;
begin
  if a=nil then exit;
  Sisalto:=a;
  Kuva:=ImageAvoinKysymys.Picture;

  MemoAvoinkysymys.Text:=Sisalto.Kysymys;
  if Sisalto.KuvanPolku <> '' then
    LataaKuva(Kuva,Sisalto.KuvanPolku)
  else
    PanelKyskuva.Visible:=true;
  if Sisalto.AanenPolku <> '' then
    LataaMedia(MediaPlayerAani,Sisalto.AanenPolku)
  else MediaPlayerAani.Visible:=False;
  if Sisalto.VideonPolku <> '' then
    LataaMedia(MediaPlayerVideo,Sisalto.VideonPolku)
  else MediaPlayerVideo.Visible:=False;  
end;

procedure TFormPeliAvoinKysymys.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if sisalto=nil then exit;
  // Suljetaan mahdolliset pyrivt mediat
  if Sisalto.AanenPolku <> '' then MediaPlayerAani.Close;
  if Sisalto.VideonPolku <> '' then MediaPlayerVideo.Close;
end;

end.
