// Talariuksen pelin pelaamiseen liittyv lomake, joka sislt
// monivalintakysymysten esittmisess tarvittavan toiminnallisuuden
// pelitilanteessa.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 16.2.2006
//

unit PelinPelaaminenMonivalintakysymysForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MPlayer, Kysymysluokat;

type
  TFormPeliMonivalintakysymys = class(TForm)
    ButtonOK: TButton;
    RadioGroupKysymys: TRadioGroup;
    ImageKuva: TImage;
    MediaPlayerVideo: TMediaPlayer;
    MediaPlayerAani: TMediaPlayer;
    ImageVastaus: TImage;
    LabelKysymyksenKuva: TLabel;
    LabelVastauksenKuva: TLabel;
    PanelKysKuva: TPanel;
    PanelVasKuva: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RadioGroupKysymysClick(Sender: TObject);
  private
    Sisalto : TMonivalintakysymys;
    OikeanVastauksenPaikka : integer;
  public
    procedure PuraTiedotLomakkeelle(m : TMonivalintakysymys);
    procedure PelaajanVastaus(var kysymys:string; var vastaus:string; var oikein:boolean);
  end;

var
  FormPeliMonivalintakysymys: TFormPeliMonivalintakysymys;

implementation

{$R *.dfm}

uses MedioidenLataajat;

procedure TFormPeliMonivalintakysymys.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
  Randomize;
  OikeanVastauksenPaikka:=0;
end;

procedure TFormPeliMonivalintakysymys.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if sisalto=nil then exit;
  // Suljetaan mahdolliset pyrivt mediat
  if Sisalto.AanenPolku <> '' then MediaPlayerAani.Close;
  if Sisalto.VideonPolku <> '' then MediaPlayerVideo.Close;
end;

procedure TFormPeliMonivalintakysymys.PuraTiedotLomakkeelle(m: TMonivalintakysymys);
var
  Kuva : TPicture;
  i, index: integer;
begin
  if m=nil then exit;
  Sisalto:=m;
  Kuva:=ImageKuva.Picture;

  // Kysymys valintalaatikon otsikkoon
  RadioGroupKysymys.Caption := Sisalto.Kysymys;
  // Luodaan vrt vastaukset
  for i:=0 to Sisalto.VaaratVastaukset.Count-1 do begin
    RadioGroupKysymys.Items.Add(Sisalto.VaaratVastaukset[i]);
  end;
  // Oikea vastaus arvalla johonkin vliin
  OikeanVastauksenPaikka := Random(Sisalto.VaaratVastaukset.Count+1);
  RadioGroupKysymys.Items.Insert(OikeanVastauksenPaikka,Sisalto.OikeaVastaus);
  // Valitaan ensimminen vaihtoehdoista
  RadioGroupKysymys.ItemIndex:= 0;

  // Tytetn mahdolliset tyhjt kohdat valinnassa tekstill "Valinta n..."
  for i:=0 to RadioGroupKysymys.Items.Count-1 do begin
    if RadioGroupKysymys.Items[i]='' then
      RadioGroupKysymys.Items[i]:='Valinta ' + intToStr(i+1);
  end;

  // Ladataan tarvittavat mediat
  if Sisalto.KuvanPolku <> '' then
    LataaKuva(Kuva,Sisalto.KuvanPolku)
  else PanelKysKuva.Visible:=true;
  if Sisalto.AanenPolku <> '' then
    LataaMedia(MediaPlayerAani,Sisalto.AanenPolku)
  else MediaPlayerAani.Visible:=False;
  if Sisalto.VideonPolku <> '' then
    LataaMedia(MediaPlayerVideo,Sisalto.VideonPolku)
  else MediaPlayerVideo.Visible:=False;

  // Ladataan vastaukseen mahdollisesti liitetty kuva
  Kuva:=ImageVastaus.Picture;
  index:=RadioGroupKysymys.ItemIndex;
  // Indeksikikkailua, ett ladataan sopiva kuva
  // (Oikean vastauksen kuva indeksiss 0, alkaa indeksist 0)
  if (Index<OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[index+1]<>'') then
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[index+1])
  else if (Index>OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[index]<>'') then
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[index])
  else if (Index=OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[0]<>'') then
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[0]);
 
end;

procedure TFormPeliMonivalintakysymys.RadioGroupKysymysClick(
  Sender: TObject);
var
  Kuva : TPicture;
  index : integer;

begin
  // Ei sislt, joten lhdetn pois...
  if Sisalto=nil then exit;
  // Ladataan vastaukseen mahdollisesti liitetty kuva
  ImageVastaus.Visible:=true;
  PanelVasKuva.Visible:=False;
  Kuva:=ImageVastaus.Picture;
  index:=RadioGroupKysymys.ItemIndex;
  // Indeksikikkailua, ett ladataan sopiva kuva
  // (Oikean vastauksen kuva indeksiss 0)
  if (Index<OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[index+1]<>'') then begin
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[index+1]);
    exit;
  end;
  if (Index>OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[index]<>'') then begin
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[index]);
    exit;
  end;
  if (Index=OikeanVastauksenPaikka)and(Sisalto.VastauksenKuvapolku[0]<>'') then begin
    LataaKuva(Kuva,Sisalto.VastauksenKuvapolku[0]);
    exit;
  end;
  // Kuvaa ei voitu ladata, joten laitetaan vanha kuva piiloon
  ImageVastaus.Visible:=False;
  PanelVasKuva.Visible:=true;
end;

procedure TFormPeliMonivalintakysymys.PelaajanVastaus(var kysymys:string; var vastaus:string; var oikein:boolean);
begin
  kysymys:='(M): ' + RadioGroupKysymys.Caption;
  oikein:=RadioGroupKysymys.ItemIndex=OikeanVastauksenPaikka;
  vastaus:=RadioGroupKysymys.Items[RadioGroupKysymys.itemindex];
  if oikein then vastaus:=vastaus+' (Oikein)'
  else vastaus:=vastaus+' (Vrin)';
end;

end.
