// Talariuksen pelin pelaamiseen liittyv lomake, joka sislt
// tietoruudun esittmisess tarvittavan toiminnallisuuden pelitilanteessa.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 16.2.2006
//


unit PelinPelaaminenTietoruutuForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MPlayer, Kysymysluokat;

type
  TFormPeliTietoruutu = class(TForm)
    ButtonOK: TButton;
    MemoTietoruutu: TMemo;
    ImageKuva: TImage;
    MediaPlayerVideo: TMediaPlayer;
    MediaPlayerAani: TMediaPlayer;
    LabelKysymyksenKuva: TLabel;
    PanelKysKuva: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    Sisalto : TTietoruutu;
  public
    procedure PuraTiedotLomakkeelle(t : TTietoruutu);
  end;

var
  FormPeliTietoruutu: TFormPeliTietoruutu;

implementation

{$R *.dfm}

uses MedioidenLataajat;

procedure TFormPeliTietoruutu.FormCreate(Sender: TObject);
begin
  // Synnytetn formi keskelle ruutua
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

// Purkaa parametrina saadusta oliosta lomakkeelle sopivat tiedot oikeisiin
// kohtiin. Ja laittaa videon pyrimn ja nen soimaan jos ne lytyvt.
procedure TFormPeliTietoruutu.PuraTiedotLomakkeelle(t: TTietoruutu);
var
  Kuva : TPicture;
begin
  if t=nil then exit;
  Sisalto:=t;
  Kuva:=ImageKuva.Picture;

  MemoTietoruutu.Text:=Sisalto.TietoTeksti;
  if Sisalto.KuvanPolku <> '' then
    LataaKuva(Kuva,Sisalto.KuvanPolku)
  else
    PanelKyskuva.Visible:=true;
  if Sisalto.AanenPolku <> '' then
    LataaMedia(MediaPlayerAani,Sisalto.AanenPolku)
  else MediaPlayerAani.Visible:=False;
  if Sisalto.VideonPolku <> '' then
    LataaMedia(MediaPlayerVideo,Sisalto.VideonPolku)
  else MediaPlayerVideo.Visible:=False;
end;

procedure TFormPeliTietoruutu.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if sisalto=nil then exit;
  // Suljetaan pyrivt mahdolliset mediat
  if Sisalto.AanenPolku <> '' then MediaPlayerAani.Close;
  if Sisalto.VideonPolku <> '' then MediaPlayerVideo.Close;
end;

end.
