{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

TFormPelinTarkemmatTiedot on formi jolla nytetn pelin tarkemmat tiedot.
Formilta on mahdollista edet peliin tai palata edelliseen tilaan
(TFormMetaOppilaanLiittyma) Lisksi formilla on kentt mahdollisen salasanan
antamiseen.

Vasemmalla: Pelin yleiset tiedot
Oikealla: Pelattava peli
Alhaalla: liittymisnappi, peruutusnappi ja salasanakentt.
}

unit PelinTarkemmatTiedotForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Contnrs, Objekti, Buttons, Paketit;

type
  TFormPelinTarkemmatTiedot = class(TForm)
    LabelNimi: TLabel;
    LabelLuoja: TLabel;
    GroupBoxPelattavaPeli: TGroupBox;
    LabelPelilauta: TLabel;
    LabelAihealue: TLabel;
    LabelVaikeustaso: TLabel;
    LabelKysymyssarjat: TLabel;
    ListBoxKysymyssarjat: TListBox;
    GroupBoxPelinTiedot: TGroupBox;
    LabelPelaajia: TLabel;
    LabelEnintaan: TLabel;
    Bevel1: TBevel;
    LabelSuojattu: TLabel;
    ListBoxPelaajat: TListBox;
    BitBtnLiity: TBitBtn;
    BitBtnPeruuta: TBitBtn;
    EditSalasana: TEdit;
    procedure EditSalasanaChange(Sender: TObject);
    procedure EditSalasanaEnter(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure EditSalasanaClick(Sender: TObject);
  private
    PelinNimi: String;
    Pelilauta: String;
    Aihealue: String;
    Vaikeustaso: String;
    Kysymyssarjat: TStringList;
    PelinLuoja: String;
    Pelaajia: Integer;
    MaxPelaajia: Integer;
    Suojattu: Boolean; //onko salasana kytss
    PelaajaLista: TObjectList;
    procedure AsetaArvot;
  public
    Salasana: String;
    procedure Alusta(PelinNimi, Aihealue, Vaikeustaso, PelinLuoja, Pelilauta: String;
      Kysymyssarjat: TStringList; PelaajaLista: TObjectList; Pelaajia,
      MaxPelaajia: Integer; Suojattu: Boolean);
  end;


implementation

{$R *.dfm}

{ TFormPelinTarkemmatTiedot }

{
Alustetaan tarkemmat tiedot ikkuna:
PelinNimi: Pelille annettu nimi
Aihealue: Pelin aihealue
Vaikeustaso: Pelin vaikeustaso
PelinLuoja: Pelin luojan nimi
Pelilauta: Peliss kytettv pelilauta (tiedostonnimi ilman ptett ja polkua)
Kysymyssarjat: Peliss kytettvt kysymyssarjat (tiedostonnimet ilman ptett ja polkua)
PelaajaLista: Peliss olevat pelaajat (THahmo)
Pelaajia: Peliss olevien pelaajien mr
MaxPelaajia: Pelaajien maksimimr
Suojattu: Tarvitaanko salasanaa
}
procedure TFormPelinTarkemmatTiedot.Alusta(PelinNimi, Aihealue,
  Vaikeustaso, PelinLuoja, Pelilauta: String; Kysymyssarjat: TStringList;
  PelaajaLista: TObjectList; Pelaajia, MaxPelaajia: Integer; Suojattu: Boolean);
var I: Integer; Hahmo: THahmo;
begin
  Self.PelinLuoja := PelinLuoja;
  Self.PelinNimi := PelinNimi;
  Self.Aihealue := Aihealue;
  Self.Vaikeustaso := Vaikeustaso;
  Self.Pelilauta := Pelilauta;
  Self.Kysymyssarjat.Free;
  Self.Kysymyssarjat := TStringList.Create;
  Self.Kysymyssarjat.AddStrings(Kysymyssarjat);
  Self.Pelaajia := Pelaajia;
  Self.MaxPelaajia := MaxPelaajia;
  Self.Suojattu := Suojattu;
  Self.PelaajaLista.Free;
  Self.PelaajaLista := TObjectList.Create;
  for I := 0 to PelaajaLista.Count-1 do
  begin
    Hahmo := THahmo.Create;
    Hahmo.Nimi := (PelaajaLista.Items[I] as THahmo).Nimi;
    Hahmo.Tunnus := (PelaajaLista.Items[I] as THahmo).Tunnus;
    Self.PelaajaLista.Add(Hahmo);
  end;
  EditSalasana.MaxLength := Paketit.SalasananMaksimipituus;
  AsetaArvot;
end;

//Sijoitetaan alustuksessa saadut arvot nytlle.
procedure TFormPelinTarkemmatTiedot.AsetaArvot;
var I: Integer;
begin
  LabelNimi.Caption := LabelNimi.Caption + PelinNimi;
  LabelLuoja.Caption := LabelLuoja.Caption + PelinLuoja;
  LabelEnintaan.Caption := LabelEnintaan.Caption + IntToStr(MaxPelaajia);
  //Jos suojattu, laitetaan thtimaski ja kirjoitusoikeus,
  if Suojattu then
  begin
    LabelSuojattu.Caption := LabelSuojattu.Caption + 'kyll';
    EditSalasana.Enabled := True;
    EditSalasana.PasswordChar := '*';
    EditSalasana.Text := '';
  end
  else //muuten nytetn < ei salasanaa >
  begin
    LabelSuojattu.Caption := LabelSuojattu.Caption + 'ei';
    EditSalasana.PasswordChar := #0;
    EditSalasana.Enabled := False;
    EditSalasana.Text := '< ei salasanaa >';
  end;
  LabelAihealue.Caption := LabelAihealue.Caption + Aihealue;
  LabelVaikeustaso.Caption := LabelVaikeustaso.Caption + Vaikeustaso;
  LabelPelilauta.Caption := LabelPelilauta.Caption + Pelilauta;
  ListBoxKysymyssarjat.Items.AddStrings(Kysymyssarjat);
  for I := 0 to PelaajaLista.Count-1 do begin
    ListBoxPelaajat.Items.Add((PelaajaLista[I] as THahmo).Nimi);
  end;
end;

//Muutetaan sisist muuttujaa kun salasanaa muutetaan. Tyhjt pois alusta ja lopusta.
procedure TFormPelinTarkemmatTiedot.EditSalasanaChange(Sender: TObject);
begin
  Salasana := Trim(EditSalasana.Text);
end;

//Pitisi valita koko kentt kun kenttn tullaan
procedure TFormPelinTarkemmatTiedot.EditSalasanaEnter(Sender: TObject);
begin
  EditSalasana.SelectAll;
end;

//Keskitetn ikkuna luonnissa
procedure TFormPelinTarkemmatTiedot.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width div 2)-(Self.Width div 2);
  Top := (Screen.Height div 2)-(Self.Height div 2);
end;

//Tapetaan objectlistit mukana
procedure TFormPelinTarkemmatTiedot.FormDestroy(Sender: TObject);
begin
  Kysymyssarjat.Free;
  PelaajaLista.Free;
end;

//Mys klikkauksella pitisi saada valittua koko kentt
procedure TFormPelinTarkemmatTiedot.EditSalasanaClick(Sender: TObject);
begin
  EditSalasanaEnter(Sender);
end;

end.
