// Talariuksen uusien kysymysten luomiseen ja editointiin liittyvt lomake
// tietoruudulle.
//
// Tekijt:
//   Antti Kirjavainen (ajkirjav@iki.fi)
//   Jukka Miettinen (jupemiet@cc.jyu.fi)
//   Heikki Nevala (hemaneva@cc.jyu.fi)
//
// Viimeksi muokattu: 15.2.2006
//

unit TietoruutuForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Kysymysluokat, ExtDlgs;

type
  TFormTietoruutu = class(TForm)
    ButtonOK: TButton;
    ButtonPeruuta: TButton;
    SpeedButtonLisaaVideo: TSpeedButton;
    SpeedButtonLisaaAani: TSpeedButton;
    SpeedButtonLisaaKuva: TSpeedButton;
    MemoTietoteksti: TMemo;
    LabelTietoruutu: TLabel;
    ImageTietoruutukuvaVasen: TImage;
    ImageTietoruutukuvaOikea: TImage;
    SpeedButtonPoistaKuva: TSpeedButton;
    SpeedButtonPoistaAani: TSpeedButton;
    SpeedButtonPoistaVideo: TSpeedButton;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialogVideo: TOpenDialog;
    OpenDialogAani: TOpenDialog;
    PanelOtsikko: TPanel;
    PanelTietoTeksti: TPanel;
    PanelNappulat: TPanel;
    PanelNapitAlusta: TPanel;
    procedure ButtonOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MemoTietotekstiChange(Sender: TObject);
    procedure MemoTietotekstiEnter(Sender: TObject);
    procedure SpeedButtonLisaaKuvaClick(Sender: TObject);
    procedure SpeedButtonPoistaKuvaClick(Sender: TObject);
    procedure SpeedButtonLisaaAaniClick(Sender: TObject);
    procedure SpeedButtonPoistaAaniClick(Sender: TObject);
    procedure SpeedButtonLisaaVideoClick(Sender: TObject);
    procedure SpeedButtonPoistaVideoClick(Sender: TObject);
  private
    FMuokattuSisalto : Boolean;
    FVideonPolku: string;
    FAanenPolku: string;
    FKuvanPolku: string;

  public
    { Public declarations }
  published
    property MuokattuSisalto : Boolean read FMuokattuSisalto write FMuokattuSisalto;
    property KuvanPolku : string read FKuvanPolku write FKuvanPolku;
    property AanenPolku : string read FAanenPolku write FAanenPolku;
    property VideonPolku : string read FVideonPolku write FVideonPolku;
  end;

var
  FormTietoruutu: TFormTietoruutu;

procedure MuokkaaTietoruutu(TietoruutuRakenne:TTietoruutu; OnkoUusiTietoruutu:Boolean; var OnkoMuokattu:Boolean);

implementation

uses KysymystenTekoPaaForm;

{$R *.dfm}

procedure MuokkaaTietoruutu(TietoruutuRakenne:TTietoruutu; OnkoUusiTietoruutu:Boolean; var OnkoMuokattu:Boolean);
var f: TFormTietoruutu;
begin
  // MUISTA alkuun tutkia, onko uusi ruutu vai editoidaanko!!!
  f := TFormTietoruutu.Create(nil);
  f.MuokattuSisalto:=true; // Asetetaan trueksi, jotta uuden saa vain listty OK:lla
  if not OnkoUusiTietoruutu then begin
    f.MuokattuSisalto:=false; // Editoitavaa ei ole heti muokattu...
    // Muokataan lomaketta editointiasuun
    f.MemoTietoteksti.Text := TietoruutuRakenne.TietoTeksti;
    f.Caption:='Tietoruudun muokkaaminen';
    // Sytytetn oikeat napit sen mukaan, onko editoitavaan tietoruutuun
    // liitetty kuvia, ni tai videota
    if ( TietoruutuRakenne.KuvanPolku <> '' ) then begin
      f.SpeedButtonPoistaKuva.Visible:=true;
      f.SpeedButtonLisaaKuva.Visible:=false;
    end;
    if ( TietoruutuRakenne.AanenPolku <> '' ) then begin
      f.SpeedButtonPoistaAani.Visible:=true;
      f.SpeedButtonLisaaAani.Visible:=false;
    end;
    if ( TietoruutuRakenne.VideonPolku <> '' ) then begin
      f.SpeedButtonPoistaVideo.Visible:=true;
      f.SpeedButtonLisaaVideo.Visible:=false;
    end;
    // Puretaan vanhat polkutiedot
    f.KuvanPolku:=TietoruutuRakenne.KuvanPolku;
    f.AanenPolku:=TietoruutuRakenne.AanenPolku;
    f.VideonPolku:=TietoruutuRakenne.VideonPolku;
  end;
  // Jos painetaan Ok-nappia, tehdn tarvittavat toimenpiteet
  if ( f.ShowModal = mrOK ) then begin
    // kopiodaan olioon tiedot lomakkeelta (memosta)
    if TietoruutuRakenne <> nil then begin
      TietoruutuRakenne.TietoTeksti:=f.MemoTietoteksti.Text;
      TietoruutuRakenne.KuvanPolku:=f.KuvanPolku;
      TietoruutuRakenne.AanenPolku:=f.AanenPolku;
      TietoruutuRakenne.VideonPolku:=f.VideonPolku;
    end;  
    // Asetetaan viesti muokatusta tai muokkaamattomasta
    // sisllst KysymystenTekoPaaFormille.
    OnkoMuokattu:=f.MuokattuSisalto;
  end
  // Jos on painettu Cancel-nappia, ilmoitetaan tieto siten
  // ettei muokkausta ole tapahtunut. Tm siksi, ettei
  // KysymystenTekoPaaFormilla aleta kopioimaan tietoja
  // kopio-oliosta oikeaan olioon.
  else OnkoMuokattu:=false;
  f.Free;
end;

procedure TFormTietoruutu.ButtonOKClick(Sender: TObject);
begin
  //FormKysymystenTekeminen.ListBoxKysymyslista.Items.Add(EditTietoruutuTeksti.Text);
end;

procedure TFormTietoruutu.FormCreate(Sender: TObject);
begin
  MuokattuSisalto:=false;
  // Synnytetn formi keskelle ruutua
  Left:=(Screen.Width div 2) - (Width div 2);
  Top:=(Screen.Height div 2) - (Height div 2);
end;

procedure TFormTietoruutu.MemoTietotekstiChange(Sender: TObject);
begin
  // Muokattaessa asetetaan muokkausta kuvaava muuttuja oikeaan arvoonsa
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.MemoTietotekstiEnter(Sender: TObject);
begin
  // Valitaan kaikki olemassaoleva teksti
  MemoTietoteksti.SelectAll;
end;

procedure TFormTietoruutu.SpeedButtonLisaaKuvaClick(Sender: TObject);
begin
  if not OpenPictureDialog.Execute then exit;
  KuvanPolku := OpenPictureDialog.FileName;
  SpeedButtonLisaaKuva.Visible:=false;
  SpeedButtonPoistaKuva.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.SpeedButtonPoistaKuvaClick(Sender: TObject);
begin
  KuvanPolku:='';
  SpeedButtonPoistaKuva.Visible:=false;
  SpeedButtonLisaaKuva.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.SpeedButtonLisaaAaniClick(Sender: TObject);
begin
  if not OpenDialogAani.Execute then exit;
  AanenPolku := OpenDialogAani.FileName;
  SpeedButtonLisaaAani.Visible:=false;
  SpeedButtonPoistaAani.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.SpeedButtonPoistaAaniClick(Sender: TObject);
begin
  AanenPolku:='';
  SpeedButtonPoistaAani.Visible:=false;
  SpeedButtonLisaaAani.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.SpeedButtonLisaaVideoClick(Sender: TObject);
begin
  if not OpenDialogVideo.Execute then exit;
  VideonPolku := OpenDialogVideo.FileName;
  SpeedButtonLisaaVideo.Visible:=false;
  SpeedButtonPoistaVideo.Visible:=true;
  MuokattuSisalto:=true;
end;

procedure TFormTietoruutu.SpeedButtonPoistaVideoClick(Sender: TObject);
begin
  VideonPolku:='';
  SpeedButtonPoistaVideo.Visible:=false;
  SpeedButtonLisaaVideo.Visible:=true;
  MuokattuSisalto:=true;
end;

end.
