{
ALEA PROJEKTI
Joni Kivinen (jomakivi@cc.jyu.fi)
Timo Holopainen (tijuholo@cc.jyu.fi)
Arto Hankaniemi (arkahonk@cc.jyu.fi)
Riku Kuismanen (rtkuisma@cc.jyu.fi)
viimeksi muokattu: 23.5.2006

TFormTilinLuonti kytetn uuden tilin luomiseen metapalvelimelle.
Palaa takaisin TFormKirjautuminen kun valmis.
}
unit TilinLuontiForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ScktComp, Paketit, md5, IlmoitusForm;

type
  TFormTilinLuonti = class(TForm)
    LabeledEditTunnus: TLabeledEdit;
    LabeledEditSalasana: TLabeledEdit;
    BitBtnLuoTili: TBitBtn;
    BitBtnPeruuta: TBitBtn;
    LabeledEditMetaSalasana: TLabeledEdit;
    LabeledEditNimi: TLabeledEdit;
    LabeledEditTarkistus: TLabeledEdit;
    procedure BitBtnLuoTiliClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    ImageSuru: TImage;
    Meta: TCustomWinSocket;
    procedure AnnaPaketti(Socket: TCustomWinSocket);
    procedure Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);


  public
    procedure AsetaMetaSocket(Meta: TCustomWinSocket);
    procedure AsetaSuru(Suru: TImage);
    procedure ClientSocketRead(Sender: TObject;
      Socket: TCustomWinSocket);

    function AnnaSalasana: String;
    function AnnaTunnus: String;
    function AnnaMetaSalasana: String;
    function AnnaNimi: String;
  end;

var
  FormTilinLuonti: TFormTilinLuonti;

implementation

{$R *.dfm}

//palauttaa salasanan
function TFormTilinLuonti.AnnaSalasana: String;
begin
  Result := LabeledEditSalasana.Text;
end;

//palauttaa tunnuksen
function TFormTilinLuonti.AnnaTunnus: String;
begin
  Result := LabeledEditTunnus.Text;
end;

//palauttaa metapalvelimen salasanan
function TFormTilinLuonti.AnnaMetaSalasana: String;
begin
  Result := LabeledEditMetaSalasana.Text;
end;

//palauttaa pelaajan nimen
function TFormTilinLuonti.AnnaNimi: String;
begin
  Result := LabeledEditNimi.Text;
end;

//lhett paketin sockettiin
procedure TFormTilinLuonti.Laheta(Paketti: TPaketti; Socket: TCustomWinSocket);
begin
  Socket.SendText(Paketti.PalautaPaketti);
end;

//passaa socketin lukijalle kun on luettavaa
procedure TFormTilinLuonti.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  AnnaPaketti(Socket);
end;

//lukee socketista paketit, jotka se sittemmin ptkii ja ksittelee.
procedure TFormTilinLuonti.AnnaPaketti(Socket: TCustomWinSocket);
var PaketinTyyppi: Pakettityyppi;
    XMLPaketti: String;
    XMLPakettiLista: TStringList;
    I: Integer;
    VirhePaketti: TVirhePaketti;
begin
  XMLPaketti := Socket.ReceiveText;
  if XMLPaketti = '' then begin
    exit;
  end;

  XMLPakettiLista := PilkoXML(XMLPaketti);

  for I := XMLPakettiLista.Count-1 downto 0 do
  begin
    XMLPaketti := XMLPakettiLista[I];
    PaketinTyyppi := PalautaPaketinTyyppi(XMLPaketti);
    case PaketinTyyppi of
     VirhePakettiTyyppi: //EiVirhettaVirhe, jos tilin luonti onnistui
     begin
     VirhePaketti := TVirhePaketti.Create(XMLPaketti);
       if not (VirhePaketti.Virhe = EiVirhettaVirhe)  then
         begin
           if (VirhePaketti.Virhe = VaaraMetapalvelimenSalasanaVirhe) then NaytaIlmoitus('Virhe!','Palvelimen salasana on vr!',ImageSuru.Picture.Bitmap);
           if (VirhePaketti.Virhe = KayttajatunnusJoKaytossaVirhe) then NaytaIlmoitus('Virhe!','Kyttjtunnus on jo kytss!',ImageSuru.Picture.Bitmap);
         end
       else
       begin
         ModalResult := mrOk; //onnistui, suljetaan ja palautetaan mrOk
       end;
     end;
    end;
  end;
end;

//laitetaan surukuva muistiin
procedure TFormTilinLuonti.AsetaSuru(Suru: TImage);
begin
  ImageSuru := Suru;
end;

//lhett tunnuksen luomispyynnn mikli salasana ja tarkiste on samat, muuten
//tyhjennetn kentt ja nytetn virhilmoitus
procedure TFormTilinLuonti.BitBtnLuoTiliClick(Sender: TObject);
begin
  if LabeledEditSalasana.Text = LabeledEditTarkistus.Text then
    Laheta(TTunnuksenLuominen.Create(AnnaNimi, AnnaTunnus, MD5String(AnnaSalasana), MD5String(AnnaMetaSalasana)), Meta)
  else
  begin
    NaytaIlmoitus('Virhe!', 'Kirjoita salasana uudelleen', ImageSuru.Picture.Bitmap);
    LabeledEditSalasana.Text := '';
    LabeledEditTarkistus.Text := '';
  end;
end;

//ottaa metasocketin talteen
procedure TFormTilinLuonti.AsetaMetaSocket(Meta: TCustomWinSocket);
begin
  Self.Meta := Meta;
end;

//keskitt ikkunan luonnissa
procedure TFormTilinLuonti.FormCreate(Sender: TObject);
begin
  Left := (Screen.Width div 2) - (Width div 2);
  Top := (Screen.Height div 2) - (Height div 2);
end;

end.
